<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="content-type" content="text/html;charset=UTF-8" />
    <meta http-equiv="generator" content="WebSVN 2.0" /> <!-- leave this for stats -->
    <link rel="shortcut icon" type="image/x-icon" href="./templates/calm/images/favicon.ico" />
    <link type="text/css" href="./templates/calm/styles.css" rel="stylesheet" media="screen" />
    <link type="text/css" href="./templates/calm/star-light/star-light.css" rel="stylesheet" media="screen" />
    <!--[if gte IE 5.5000]>
    <script type="text/javascript" src="./templates/calm/png.js"></script>
    <style type="text/css" media="screen">
    tbody tr td { padding:1px 0 }
    #wrap h2 { padding:10px 5px 0 5px; margin-bottom:-8px }
    </style>
    <![endif]-->
    <title>
         MikroKopter - WebSVN
            - FlightCtrl
               - Rev 1226
            - /tags/V0.74d/eeprom.c
    </title>
    <script type="text/javascript">
    //<![CDATA[
         function getPath()
         {
         	return '.';
         }
         
         function checkCB(chBox)
         {
            count = 0
            first = null
            f = chBox.form
            for (i = 0 ; i < f.elements.length ; i++)
            if (f.elements[i].type == 'checkbox' && f.elements[i].checked)
            {
               if (first == null && f.elements[i] != chBox)
                  first = f.elements[i]
               count += 1
            }
            
            if (count > 2) 
            {
               first.checked = false
               count -= 1
            }
         }
    //]]>
    </script>
    <script type="text/javascript" src="./templates/calm/collapse.js"></script>
    </head>
    <body>
    <div id="container">
    <H3>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://www.mikrokopter.de" target="_blank">MikroKopter.de</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://forum.mikrokopter.de" target="_blank">Forum</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
  </H3>
<div id="select"><form action="form.php?path=&amp;" method="post" id="projectform"><div><input type="hidden" name="selectproj" value="1" /><input type="hidden" name="op" value="form" /><input type="hidden" name="sc" value="0" /><select name="repname" onchange="javascript:this.form.submit();"><option value="BL-Ctrl">BL-Ctrl</option><option value="FlightCtrl" selected="selected">FlightCtrl</option><option value="MK3Mag">MK3Mag</option><option value="NaviCtrl">NaviCtrl</option><option value="Projects">Projects</option></select><span class="submit"><input type="submit" value="Go" /></span></div></form></div>
<h1><a href=".?sc=0" title="Project home">Subversion&nbsp;Repositories</a> <span>FlightCtrl</span></h1>
<h2 class="path" style="margin:0 2% 15px 2%;">[<a href="listing.php?repname=FlightCtrl&amp;path=%2F&amp;rev=0&amp;sc=0">/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2F&amp;rev=0&amp;sc=0">tags/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2F&amp;rev=0&amp;sc=0">V0.74d/</a>] [<b>eeprom.c</b>] - Rev 1226</h2>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Feeprom.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Feeprom.c&amp;rev=0&amp;sc=0">Blame</a></span> &#124;
<span class="diff"><a href="log.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Feeprom.c&amp;rev=0&amp;sc=0&amp;isdir=0">View&nbsp;Log</a></span>
</p>
    <div class="listing">
<code><PRE>
</code><code><I><FONT COLOR="#B22222">// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">// + Konstanten 
</code><code></FONT></I><I><FONT COLOR="#B22222">// + 0-250 -&gt; normale Werte
</code><code></FONT></I><I><FONT COLOR="#B22222">// + 251 -&gt; Poti1
</code><code></FONT></I><I><FONT COLOR="#B22222">// + 252 -&gt; Poti2
</code><code></FONT></I><I><FONT COLOR="#B22222">// + 253 -&gt; Poti3
</code><code></FONT></I><I><FONT COLOR="#B22222">// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">DefaultStickMapping</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code> EE_Parameter.Kanalbelegung[K_NICK]  = 1;
</code><code> EE_Parameter.Kanalbelegung[K_ROLL]  = 2;
</code><code> EE_Parameter.Kanalbelegung[K_GAS]   = 3;
</code><code> EE_Parameter.Kanalbelegung[K_GIER]  = 4;
</code><code> EE_Parameter.Kanalbelegung[K_POTI1] = 5;
</code><code> EE_Parameter.Kanalbelegung[K_POTI2] = 6;
</code><code> EE_Parameter.Kanalbelegung[K_POTI3] = 7;
</code><code> EE_Parameter.Kanalbelegung[K_POTI4] = 8;
</code><code>}
</code><code>
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">DefaultKonstanten1</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code> EE_Parameter.GlobalConfig = CFG_ACHSENKOPPLUNG_AKTIV | CFG_KOMPASS_AKTIV | CFG_GPS_AKTIV;<I><FONT COLOR="#B22222">//CFG_HOEHEN_SCHALTER 
</code><code></FONT></I> EE_Parameter.Hoehe_MinGas = 30;
</code><code> EE_Parameter.MaxHoehe     = 251;      <I><FONT COLOR="#B22222">// Wert : 0-250   251 -&gt; Poti1
</code><code></FONT></I> EE_Parameter.Hoehe_P      = 10;       <I><FONT COLOR="#B22222">// Wert : 0-32
</code><code></FONT></I> EE_Parameter.Luftdruck_D  = 30;       <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Hoehe_ACC_Wirkung = 30;  <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Hoehe_Verstaerkung = 4;  <I><FONT COLOR="#B22222">// Wert : 0-50
</code><code></FONT></I> EE_Parameter.Stick_P = 15;            <I><FONT COLOR="#B22222">// Wert : 1-6
</code><code></FONT></I> EE_Parameter.Stick_D = 30;            <I><FONT COLOR="#B22222">// Wert : 0-64
</code><code></FONT></I> EE_Parameter.Gier_P = 12;             <I><FONT COLOR="#B22222">// Wert : 1-20
</code><code></FONT></I> EE_Parameter.Gas_Min = 8;             <I><FONT COLOR="#B22222">// Wert : 0-32
</code><code></FONT></I> EE_Parameter.Gas_Max = 230;           <I><FONT COLOR="#B22222">// Wert : 33-250
</code><code></FONT></I> EE_Parameter.GyroAccFaktor = 30;      <I><FONT COLOR="#B22222">// Wert : 1-64
</code><code></FONT></I> EE_Parameter.KompassWirkung = 128;    <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Gyro_P = 80;             <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Gyro_I = 150;            <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Gyro_D = 3;              <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.UnterspannungsWarnung = 94; <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.NotGas = 35;                <I><FONT COLOR="#B22222">// Wert : 0-250     // Gaswert bei Empangsverlust
</code><code></FONT></I> EE_Parameter.NotGasZeit = 30;            <I><FONT COLOR="#B22222">// Wert : 0-250     // Zeit bis auf NotGas geschaltet wird, wg. Rx-Problemen
</code><code></FONT></I> EE_Parameter.UfoAusrichtung = 0;         <I><FONT COLOR="#B22222">// X oder + Formation
</code><code></FONT></I> EE_Parameter.I_Faktor = 32;
</code><code> EE_Parameter.UserParam1 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam2 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam3 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam4 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam5 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam6 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam7 = 0;             <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam8 = 0;             <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.ServoNickControl = 100;     <I><FONT COLOR="#B22222">// Wert : 0-250     // Stellung des Servos
</code><code></FONT></I> EE_Parameter.ServoNickComp = 40;         <I><FONT COLOR="#B22222">// Wert : 0-250     // Einfluss Gyro/Servo
</code><code></FONT></I> EE_Parameter.ServoNickCompInvert = 0;    <I><FONT COLOR="#B22222">// Wert : 0-250     // Richtung Einfluss Gyro/Servo
</code><code></FONT></I> EE_Parameter.ServoNickMin = 50;          <I><FONT COLOR="#B22222">// Wert : 0-250     // Anschlag
</code><code></FONT></I> EE_Parameter.ServoNickMax = 150;         <I><FONT COLOR="#B22222">// Wert : 0-250     // Anschlag
</code><code></FONT></I> EE_Parameter.ServoNickRefresh = 5;
</code><code> EE_Parameter.LoopGasLimit = 50;
</code><code> EE_Parameter.LoopThreshold = 90;         <I><FONT COLOR="#B22222">// Wert: 0-250  Schwelle fr Stickausschlag
</code><code></FONT></I> EE_Parameter.LoopHysterese = 50;
</code><code> EE_Parameter.BitConfig = 0;             <I><FONT COLOR="#B22222">// Bitcodiert: 0x01=oben, 0x02=unten, 0x04=links, 0x08=rechts / wird getrennt behandelt
</code><code></FONT></I> EE_Parameter.AchsKopplung1 = 90;
</code><code> EE_Parameter.AchsKopplung2 = 67;
</code><code> EE_Parameter.CouplingYawCorrection = 0;
</code><code> EE_Parameter.WinkelUmschlagNick = 85;
</code><code> EE_Parameter.WinkelUmschlagRoll = 85;
</code><code> EE_Parameter.GyroAccAbgleich = 16;        <I><FONT COLOR="#B22222">// 1/k 
</code><code></FONT></I> EE_Parameter.Driftkomp = 32;              
</code><code> EE_Parameter.DynamicStability = 100;
</code><code> EE_Parameter.J16Bitmask = 95; 
</code><code> EE_Parameter.J17Bitmask = 243; 
</code><code> EE_Parameter.J16Timing = 15; 
</code><code> EE_Parameter.J17Timing = 15; 
</code><code> EE_Parameter.NaviGpsModeControl = 253;    
</code><code> EE_Parameter.NaviGpsGain = 100;     
</code><code> EE_Parameter.NaviGpsP = 90;        
</code><code> EE_Parameter.NaviGpsI = 90;        
</code><code> EE_Parameter.NaviGpsD = 90;        
</code><code> EE_Parameter.NaviGpsPLimit = 75;        
</code><code> EE_Parameter.NaviGpsILimit = 75;        
</code><code> EE_Parameter.NaviGpsDLimit = 75;        
</code><code> EE_Parameter.NaviGpsACC = 0;        
</code><code> EE_Parameter.NaviGpsMinSat = 6;        
</code><code> EE_Parameter.NaviStickThreshold = 8;
</code><code> EE_Parameter.NaviWindCorrection = 90;        
</code><code> EE_Parameter.NaviSpeedCompensation = 30;        
</code><code> EE_Parameter.NaviOperatingRadius = 100;        
</code><code> EE_Parameter.NaviAngleLimitation = 100;
</code><code> EE_Parameter.NaviPH_LoginTime = 4;
</code><code> memcpy(EE_Parameter.Name, <B><FONT COLOR="#BC8F8F">&quot;Sport\0&quot;</FONT></B>, 12);   
</code><code>}
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">DefaultKonstanten2</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code> EE_Parameter.GlobalConfig = CFG_ACHSENKOPPLUNG_AKTIV | CFG_KOMPASS_AKTIV | CFG_GPS_AKTIV;<I><FONT COLOR="#B22222">///*CFG_HOEHEN_SCHALTER |*/ CFG_KOMPASS_AKTIV;//0x01;    
</code><code></FONT></I> EE_Parameter.Hoehe_MinGas = 30;
</code><code> EE_Parameter.MaxHoehe     = 251;         <I><FONT COLOR="#B22222">// Wert : 0-250   251 -&gt; Poti1
</code><code></FONT></I> EE_Parameter.Hoehe_P      = 10;          <I><FONT COLOR="#B22222">// Wert : 0-32
</code><code></FONT></I> EE_Parameter.Luftdruck_D  = 30;          <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Hoehe_ACC_Wirkung = 30;     <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Hoehe_Verstaerkung = 3;     <I><FONT COLOR="#B22222">// Wert : 0-50
</code><code></FONT></I> EE_Parameter.Stick_P = 12;               <I><FONT COLOR="#B22222">// Wert : 1-6
</code><code></FONT></I> EE_Parameter.Stick_D = 16;               <I><FONT COLOR="#B22222">// Wert : 0-64
</code><code></FONT></I> EE_Parameter.Gier_P = 6;                 <I><FONT COLOR="#B22222">// Wert : 1-20
</code><code></FONT></I> EE_Parameter.Gas_Min = 8;                <I><FONT COLOR="#B22222">// Wert : 0-32
</code><code></FONT></I> EE_Parameter.Gas_Max = 230;              <I><FONT COLOR="#B22222">// Wert : 33-250
</code><code></FONT></I> EE_Parameter.GyroAccFaktor = 30;         <I><FONT COLOR="#B22222">// Wert : 1-64
</code><code></FONT></I> EE_Parameter.KompassWirkung = 128;       <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Gyro_P = 80;                <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Gyro_I = 120;               <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Gyro_D = 3;                 <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.UnterspannungsWarnung = 94; <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.NotGas = 35;                <I><FONT COLOR="#B22222">// Wert : 0-250     // Gaswert bei Empangsverlust
</code><code></FONT></I> EE_Parameter.NotGasZeit = 30;            <I><FONT COLOR="#B22222">// Wert : 0-250     // Zeit bis auf NotGas geschaltet wird, wg. Rx-Problemen
</code><code></FONT></I> EE_Parameter.UfoAusrichtung = 0;         <I><FONT COLOR="#B22222">// X oder + Formation
</code><code></FONT></I> EE_Parameter.I_Faktor = 32;
</code><code> EE_Parameter.UserParam1 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam2 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam3 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam4 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam5 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam6 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam7 = 0;             <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam8 = 0;             <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.ServoNickControl = 100;     <I><FONT COLOR="#B22222">// Wert : 0-250     // Stellung des Servos
</code><code></FONT></I> EE_Parameter.ServoNickComp = 40;         <I><FONT COLOR="#B22222">// Wert : 0-250     // Einfluss Gyro/Servo
</code><code></FONT></I> EE_Parameter.ServoNickCompInvert = 0;    <I><FONT COLOR="#B22222">// Wert : 0-250     // Richtung Einfluss Gyro/Servo
</code><code></FONT></I> EE_Parameter.ServoNickMin = 50;          <I><FONT COLOR="#B22222">// Wert : 0-250     // Anschlag
</code><code></FONT></I> EE_Parameter.ServoNickMax = 150;         <I><FONT COLOR="#B22222">// Wert : 0-250     // Anschlag
</code><code></FONT></I> EE_Parameter.ServoNickRefresh = 5;
</code><code> EE_Parameter.LoopGasLimit = 50;
</code><code> EE_Parameter.LoopThreshold = 90;         <I><FONT COLOR="#B22222">// Wert: 0-250  Schwelle fr Stickausschlag
</code><code></FONT></I> EE_Parameter.LoopHysterese = 50;
</code><code> EE_Parameter.BitConfig = 0;             <I><FONT COLOR="#B22222">// Bitcodiert: 0x01=oben, 0x02=unten, 0x04=links, 0x08=rechts 
</code><code></FONT></I> EE_Parameter.AchsKopplung1 = 90;
</code><code> EE_Parameter.AchsKopplung2 = 67;
</code><code> EE_Parameter.CouplingYawCorrection = 60;
</code><code> EE_Parameter.WinkelUmschlagNick = 85;
</code><code> EE_Parameter.WinkelUmschlagRoll = 85;
</code><code> EE_Parameter.GyroAccAbgleich = 32;        <I><FONT COLOR="#B22222">// 1/k 
</code><code></FONT></I> EE_Parameter.Driftkomp = 32;              
</code><code> EE_Parameter.DynamicStability = 75;
</code><code> EE_Parameter.J16Bitmask = 95; 
</code><code> EE_Parameter.J17Bitmask = 243; 
</code><code> EE_Parameter.J16Timing = 20; 
</code><code> EE_Parameter.J17Timing = 20; 
</code><code> EE_Parameter.NaviGpsModeControl = 253;    
</code><code> EE_Parameter.NaviGpsGain = 100;     
</code><code> EE_Parameter.NaviGpsP = 90;        
</code><code> EE_Parameter.NaviGpsI = 90;        
</code><code> EE_Parameter.NaviGpsD = 90;        
</code><code> EE_Parameter.NaviGpsPLimit = 75;        
</code><code> EE_Parameter.NaviGpsILimit = 75;        
</code><code> EE_Parameter.NaviGpsDLimit = 75;        
</code><code> EE_Parameter.NaviGpsACC = 0;        
</code><code> EE_Parameter.NaviGpsMinSat = 6;        
</code><code> EE_Parameter.NaviStickThreshold = 8;
</code><code> EE_Parameter.NaviWindCorrection = 90;        
</code><code> EE_Parameter.NaviSpeedCompensation = 30;        
</code><code> EE_Parameter.NaviOperatingRadius = 100;        
</code><code> EE_Parameter.NaviAngleLimitation = 100;
</code><code> EE_Parameter.NaviPH_LoginTime = 4;
</code><code> memcpy(EE_Parameter.Name, <B><FONT COLOR="#BC8F8F">&quot;Normal\0&quot;</FONT></B>, 12);   
</code><code>}
</code><code>
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">DefaultKonstanten3</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code> EE_Parameter.GlobalConfig = CFG_DREHRATEN_BEGRENZER | CFG_ACHSENKOPPLUNG_AKTIV | CFG_KOMPASS_AKTIV | CFG_GPS_AKTIV;<I><FONT COLOR="#B22222">///*CFG_HOEHEN_SCHALTER |*/ CFG_KOMPASS_AKTIV;//0x01;    
</code><code></FONT></I> EE_Parameter.Hoehe_MinGas = 30;
</code><code> EE_Parameter.MaxHoehe     = 251;         <I><FONT COLOR="#B22222">// Wert : 0-250   251 -&gt; Poti1
</code><code></FONT></I> EE_Parameter.Hoehe_P      = 10;          <I><FONT COLOR="#B22222">// Wert : 0-32
</code><code></FONT></I> EE_Parameter.Luftdruck_D  = 30;          <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Hoehe_ACC_Wirkung = 30;     <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Hoehe_Verstaerkung = 3;     <I><FONT COLOR="#B22222">// Wert : 0-50
</code><code></FONT></I> EE_Parameter.Stick_P = 8;                <I><FONT COLOR="#B22222">// Wert : 1-6
</code><code></FONT></I> EE_Parameter.Stick_D = 16;               <I><FONT COLOR="#B22222">// Wert : 0-64
</code><code></FONT></I> EE_Parameter.Gier_P  = 6;                <I><FONT COLOR="#B22222">// Wert : 1-20
</code><code></FONT></I> EE_Parameter.Gas_Min = 8;                <I><FONT COLOR="#B22222">// Wert : 0-32
</code><code></FONT></I> EE_Parameter.Gas_Max = 230;              <I><FONT COLOR="#B22222">// Wert : 33-250
</code><code></FONT></I> EE_Parameter.GyroAccFaktor = 30;         <I><FONT COLOR="#B22222">// Wert : 1-64
</code><code></FONT></I> EE_Parameter.KompassWirkung = 128;       <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Gyro_P = 100;               <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Gyro_I = 120;               <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.Gyro_D = 3;                 <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.UnterspannungsWarnung = 94; <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I> EE_Parameter.NotGas = 35;                <I><FONT COLOR="#B22222">// Wert : 0-250     // Gaswert bei Empangsverlust
</code><code></FONT></I> EE_Parameter.NotGasZeit = 20;            <I><FONT COLOR="#B22222">// Wert : 0-250     // Zeit bis auf NotGas geschaltet wird, wg. Rx-Problemen
</code><code></FONT></I> EE_Parameter.UfoAusrichtung = 0;         <I><FONT COLOR="#B22222">// X oder + Formation
</code><code></FONT></I> EE_Parameter.I_Faktor = 16;
</code><code> EE_Parameter.UserParam1 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam2 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam3 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam4 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam5 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam6 =   0;           <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam7 = 0;             <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.UserParam8 = 0;             <I><FONT COLOR="#B22222">// zur freien Verwendung
</code><code></FONT></I> EE_Parameter.ServoNickControl = 100;     <I><FONT COLOR="#B22222">// Wert : 0-250     // Stellung des Servos
</code><code></FONT></I> EE_Parameter.ServoNickComp = 40;         <I><FONT COLOR="#B22222">// Wert : 0-250     // Einfluss Gyro/Servo
</code><code></FONT></I> EE_Parameter.ServoNickCompInvert = 0;    <I><FONT COLOR="#B22222">// Wert : 0-250     // Richtung Einfluss Gyro/Servo
</code><code></FONT></I> EE_Parameter.ServoNickMin = 50;          <I><FONT COLOR="#B22222">// Wert : 0-250     // Anschlag
</code><code></FONT></I> EE_Parameter.ServoNickMax = 150;         <I><FONT COLOR="#B22222">// Wert : 0-250     // Anschlag
</code><code></FONT></I> EE_Parameter.ServoNickRefresh = 5;
</code><code> EE_Parameter.LoopGasLimit = 50;
</code><code> EE_Parameter.LoopThreshold = 90;         <I><FONT COLOR="#B22222">// Wert: 0-250  Schwelle fr Stickausschlag
</code><code></FONT></I> EE_Parameter.LoopHysterese = 50;
</code><code> EE_Parameter.BitConfig = 0;             <I><FONT COLOR="#B22222">// Bitcodiert: 0x01=oben, 0x02=unten, 0x04=links, 0x08=rechts 
</code><code></FONT></I> EE_Parameter.AchsKopplung1 = 90;
</code><code> EE_Parameter.AchsKopplung2 = 67;
</code><code> EE_Parameter.CouplingYawCorrection = 70;
</code><code> EE_Parameter.WinkelUmschlagNick = 85;
</code><code> EE_Parameter.WinkelUmschlagRoll = 85;
</code><code> EE_Parameter.GyroAccAbgleich = 32;        <I><FONT COLOR="#B22222">// 1/k 
</code><code></FONT></I> EE_Parameter.Driftkomp = 32;              
</code><code> EE_Parameter.DynamicStability = 50;
</code><code> EE_Parameter.J16Bitmask = 95; 
</code><code> EE_Parameter.J17Bitmask = 243; 
</code><code> EE_Parameter.J16Timing = 30; 
</code><code> EE_Parameter.J17Timing = 30; 
</code><code> EE_Parameter.NaviGpsModeControl = 253;    
</code><code> EE_Parameter.NaviGpsGain = 100;     
</code><code> EE_Parameter.NaviGpsP = 90;        
</code><code> EE_Parameter.NaviGpsI = 90;        
</code><code> EE_Parameter.NaviGpsD = 90;        
</code><code> EE_Parameter.NaviGpsPLimit = 75;        
</code><code> EE_Parameter.NaviGpsILimit = 75;        
</code><code> EE_Parameter.NaviGpsDLimit = 75;        
</code><code> EE_Parameter.NaviGpsACC = 0;        
</code><code> EE_Parameter.NaviGpsMinSat = 6;        
</code><code> EE_Parameter.NaviStickThreshold = 8;
</code><code> EE_Parameter.NaviWindCorrection = 90;        
</code><code> EE_Parameter.NaviSpeedCompensation = 30;        
</code><code> EE_Parameter.NaviOperatingRadius = 100;        
</code><code> EE_Parameter.NaviAngleLimitation = 100;
</code><code> EE_Parameter.NaviPH_LoginTime = 4;
</code><code> memcpy(EE_Parameter.Name, <B><FONT COLOR="#BC8F8F">&quot;Beginner\0&quot;</FONT></B>, 12);   
</code><code>}
</code><code></PRE>
</code><code></code>    </div>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Feeprom.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Feeprom.c&amp;rev=0&amp;sc=0">Blame</a></span>
</p>
  </div>
  <div id="footer">
    <p style="padding:0; margin:0"><small>powered by: <a href="http://websvn.tigris.org">WebSVN 2.0</a></small></p>
  </div>
</body>
</html>
