<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="content-type" content="text/html;charset=UTF-8" />
    <meta http-equiv="generator" content="WebSVN 2.0" /> <!-- leave this for stats -->
    <link rel="shortcut icon" type="image/x-icon" href="./templates/calm/images/favicon.ico" />
    <link type="text/css" href="./templates/calm/styles.css" rel="stylesheet" media="screen" />
    <link type="text/css" href="./templates/calm/star-light/star-light.css" rel="stylesheet" media="screen" />
    <!--[if gte IE 5.5000]>
    <script type="text/javascript" src="./templates/calm/png.js"></script>
    <style type="text/css" media="screen">
    tbody tr td { padding:1px 0 }
    #wrap h2 { padding:10px 5px 0 5px; margin-bottom:-8px }
    </style>
    <![endif]-->
    <title>
         MikroKopter - WebSVN
            - FlightCtrl
               - Rev 1226
            - /tags/V0.74d/fc.h
    </title>
    <script type="text/javascript">
    //<![CDATA[
         function getPath()
         {
         	return '.';
         }
         
         function checkCB(chBox)
         {
            count = 0
            first = null
            f = chBox.form
            for (i = 0 ; i < f.elements.length ; i++)
            if (f.elements[i].type == 'checkbox' && f.elements[i].checked)
            {
               if (first == null && f.elements[i] != chBox)
                  first = f.elements[i]
               count += 1
            }
            
            if (count > 2) 
            {
               first.checked = false
               count -= 1
            }
         }
    //]]>
    </script>
    <script type="text/javascript" src="./templates/calm/collapse.js"></script>
    </head>
    <body>
    <div id="container">
    <H3>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://www.mikrokopter.de" target="_blank">MikroKopter.de</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://forum.mikrokopter.de" target="_blank">Forum</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
  </H3>
<div id="select"><form action="form.php?path=&amp;" method="post" id="projectform"><div><input type="hidden" name="selectproj" value="1" /><input type="hidden" name="op" value="form" /><input type="hidden" name="sc" value="0" /><select name="repname" onchange="javascript:this.form.submit();"><option value="BL-Ctrl">BL-Ctrl</option><option value="FlightCtrl" selected="selected">FlightCtrl</option><option value="MK3Mag">MK3Mag</option><option value="NaviCtrl">NaviCtrl</option><option value="Projects">Projects</option></select><span class="submit"><input type="submit" value="Go" /></span></div></form></div>
<h1><a href=".?sc=0" title="Project home">Subversion&nbsp;Repositories</a> <span>FlightCtrl</span></h1>
<h2 class="path" style="margin:0 2% 15px 2%;">[<a href="listing.php?repname=FlightCtrl&amp;path=%2F&amp;rev=0&amp;sc=0">/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2F&amp;rev=0&amp;sc=0">tags/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2F&amp;rev=0&amp;sc=0">V0.74d/</a>] [<b>fc.h</b>] - Rev 1226</h2>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ffc.h&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ffc.h&amp;rev=0&amp;sc=0">Blame</a></span> &#124;
<span class="diff"><a href="log.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ffc.h&amp;rev=0&amp;sc=0&amp;isdir=0">View&nbsp;Log</a></span>
</p>
    <div class="listing">
<code><PRE>
</code><code><I><FONT COLOR="#B22222">/*#######################################################################################
</code><code>Flight Control
</code><code>#######################################################################################*/</FONT></I>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">_FC_H</FONT>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">_FC_H</FONT>
</code><code><I><FONT COLOR="#B22222">//#define GIER_GRAD_FAKTOR 1291L // Abhngigkeit zwischen GyroIntegral und Winkel
</code><code></FONT></I><I><FONT COLOR="#B22222">//#define GIER_GRAD_FAKTOR 1160L 
</code><code></FONT></I><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">long</FONT></B> GIER_GRAD_FAKTOR; <I><FONT COLOR="#B22222">// Abhngigkeit zwischen GyroIntegral und Winkel
</code><code></FONT></I>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">STICK_GAIN</FONT> 4
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">FLAG_MOTOR_RUN</FONT>  1
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">FLAG_FLY</FONT>        2
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">FLAG_CALIBRATE</FONT>  4
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">FLAG_START</FONT>      8
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">MAX_MOTORS</FONT>      12
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <B><FONT COLOR="#0000FF">CHECK_MIN_MAX</FONT></B>(wert,min,max) {if(wert &lt; min) wert = min; else if(wert &gt; max) wert = max;}
</code><code>
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> MikroKopterFlags;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> I2CTimeout;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Sekunde,Minute;
</code><code>
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">long</FONT></B> IntegralNick,IntegralNick2;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">long</FONT></B> IntegralRoll,IntegralRoll2;
</code><code><I><FONT COLOR="#B22222">//extern int IntegralNick,IntegralNick2;
</code><code></FONT></I><I><FONT COLOR="#B22222">//extern int IntegralRoll,IntegralRoll2;
</code><code></FONT></I>
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">long</FONT></B> Mess_IntegralNick,Mess_IntegralNick2;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">long</FONT></B> Mess_IntegralRoll,Mess_IntegralRoll2;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">long</FONT></B> IntegralAccNick,IntegralAccRoll;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">long</FONT></B> Mess_Integral_Hoch;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">long</FONT></B> Integral_Gier,Mess_Integral_Gier,Mess_Integral_Gier2;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  KompassValue;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  KompassStartwert;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  KompassRichtung;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  TrimNick, TrimRoll;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">long</FONT></B>  ErsatzKompass;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>   ErsatzKompassInGrad; <I><FONT COLOR="#B22222">// Kompasswert in Grad
</code><code></FONT></I><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> HoehenWert;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> SollHoehe;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> MesswertNick,MesswertRoll,MesswertGier;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> AdNeutralNick,AdNeutralRoll,AdNeutralGier, Mittelwert_AccNick, Mittelwert_AccRoll;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> NeutralAccX, NeutralAccY,Mittelwert_AccHoch;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> HoehenReglerAktiv;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">float</FONT></B> NeutralAccZ;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">long</FONT></B> Umschlag180Nick, Umschlag180Roll;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> ExternStickNick,ExternStickRoll,ExternStickGier;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_UserParam1,Parameter_UserParam2,Parameter_UserParam3,Parameter_UserParam4,Parameter_UserParam5,Parameter_UserParam6,Parameter_UserParam7,Parameter_UserParam8;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> NaviAccNick,NaviAccRoll,NaviCntAcc;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> modell_fliegt;
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">MotorRegler</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">SendMotorData</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">CalibrierMittelwert</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">Mittelwert</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">SetNeutral</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">Piep</FONT></B>(<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Anzahl);
</code><code>
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> h,m,s;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Timeout ;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> CosinusNickWinkel, CosinusRollWinkel;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  DiffNick,DiffRoll;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  Poti1, Poti2, Poti3, Poti4; 
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> SenderOkay;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> RequiredMotors;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> StickNick,StickRoll,StickGier;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> MotorenEin;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">DefaultKonstanten1</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">DefaultKonstanten2</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">DefaultKonstanten3</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">DefaultStickMapping</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B>  <FONT COLOR="#B8860B">STRUCT_PARAM_LAENGE</FONT>  sizeof(EE_Parameter) 
</code><code><B><FONT COLOR="#228B22">struct</FONT></B> mk_param_struct
</code><code> {
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Kanalbelegung[8];       <I><FONT COLOR="#B22222">// GAS[0], GIER[1],NICK[2], ROLL[3], POTI1, POTI2, POTI3
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> GlobalConfig;           <I><FONT COLOR="#B22222">// 0x01=Hhenregler aktiv,0x02=Kompass aktiv, 0x04=GPS aktiv, 0x08=Heading Hold aktiv
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Hoehe_MinGas;           <I><FONT COLOR="#B22222">// Wert : 0-100
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Luftdruck_D;            <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> MaxHoehe;               <I><FONT COLOR="#B22222">// Wert : 0-32
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Hoehe_P;                <I><FONT COLOR="#B22222">// Wert : 0-32
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Hoehe_Verstaerkung;     <I><FONT COLOR="#B22222">// Wert : 0-50
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Hoehe_ACC_Wirkung;      <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Stick_P;                <I><FONT COLOR="#B22222">// Wert : 1-6
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Stick_D;                <I><FONT COLOR="#B22222">// Wert : 0-64
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Gier_P;                 <I><FONT COLOR="#B22222">// Wert : 1-20
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Gas_Min;                <I><FONT COLOR="#B22222">// Wert : 0-32
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Gas_Max;                <I><FONT COLOR="#B22222">// Wert : 33-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> GyroAccFaktor;          <I><FONT COLOR="#B22222">// Wert : 1-64
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> KompassWirkung;         <I><FONT COLOR="#B22222">// Wert : 0-32
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Gyro_P;                 <I><FONT COLOR="#B22222">// Wert : 10-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Gyro_I;                 <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Gyro_D;                 <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> UnterspannungsWarnung;  <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NotGas;                 <I><FONT COLOR="#B22222">// Wert : 0-250     //Gaswert bei Empngsverlust
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NotGasZeit;             <I><FONT COLOR="#B22222">// Wert : 0-250     // Zeitbis auf NotGas geschaltet wird, wg. Rx-Problemen
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> UfoAusrichtung;         <I><FONT COLOR="#B22222">// X oder + Formation
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> I_Faktor;               <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> UserParam1;             <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> UserParam2;             <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> UserParam3;             <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> UserParam4;             <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> ServoNickControl;       <I><FONT COLOR="#B22222">// Wert : 0-250     // Stellung des Servos
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> ServoNickComp;          <I><FONT COLOR="#B22222">// Wert : 0-250     // Einfluss Gyro/Servo
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> ServoNickMin;           <I><FONT COLOR="#B22222">// Wert : 0-250     // Anschlag
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> ServoNickMax;           <I><FONT COLOR="#B22222">// Wert : 0-250     // Anschlag
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> ServoNickRefresh;       <I><FONT COLOR="#B22222">//
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> LoopGasLimit;           <I><FONT COLOR="#B22222">// Wert: 0-250  max. Gas whrend Looping
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> LoopThreshold;          <I><FONT COLOR="#B22222">// Wert: 0-250  Schwelle fr Stickausschlag
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> LoopHysterese;          <I><FONT COLOR="#B22222">// Wert: 0-250  Hysterese fr Stickausschlag
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> AchsKopplung1;          <I><FONT COLOR="#B22222">// Wert: 0-250  Faktor, mit dem Gier die Achsen Roll und Nick koppelt (NickRollMitkopplung)
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> AchsKopplung2;          <I><FONT COLOR="#B22222">// Wert: 0-250  Faktor, mit dem Nick und Roll verkoppelt werden
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> CouplingYawCorrection;  <I><FONT COLOR="#B22222">// Wert: 0-250  Faktor, mit dem Nick und Roll verkoppelt werden
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> WinkelUmschlagNick;     <I><FONT COLOR="#B22222">// Wert: 0-250  180-Punkt
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> WinkelUmschlagRoll;     <I><FONT COLOR="#B22222">// Wert: 0-250  180-Punkt
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> GyroAccAbgleich;        <I><FONT COLOR="#B22222">// 1/k  (Koppel_ACC_Wirkung)
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Driftkomp;              
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> DynamicStability;
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> UserParam5;             <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> UserParam6;             <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> UserParam7;             <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> UserParam8;             <I><FONT COLOR="#B22222">// Wert : 0-250
</code><code></FONT></I><I><FONT COLOR="#B22222">//---Output ---------------------------------------------
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> J16Bitmask;             <I><FONT COLOR="#B22222">// for the J16 Output
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> J16Timing;              <I><FONT COLOR="#B22222">// for the J16 Output
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> J17Bitmask;             <I><FONT COLOR="#B22222">// for the J17 Output
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> J17Timing;              <I><FONT COLOR="#B22222">// for the J17 Output
</code><code></FONT></I><I><FONT COLOR="#B22222">//---NaviCtrl---------------------------------------------
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviGpsModeControl;     <I><FONT COLOR="#B22222">// Parameters for the Naviboard
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviGpsGain;     
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviGpsP;        
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviGpsI;        
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviGpsD;        
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviGpsPLimit;        
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviGpsILimit;        
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviGpsDLimit;        
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviGpsACC;        
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviGpsMinSat;        
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviStickThreshold;        
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviWindCorrection;        
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviSpeedCompensation;        
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviOperatingRadius;        
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviAngleLimitation;
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NaviPH_LoginTime;
</code><code><I><FONT COLOR="#B22222">//---Ext.Ctrl---------------------------------------------
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> ExternalControl;        <I><FONT COLOR="#B22222">// for serial Control
</code><code></FONT></I><I><FONT COLOR="#B22222">//------------------------------------------------
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> BitConfig;             <I><FONT COLOR="#B22222">// (war Loop-Cfg) Bitcodiert: 0x01=oben, 0x02=unten, 0x04=links, 0x08=rechts / wird getrennt behandelt
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> ServoNickCompInvert;    <I><FONT COLOR="#B22222">// Wert : 0-250   0 oder 1  // WICHTIG!!! am Ende lassen
</code><code></FONT></I>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Reserved[4];
</code><code>   <B><FONT COLOR="#228B22">char</FONT></B> Name[12];
</code><code> }; 
</code><code>
</code><code>
</code><code><B><FONT COLOR="#228B22">struct</FONT></B>
</code><code>  {
</code><code>    <B><FONT COLOR="#228B22">char</FONT></B> Revision;
</code><code>    <B><FONT COLOR="#228B22">char</FONT></B> Name[12];
</code><code>    <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Motor[16][4];
</code><code>  } Mixer;
</code><code>        
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">struct</FONT></B> mk_param_struct EE_Parameter;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_Luftdruck_D;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_MaxHoehe;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_Hoehe_P;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_Hoehe_ACC_Wirkung;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_KompassWirkung;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_Gyro_P;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_Gyro_I;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_Gier_P;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_ServoNickControl;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_AchsKopplung1;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_AchsKopplung2;
</code><code><I><FONT COLOR="#B22222">//extern unsigned char Parameter_AchsGegenKopplung1;
</code><code></FONT></I><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_J16Bitmask;             <I><FONT COLOR="#B22222">// for the J16 Output
</code><code></FONT></I><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_J16Timing;              <I><FONT COLOR="#B22222">// for the J16 Output
</code><code></FONT></I><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_J17Bitmask;             <I><FONT COLOR="#B22222">// for the J17 Output
</code><code></FONT></I><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Parameter_J17Timing;              <I><FONT COLOR="#B22222">// for the J17 Output
</code><code></FONT></I><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> MixerTable[MAX_MOTORS][4]; 
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Motor[MAX_MOTORS];
</code><code>#<B><FONT COLOR="#5F9EA0">endif</FONT></B> //<FONT COLOR="#B8860B">_FC_H</FONT>
</code><code>
</code><code></PRE>
</code><code></code>    </div>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ffc.h&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ffc.h&amp;rev=0&amp;sc=0">Blame</a></span>
</p>
  </div>
  <div id="footer">
    <p style="padding:0; margin:0"><small>powered by: <a href="http://websvn.tigris.org">WebSVN 2.0</a></small></p>
  </div>
</body>
</html>
