<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="content-type" content="text/html;charset=UTF-8" />
    <meta http-equiv="generator" content="WebSVN 2.0" /> <!-- leave this for stats -->
    <link rel="shortcut icon" type="image/x-icon" href="./templates/calm/images/favicon.ico" />
    <link type="text/css" href="./templates/calm/styles.css" rel="stylesheet" media="screen" />
    <link type="text/css" href="./templates/calm/star-light/star-light.css" rel="stylesheet" media="screen" />
    <!--[if gte IE 5.5000]>
    <script type="text/javascript" src="./templates/calm/png.js"></script>
    <style type="text/css" media="screen">
    tbody tr td { padding:1px 0 }
    #wrap h2 { padding:10px 5px 0 5px; margin-bottom:-8px }
    </style>
    <![endif]-->
    <title>
         MikroKopter - WebSVN
            - FlightCtrl
               - Rev 1226
            - /tags/V0.74d/led.c
    </title>
    <script type="text/javascript">
    //<![CDATA[
         function getPath()
         {
         	return '.';
         }
         
         function checkCB(chBox)
         {
            count = 0
            first = null
            f = chBox.form
            for (i = 0 ; i < f.elements.length ; i++)
            if (f.elements[i].type == 'checkbox' && f.elements[i].checked)
            {
               if (first == null && f.elements[i] != chBox)
                  first = f.elements[i]
               count += 1
            }
            
            if (count > 2) 
            {
               first.checked = false
               count -= 1
            }
         }
    //]]>
    </script>
    <script type="text/javascript" src="./templates/calm/collapse.js"></script>
    </head>
    <body>
    <div id="container">
    <H3>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://www.mikrokopter.de" target="_blank">MikroKopter.de</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://forum.mikrokopter.de" target="_blank">Forum</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
  </H3>
<div id="select"><form action="form.php?path=&amp;" method="post" id="projectform"><div><input type="hidden" name="selectproj" value="1" /><input type="hidden" name="op" value="form" /><input type="hidden" name="sc" value="0" /><select name="repname" onchange="javascript:this.form.submit();"><option value="BL-Ctrl">BL-Ctrl</option><option value="FlightCtrl" selected="selected">FlightCtrl</option><option value="MK3Mag">MK3Mag</option><option value="NaviCtrl">NaviCtrl</option><option value="Projects">Projects</option></select><span class="submit"><input type="submit" value="Go" /></span></div></form></div>
<h1><a href=".?sc=0" title="Project home">Subversion&nbsp;Repositories</a> <span>FlightCtrl</span></h1>
<h2 class="path" style="margin:0 2% 15px 2%;">[<a href="listing.php?repname=FlightCtrl&amp;path=%2F&amp;rev=0&amp;sc=0">/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2F&amp;rev=0&amp;sc=0">tags/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2F&amp;rev=0&amp;sc=0">V0.74d/</a>] [<b>led.c</b>] - Rev 1226</h2>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fled.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fled.c&amp;rev=0&amp;sc=0">Blame</a></span> &#124;
<span class="diff"><a href="log.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fled.c&amp;rev=0&amp;sc=0&amp;isdir=0">View&nbsp;Log</a></span>
</p>
    <div class="listing">
<code><PRE>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&lt;inttypes.h&gt;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;main.h&quot;</FONT></B>
</code><code>
</code><code>uint16_t LED1_Timing = 0;
</code><code>uint16_t LED2_Timing = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> J16Blinkcount = 0, J16Mask = 1;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> J17Blinkcount = 0, J17Mask = 1;
</code><code>
</code><code><I><FONT COLOR="#B22222">// initializes the LED control outputs J16, J17
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">LED_Init</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code>    <I><FONT COLOR="#B22222">// set PC2 &amp; PC3 as output (control of J16 &amp; J17)
</code><code></FONT></I>        DDRC |= (1&lt;&lt;DDC2)|(1&lt;&lt;DDC3);
</code><code>        J16_OFF;
</code><code>        J17_OFF;
</code><code>        J16Blinkcount = 0; J16Mask = 128;
</code><code>        J17Blinkcount = 0; J17Mask = 128;
</code><code>}
</code><code>
</code><code>
</code><code><I><FONT COLOR="#B22222">// called in UpdateMotors() every 2ms
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">LED_Update</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code> <B><FONT COLOR="#228B22">static</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> delay = 0;
</code><code> <B><FONT COLOR="#A020F0">if</FONT></B>(!delay--)  <I><FONT COLOR="#B22222">// 10ms Intervall
</code><code></FONT></I>  {
</code><code>  delay = 4; 
</code><code>  <B><FONT COLOR="#A020F0">if</FONT></B>((EE_Parameter.J16Timing &gt; 250) &amp;&amp; (Parameter_J16Timing &gt; 230)) {<B><FONT COLOR="#A020F0">if</FONT></B>(EE_Parameter.J16Bitmask &amp; 128) J16_ON; <B><FONT COLOR="#A020F0">else</FONT></B> J16_OFF;}
</code><code>  <B><FONT COLOR="#A020F0">else</FONT></B> 
</code><code>  <B><FONT COLOR="#A020F0">if</FONT></B>((EE_Parameter.J16Timing &gt; 250) &amp;&amp; (Parameter_J16Timing &lt; 10))  {<B><FONT COLOR="#A020F0">if</FONT></B>(EE_Parameter.J16Bitmask &amp; 128) J16_OFF; <B><FONT COLOR="#A020F0">else</FONT></B> J16_ON;}
</code><code>  <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>  <B><FONT COLOR="#A020F0">if</FONT></B>(!J16Blinkcount--) 
</code><code>   {
</code><code>     J16Blinkcount = Parameter_J16Timing-1;
</code><code>     <B><FONT COLOR="#A020F0">if</FONT></B>(J16Mask == 1) J16Mask = 128; <B><FONT COLOR="#A020F0">else</FONT></B> J16Mask /= 2;
</code><code>     <B><FONT COLOR="#A020F0">if</FONT></B>(J16Mask &amp; EE_Parameter.J16Bitmask) J16_ON; <B><FONT COLOR="#A020F0">else</FONT></B> J16_OFF;
</code><code>   }  
</code><code>  <B><FONT COLOR="#A020F0">if</FONT></B>((EE_Parameter.J17Timing &gt; 250) &amp;&amp; (Parameter_J17Timing &gt; 230)) {<B><FONT COLOR="#A020F0">if</FONT></B>(EE_Parameter.J17Bitmask &amp; 128) J17_ON; <B><FONT COLOR="#A020F0">else</FONT></B> J17_OFF;}
</code><code>  <B><FONT COLOR="#A020F0">else</FONT></B> 
</code><code>  <B><FONT COLOR="#A020F0">if</FONT></B>((EE_Parameter.J17Timing &gt; 250) &amp;&amp; (Parameter_J17Timing &lt; 10))  {<B><FONT COLOR="#A020F0">if</FONT></B>(EE_Parameter.J17Bitmask &amp; 128) J17_OFF; <B><FONT COLOR="#A020F0">else</FONT></B> J17_ON;}
</code><code>  <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>  <B><FONT COLOR="#A020F0">if</FONT></B>(!J17Blinkcount--) 
</code><code>   {
</code><code>     J17Blinkcount = Parameter_J17Timing-1;
</code><code>     <B><FONT COLOR="#A020F0">if</FONT></B>(J17Mask == 1) J17Mask = 128; <B><FONT COLOR="#A020F0">else</FONT></B> J17Mask /= 2;
</code><code>     <B><FONT COLOR="#A020F0">if</FONT></B>(J17Mask &amp; EE_Parameter.J17Bitmask) J17_ON; <B><FONT COLOR="#A020F0">else</FONT></B> J17_OFF;
</code><code>   }  
</code><code>  }
</code><code>}
</code><code></PRE>
</code><code></code>    </div>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fled.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fled.c&amp;rev=0&amp;sc=0">Blame</a></span>
</p>
  </div>
  <div id="footer">
    <p style="padding:0; margin:0"><small>powered by: <a href="http://websvn.tigris.org">WebSVN 2.0</a></small></p>
  </div>
</body>
</html>
