<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="content-type" content="text/html;charset=UTF-8" />
    <meta http-equiv="generator" content="WebSVN 2.0" /> <!-- leave this for stats -->
    <link rel="shortcut icon" type="image/x-icon" href="./templates/calm/images/favicon.ico" />
    <link type="text/css" href="./templates/calm/styles.css" rel="stylesheet" media="screen" />
    <link type="text/css" href="./templates/calm/star-light/star-light.css" rel="stylesheet" media="screen" />
    <!--[if gte IE 5.5000]>
    <script type="text/javascript" src="./templates/calm/png.js"></script>
    <style type="text/css" media="screen">
    tbody tr td { padding:1px 0 }
    #wrap h2 { padding:10px 5px 0 5px; margin-bottom:-8px }
    </style>
    <![endif]-->
    <title>
         MikroKopter - WebSVN
            - FlightCtrl
               - Rev 1226
            - /tags/V0.74d/main.h
    </title>
    <script type="text/javascript">
    //<![CDATA[
         function getPath()
         {
         	return '.';
         }
         
         function checkCB(chBox)
         {
            count = 0
            first = null
            f = chBox.form
            for (i = 0 ; i < f.elements.length ; i++)
            if (f.elements[i].type == 'checkbox' && f.elements[i].checked)
            {
               if (first == null && f.elements[i] != chBox)
                  first = f.elements[i]
               count += 1
            }
            
            if (count > 2) 
            {
               first.checked = false
               count -= 1
            }
         }
    //]]>
    </script>
    <script type="text/javascript" src="./templates/calm/collapse.js"></script>
    </head>
    <body>
    <div id="container">
    <H3>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://www.mikrokopter.de" target="_blank">MikroKopter.de</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://forum.mikrokopter.de" target="_blank">Forum</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
  </H3>
<div id="select"><form action="form.php?path=&amp;" method="post" id="projectform"><div><input type="hidden" name="selectproj" value="1" /><input type="hidden" name="op" value="form" /><input type="hidden" name="sc" value="0" /><select name="repname" onchange="javascript:this.form.submit();"><option value="BL-Ctrl">BL-Ctrl</option><option value="FlightCtrl" selected="selected">FlightCtrl</option><option value="MK3Mag">MK3Mag</option><option value="NaviCtrl">NaviCtrl</option><option value="Projects">Projects</option></select><span class="submit"><input type="submit" value="Go" /></span></div></form></div>
<h1><a href=".?sc=0" title="Project home">Subversion&nbsp;Repositories</a> <span>FlightCtrl</span></h1>
<h2 class="path" style="margin:0 2% 15px 2%;">[<a href="listing.php?repname=FlightCtrl&amp;path=%2F&amp;rev=0&amp;sc=0">/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2F&amp;rev=0&amp;sc=0">tags/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2F&amp;rev=0&amp;sc=0">V0.74d/</a>] [<b>main.h</b>] - Rev 1226</h2>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fmain.h&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fmain.h&amp;rev=0&amp;sc=0">Blame</a></span> &#124;
<span class="diff"><a href="log.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fmain.h&amp;rev=0&amp;sc=0&amp;isdir=0">View&nbsp;Log</a></span>
</p>
    <div class="listing">
<code><PRE>
</code><code>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">_MAIN_H</FONT>
</code><code> #define _MAIN_H
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">QUADRO</FONT>
</code><code><I><FONT COLOR="#B22222">//#define OCTO  // 2 Arms in Front
</code><code></FONT></I><I><FONT COLOR="#B22222">//#define OCTO2 // 1 Arm in front
</code><code></FONT></I><I><FONT COLOR="#B22222">//#define OCTO3 // 1 Arm with two Motors in front or Coax
</code><code></FONT></I>
</code><code><I><FONT COLOR="#B22222">//+++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">//  Quadro:
</code><code></FONT></I><I><FONT COLOR="#B22222">//    1
</code><code></FONT></I><I><FONT COLOR="#B22222">//  4   3
</code><code></FONT></I><I><FONT COLOR="#B22222">//    2
</code><code></FONT></I><I><FONT COLOR="#B22222">//+++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">// Reverse Props on 1 2
</code><code></FONT></I>
</code><code><I><FONT COLOR="#B22222">//+++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">//   Octo:
</code><code></FONT></I><I><FONT COLOR="#B22222">//    1 2
</code><code></FONT></I><I><FONT COLOR="#B22222">//  8     3
</code><code></FONT></I><I><FONT COLOR="#B22222">//  7     4
</code><code></FONT></I><I><FONT COLOR="#B22222">//    6 5
</code><code></FONT></I><I><FONT COLOR="#B22222">//+++++++++++
</code><code></FONT></I>
</code><code><I><FONT COLOR="#B22222">//+++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">//   Octo2:
</code><code></FONT></I><I><FONT COLOR="#B22222">//      1
</code><code></FONT></I><I><FONT COLOR="#B22222">//    8   2
</code><code></FONT></I><I><FONT COLOR="#B22222">//  7       3
</code><code></FONT></I><I><FONT COLOR="#B22222">//    6   4
</code><code></FONT></I><I><FONT COLOR="#B22222">//      5
</code><code></FONT></I><I><FONT COLOR="#B22222">//+++++++++++
</code><code></FONT></I>
</code><code><I><FONT COLOR="#B22222">//+++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">//   Octo3:
</code><code></FONT></I><I><FONT COLOR="#B22222">//      1
</code><code></FONT></I><I><FONT COLOR="#B22222">//      2
</code><code></FONT></I><I><FONT COLOR="#B22222">// 8 7     3 4
</code><code></FONT></I><I><FONT COLOR="#B22222">//      5
</code><code></FONT></I><I><FONT COLOR="#B22222">//      6
</code><code></FONT></I><I><FONT COLOR="#B22222">//+++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">// Reverse Props on octo: 1 3 5 7
</code><code></FONT></I>
</code><code>
</code><code><I><FONT COLOR="#B22222">//Hier die Quarz Frequenz einstellen
</code><code></FONT></I>#<B><FONT COLOR="#5F9EA0">if</FONT></B> <FONT COLOR="#B8860B">defined</FONT> (<FONT COLOR="#B8860B">__AVR_ATmega32__</FONT>)
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SYSCLK</FONT>  20000000L       //Quarz Frequenz in Hz
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">if</FONT></B> <FONT COLOR="#B8860B">defined</FONT> (<FONT COLOR="#B8860B">__AVR_ATmega644__</FONT>)
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SYSCLK</FONT>  20000000L       //Quarz Frequenz in Hz
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">if</FONT></B> <FONT COLOR="#B8860B">defined</FONT> (<FONT COLOR="#B8860B">__AVR_ATmega644P__</FONT>)
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SYSCLK</FONT>  20000000L       //Quarz Frequenz in Hz
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>
</code><code><I><FONT COLOR="#B22222">// neue Hardware
</code><code></FONT></I>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">ROT_OFF</FONT>   {if((PlatinenVersion == 10)||(PlatinenVersion == 20)) PORTB &amp;=~0x01; else  PORTB |= 0x01;}
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">ROT_ON</FONT>    {if((PlatinenVersion == 10)||(PlatinenVersion == 20)) PORTB |= 0x01; else  PORTB &amp;=~0x01;}
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">ROT_FLASH</FONT> PORTB ^= 0x01
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">GRN_OFF</FONT>   {if((PlatinenVersion &lt; 12)) PORTB &amp;=~0x02; else PORTB |= 0x02;}
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">GRN_ON</FONT>    {if((PlatinenVersion &lt; 12)) PORTB |= 0x02; else PORTB &amp;=~0x02;}
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">GRN_FLASH</FONT> PORTB ^= 0x02
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">F_CPU</FONT> SYSCLK
</code><code><I><FONT COLOR="#B22222">//#ifndef F_CPU
</code><code></FONT></I><I><FONT COLOR="#B22222">//#error ################## F_CPU nicht definiert oder ungltig #############
</code><code></FONT></I><I><FONT COLOR="#B22222">//#endif
</code><code></FONT></I><I><FONT COLOR="#B22222">//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">EE_DATENREVISION</FONT> 75 // wird angepasst, wenn sich die EEPROM-Daten gendert haben
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">MIXER_REVISION</FONT>    1 // wird angepasst, wenn sich die Mixer-Daten gendert haben
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">EEPROM_ADR_VALID</FONT>            1
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">EEPROM_ADR_ACTIVE_SET</FONT>       2
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">EEPROM_ADR_LAST_OFFSET</FONT>      3
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">EEPROM_ADR_ACC_NICK</FONT>         4
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">EEPROM_ADR_ACC_ROLL</FONT>         6
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">EEPROM_ADR_ACC_Z</FONT>            8
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">EEPROM_ADR_CHANNELS</FONT>          80
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">EEPROM_ADR_PARAM_LENGTH</FONT>      98
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">EEPROM_ADR_PARAM_BEGIN</FONT>      100
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">EEPROM_ADR_MIXER_TABLE</FONT>     1000 // 1001 - 1100
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_HOEHENREGELUNG</FONT>       0x01
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_HOEHEN_SCHALTER</FONT>      0x02
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_HEADING_HOLD</FONT>         0x04
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_KOMPASS_AKTIV</FONT>        0x08
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_KOMPASS_FIX</FONT>          0x10
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_GPS_AKTIV</FONT>            0x20
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_ACHSENKOPPLUNG_AKTIV</FONT> 0x40
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_DREHRATEN_BEGRENZER</FONT>  0x80
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_LOOP_OBEN</FONT>       0x01
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_LOOP_UNTEN</FONT>      0x02
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_LOOP_LINKS</FONT>      0x04
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_LOOP_RECHTS</FONT>     0x08
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_RES1</FONT>                    0x10
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_RES2</FONT>                    0x20
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_RES3</FONT>                    0x40
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">CFG_RES4</FONT>                    0x80
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">J3High</FONT>    PORTD |= 0x20
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">J3Low</FONT>     PORTD &amp;= ~0x20
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">J4High</FONT>    PORTD |= 0x10
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">J4Low</FONT>     PORTD &amp;= ~0x10
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">J5High</FONT>    PORTD |= 0x08
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">J5Low</FONT>     PORTD &amp;= ~0x08
</code><code>
</code><code>
</code><code><I><FONT COLOR="#B22222">//#define  SYSCLK
</code><code></FONT></I><I><FONT COLOR="#B22222">//extern unsigned long SYSCLK;
</code><code></FONT></I><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> SenderOkay;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> CosinusNickWinkel, CosinusRollWinkel;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> PlatinenVersion;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> SendVersionToNavi;
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">ReadParameterSet</FONT></B> (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> number, <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *buffer, <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> length);
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">WriteParameterSet</FONT></B>(<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> number, <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *buffer, <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> length);
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> <B><FONT COLOR="#0000FF">GetActiveParamSetNumber</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">SetActiveParamSetNumber</FONT></B>(<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> number);
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> EEPromArray[];
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&lt;stdlib.h&gt;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&lt;string.h&gt;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&lt;avr/io.h&gt;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&lt;avr/pgmspace.h&gt;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&lt;avr/interrupt.h&gt;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&lt;avr/eeprom.h&gt;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&lt;avr/boot.h&gt;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&lt;avr/wdt.h&gt;</FONT></B>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;old_macros.h&quot;</FONT></B>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;_Settings.h&quot;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;printf_P.h&quot;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;timer0.h&quot;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;uart.h&quot;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;analog.h&quot;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;twimaster.h&quot;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;menu.h&quot;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;rc.h&quot;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;fc.h&quot;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;gps.h&quot;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;spi.h&quot;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;led.h&quot;</FONT></B>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">EEMEM</FONT>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">EEMEM</FONT> __attribute__ ((section (<B><FONT COLOR="#BC8F8F">&quot;.eeprom&quot;</FONT></B>)))
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">DEBUG_DISPLAY_INTERVALL</FONT>  123 // in ms
</code><code>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <B><FONT COLOR="#0000FF">DELAY_US</FONT></B>(x)     ((unsigned int)( (x) * 1e-6 * F_CPU ))
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">endif</FONT></B> //<FONT COLOR="#B8860B">_MAIN_H</FONT>
</code><code>
</code><code>
</code><code>
</code><code>
</code><code>
</code><code>
</code><code></PRE>
</code><code></code>    </div>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fmain.h&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fmain.h&amp;rev=0&amp;sc=0">Blame</a></span>
</p>
  </div>
  <div id="footer">
    <p style="padding:0; margin:0"><small>powered by: <a href="http://websvn.tigris.org">WebSVN 2.0</a></small></p>
  </div>
</body>
</html>
