<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="content-type" content="text/html;charset=UTF-8" />
    <meta http-equiv="generator" content="WebSVN 2.0" /> <!-- leave this for stats -->
    <link rel="shortcut icon" type="image/x-icon" href="./templates/calm/images/favicon.ico" />
    <link type="text/css" href="./templates/calm/styles.css" rel="stylesheet" media="screen" />
    <link type="text/css" href="./templates/calm/star-light/star-light.css" rel="stylesheet" media="screen" />
    <!--[if gte IE 5.5000]>
    <script type="text/javascript" src="./templates/calm/png.js"></script>
    <style type="text/css" media="screen">
    tbody tr td { padding:1px 0 }
    #wrap h2 { padding:10px 5px 0 5px; margin-bottom:-8px }
    </style>
    <![endif]-->
    <title>
         MikroKopter - WebSVN
            - FlightCtrl
               - Rev 1226
            - /tags/V0.74d/spi.c
    </title>
    <script type="text/javascript">
    //<![CDATA[
         function getPath()
         {
         	return '.';
         }
         
         function checkCB(chBox)
         {
            count = 0
            first = null
            f = chBox.form
            for (i = 0 ; i < f.elements.length ; i++)
            if (f.elements[i].type == 'checkbox' && f.elements[i].checked)
            {
               if (first == null && f.elements[i] != chBox)
                  first = f.elements[i]
               count += 1
            }
            
            if (count > 2) 
            {
               first.checked = false
               count -= 1
            }
         }
    //]]>
    </script>
    <script type="text/javascript" src="./templates/calm/collapse.js"></script>
    </head>
    <body>
    <div id="container">
    <H3>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://www.mikrokopter.de" target="_blank">MikroKopter.de</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://forum.mikrokopter.de" target="_blank">Forum</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
  </H3>
<div id="select"><form action="form.php?path=&amp;" method="post" id="projectform"><div><input type="hidden" name="selectproj" value="1" /><input type="hidden" name="op" value="form" /><input type="hidden" name="sc" value="0" /><select name="repname" onchange="javascript:this.form.submit();"><option value="BL-Ctrl">BL-Ctrl</option><option value="FlightCtrl" selected="selected">FlightCtrl</option><option value="MK3Mag">MK3Mag</option><option value="NaviCtrl">NaviCtrl</option><option value="Projects">Projects</option></select><span class="submit"><input type="submit" value="Go" /></span></div></form></div>
<h1><a href=".?sc=0" title="Project home">Subversion&nbsp;Repositories</a> <span>FlightCtrl</span></h1>
<h2 class="path" style="margin:0 2% 15px 2%;">[<a href="listing.php?repname=FlightCtrl&amp;path=%2F&amp;rev=0&amp;sc=0">/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2F&amp;rev=0&amp;sc=0">tags/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2F&amp;rev=0&amp;sc=0">V0.74d/</a>] [<b>spi.c</b>] - Rev 1226</h2>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fspi.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fspi.c&amp;rev=0&amp;sc=0">Blame</a></span> &#124;
<span class="diff"><a href="log.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fspi.c&amp;rev=0&amp;sc=0&amp;isdir=0">View&nbsp;Log</a></span>
</p>
    <div class="listing">
<code><PRE>
</code><code><I><FONT COLOR="#B22222">// ######################## SPI - FlightCtrl ###################
</code><code></FONT></I>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;main.h&quot;</FONT></B>
</code><code>
</code><code>
</code><code><I><FONT COLOR="#B22222">//struct str_ToNaviCtrl_Version   ToNaviCtrl_Version;
</code><code></FONT></I><I><FONT COLOR="#B22222">//struct str_FromNaviCtrl_Version   FromNaviCtrl_Version;
</code><code></FONT></I><B><FONT COLOR="#228B22">struct</FONT></B> str_ToNaviCtrl   ToNaviCtrl;
</code><code><B><FONT COLOR="#228B22">struct</FONT></B> str_FromNaviCtrl   FromNaviCtrl;
</code><code><B><FONT COLOR="#228B22">struct</FONT></B> str_FromNaviCtrl_Value FromNaviCtrl_Value;
</code><code><B><FONT COLOR="#228B22">struct</FONT></B> str_SPI_VersionInfo SPI_VersionInfo;
</code><code>
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>              SPI_BufferIndex;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>              SPI_RxBufferIndex;
</code><code>
</code><code><B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>     SPI_Buffer[<B><FONT COLOR="#A020F0">sizeof</FONT></B>(FromNaviCtrl)];
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *SPI_TX_Buffer;
</code><code>
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> SPITransferCompleted, SPI_ChkSum;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> SPI_RxDataValid,NaviDataOkay = 0;
</code><code>
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> SPI_CommandSequence[] = { SPI_CMD_USER, SPI_CMD_STICK, SPI_CMD_PARAMETER1, SPI_CMD_STICK, SPI_CMD_MISC, SPI_CMD_VERSION };
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> SPI_CommandCounter = 0;
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">ifdef</FONT></B> <FONT COLOR="#B8860B">USE_SPI_COMMUNICATION</FONT>
</code><code>
</code><code><I><FONT COLOR="#B22222">//------------------------------------------------------
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">SPI_MasterInit</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code>  DDR_SPI |= (1&lt;&lt;DD_MOSI)|(1&lt;&lt;DD_SCK);    <I><FONT COLOR="#B22222">// Set MOSI and SCK output, all others input
</code><code></FONT></I>  SLAVE_SELECT_DDR_PORT |= (1 &lt;&lt; SPI_SLAVE_SELECT);
</code><code>
</code><code>  SPCR = (1&lt;&lt;SPE)|(1&lt;&lt;MSTR)|(1&lt;&lt;SPR1)|(0&lt;&lt;SPR0)|(0&lt;&lt;SPIE);   <I><FONT COLOR="#B22222">// Enable SPI, Master, set clock rate fck/64
</code><code></FONT></I>  SPSR = 0;<I><FONT COLOR="#B22222">//(1&lt;&lt;SPI2X);
</code><code></FONT></I>
</code><code>  SLAVE_SELECT_PORT |=  (1 &lt;&lt; SPI_SLAVE_SELECT);
</code><code>  SPITransferCompleted = 1;
</code><code>
</code><code>  <I><FONT COLOR="#B22222">//SPDR = 0x00;  // dummy write
</code><code></FONT></I>
</code><code>  ToNaviCtrl.Sync1 = 0xAA;
</code><code>  ToNaviCtrl.Sync2 = 0x83;
</code><code>
</code><code>  ToNaviCtrl.Command = SPI_CMD_USER;
</code><code>  ToNaviCtrl.IntegralNick = 0;
</code><code>  ToNaviCtrl.IntegralRoll = 0;
</code><code>  FromNaviCtrl_Value.SerialDataOkay = 0;
</code><code>  SPI_RxDataValid = 0;
</code><code>
</code><code>  SPI_VersionInfo.Major = VERSION_MAJOR;
</code><code>  SPI_VersionInfo.Minor = VERSION_MINOR;
</code><code>  SPI_VersionInfo.Patch = VERSION_PATCH;
</code><code>  SPI_VersionInfo.Compatible = NC_SPI_COMPATIBLE;
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">//------------------------------------------------------
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">SPI_StartTransmitPacket</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code>   <I><FONT COLOR="#B22222">//if ((SLAVE_SELECT_PORT &amp; (1 &lt;&lt; SPI_SLAVE_SELECT)) == 0) return;    // transfer of prev. packet not completed
</code><code></FONT></I>   <B><FONT COLOR="#A020F0">if</FONT></B> (!SPITransferCompleted) <B><FONT COLOR="#A020F0">return</FONT></B>;
</code><code><I><FONT COLOR="#B22222">//   _delay_us(30);
</code><code></FONT></I>
</code><code>   SLAVE_SELECT_PORT &amp;=  ~(1 &lt;&lt; SPI_SLAVE_SELECT);  <I><FONT COLOR="#B22222">// SelectSlave
</code><code></FONT></I>   SPI_TX_Buffer = (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) &amp;ToNaviCtrl;
</code><code>
</code><code>   ToNaviCtrl.Command = SPI_CommandSequence[SPI_CommandCounter++];
</code><code>   <B><FONT COLOR="#A020F0">if</FONT></B> (SPI_CommandCounter &gt;= <B><FONT COLOR="#A020F0">sizeof</FONT></B>(SPI_CommandSequence)) SPI_CommandCounter = 0;
</code><code>
</code><code>   SPITransferCompleted = 0;
</code><code>   UpdateSPI_Buffer();                              <I><FONT COLOR="#B22222">// update buffer
</code><code></FONT></I>
</code><code>   SPI_BufferIndex = 1;
</code><code>  <I><FONT COLOR="#B22222">//ebugOut.Analog[16]++;
</code><code></FONT></I>   <I><FONT COLOR="#B22222">// -- Debug-Output ---
</code><code></FONT></I>   <I><FONT COLOR="#B22222">//----
</code><code></FONT></I>   asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>);         asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>);
</code><code>   asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>);         asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>);
</code><code>   asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>);         asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>);
</code><code>   ToNaviCtrl.Chksum = ToNaviCtrl.Sync1;
</code><code>   SPDR = ToNaviCtrl.Sync1;                  <I><FONT COLOR="#B22222">// Start transmission
</code><code></FONT></I><I><FONT COLOR="#B22222">//     SLAVE_SELECT_PORT |=  (1 &lt;&lt; SPI_SLAVE_SELECT);   // DeselectSlave
</code><code></FONT></I>
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">//------------------------------------------------------
</code><code></FONT></I><I><FONT COLOR="#B22222">//SIGNAL(SIG_SPI)
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">SPI_TransmitByte</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code>   <B><FONT COLOR="#228B22">static</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> SPI_RXState = 0;
</code><code>   <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> rxdata;
</code><code>   <B><FONT COLOR="#228B22">static</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> rxchksum;
</code><code>
</code><code>   <B><FONT COLOR="#A020F0">if</FONT></B> (SPITransferCompleted) <B><FONT COLOR="#A020F0">return</FONT></B>;
</code><code>   <B><FONT COLOR="#A020F0">if</FONT></B> (!(SPSR &amp; (1 &lt;&lt; SPIF))) <B><FONT COLOR="#A020F0">return</FONT></B>;
</code><code>  SendSPI = 4;
</code><code>
</code><code><I><FONT COLOR="#B22222">//   _delay_us(30);
</code><code></FONT></I>  SLAVE_SELECT_PORT |=  (1 &lt;&lt; SPI_SLAVE_SELECT);   <I><FONT COLOR="#B22222">// DeselectSlave
</code><code></FONT></I>
</code><code>  rxdata = SPDR;
</code><code>  <B><FONT COLOR="#A020F0">switch</FONT></B> ( SPI_RXState)
</code><code>  {
</code><code>  <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">0</FONT></B>:
</code><code>
</code><code>                        SPI_RxBufferIndex = 0;
</code><code>                        <I><FONT COLOR="#B22222">//DebugOut.Analog[17]++;
</code><code></FONT></I>                        rxchksum = rxdata;
</code><code>                        <B><FONT COLOR="#A020F0">if</FONT></B> (rxdata == 0x81 )  { SPI_RXState  = 1;  }   <I><FONT COLOR="#B22222">// 1. Syncbyte ok
</code><code></FONT></I>
</code><code>           <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>   <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">1</FONT></B>:
</code><code>                    <B><FONT COLOR="#A020F0">if</FONT></B> (rxdata == 0x55) { rxchksum += rxdata; SPI_RXState  = 2;  }   <I><FONT COLOR="#B22222">// 2. Syncbyte ok
</code><code></FONT></I>                 <B><FONT COLOR="#A020F0">else</FONT></B> SPI_RXState  = 0;
</code><code>                        <I><FONT COLOR="#B22222">//DebugOut.Analog[18]++;
</code><code></FONT></I>           <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>   <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">2</FONT></B>:
</code><code>                   SPI_Buffer[SPI_RxBufferIndex++]= rxdata;             <I><FONT COLOR="#B22222">// get data
</code><code></FONT></I>           <I><FONT COLOR="#B22222">//DebugOut.Analog[19]++;
</code><code></FONT></I>           <B><FONT COLOR="#A020F0">if</FONT></B> (SPI_RxBufferIndex &gt;= <B><FONT COLOR="#A020F0">sizeof</FONT></B>(FromNaviCtrl))
</code><code>                   {
</code><code>
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B> (rxdata == rxchksum)
</code><code>                        {
</code><code>                  <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *ptr = (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)&amp;FromNaviCtrl;
</code><code>
</code><code>                          memcpy(ptr, (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) SPI_Buffer,  <B><FONT COLOR="#A020F0">sizeof</FONT></B>(SPI_Buffer));
</code><code>
</code><code>                          SPI_RxDataValid = 1;
</code><code>                        }
</code><code>                        <B><FONT COLOR="#A020F0">else</FONT></B> SPI_RxDataValid = 0;
</code><code>
</code><code>                        SPI_RXState  = 0;
</code><code>                   }
</code><code>                  <B><FONT COLOR="#A020F0">else</FONT></B> rxchksum += rxdata;
</code><code>        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>  }
</code><code>
</code><code>   <B><FONT COLOR="#A020F0">if</FONT></B> (SPI_BufferIndex &lt; <B><FONT COLOR="#A020F0">sizeof</FONT></B>(ToNaviCtrl))
</code><code>     {
</code><code>           SLAVE_SELECT_PORT &amp;=  ~(1 &lt;&lt; SPI_SLAVE_SELECT);  <I><FONT COLOR="#B22222">// SelectSlave
</code><code></FONT></I>           asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>);         asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>);
</code><code>           asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>);         asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>);
</code><code>           asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>);         asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>); asm <B><FONT COLOR="#228B22">volatile</FONT></B> (<B><FONT COLOR="#BC8F8F">&quot;nop&quot;</FONT></B>);
</code><code>
</code><code>           SPDR = SPI_TX_Buffer[SPI_BufferIndex];
</code><code>           ToNaviCtrl.Chksum += SPI_TX_Buffer[SPI_BufferIndex];
</code><code>        <I><FONT COLOR="#B22222">//   SLAVE_SELECT_PORT |=  (1 &lt;&lt; SPI_SLAVE_SELECT);   // DeselectSlave
</code><code></FONT></I>
</code><code>         }
</code><code>         <B><FONT COLOR="#A020F0">else</FONT></B> SPITransferCompleted = 1;
</code><code>
</code><code>         SPI_BufferIndex++;
</code><code>}
</code><code>
</code><code>
</code><code><I><FONT COLOR="#B22222">//------------------------------------------------------
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">UpdateSPI_Buffer</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code>  <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> tmp;
</code><code>  cli();
</code><code>
</code><code>  ToNaviCtrl.IntegralNick = (<B><FONT COLOR="#228B22">int</FONT></B>) (IntegralNick / (<B><FONT COLOR="#228B22">long</FONT></B>)(EE_Parameter.GyroAccFaktor * 4));
</code><code>  ToNaviCtrl.IntegralRoll = (<B><FONT COLOR="#228B22">int</FONT></B>) (IntegralRoll / (<B><FONT COLOR="#228B22">long</FONT></B>)(EE_Parameter.GyroAccFaktor * 4));
</code><code>  ToNaviCtrl.GyroCompass = (10 * ErsatzKompass) / GIER_GRAD_FAKTOR;
</code><code>  ToNaviCtrl.AccNick = ((<B><FONT COLOR="#228B22">int</FONT></B>) ACC_AMPLIFY * (NaviAccNick / NaviCntAcc))/4;
</code><code>  ToNaviCtrl.AccRoll = ((<B><FONT COLOR="#228B22">int</FONT></B>) ACC_AMPLIFY * (NaviAccRoll / NaviCntAcc))/4;
</code><code>  NaviCntAcc = 0; NaviAccNick = 0; NaviAccRoll = 0;
</code><code><I><FONT COLOR="#B22222">//  ToNaviCtrl.User8 = Parameter_UserParam8;
</code><code></FONT></I><I><FONT COLOR="#B22222">//  ToNaviCtrl.CalState = WinkelOut.CalcState;
</code><code></FONT></I>
</code><code>   <B><FONT COLOR="#A020F0">switch</FONT></B>(ToNaviCtrl.Command)  <I><FONT COLOR="#B22222">//
</code><code></FONT></I>   {
</code><code>         <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">SPI_CMD_USER</FONT></B>:
</code><code>                                ToNaviCtrl.Param.Byte[0] = Parameter_UserParam1;
</code><code>                                ToNaviCtrl.Param.Byte[1] = Parameter_UserParam2;
</code><code>                                ToNaviCtrl.Param.Byte[2] = Parameter_UserParam3;
</code><code>                                ToNaviCtrl.Param.Byte[3] = Parameter_UserParam4;
</code><code>                                ToNaviCtrl.Param.Byte[4] = Parameter_UserParam5;
</code><code>                                ToNaviCtrl.Param.Byte[5] = Parameter_UserParam6;
</code><code>                                ToNaviCtrl.Param.Byte[6] = Parameter_UserParam7;
</code><code>                                ToNaviCtrl.Param.Byte[7] = Parameter_UserParam8;
</code><code>                                ToNaviCtrl.Param.Byte[8] = (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>) MikroKopterFlags;
</code><code>                MikroKopterFlags &amp;= ~(FLAG_CALIBRATE | FLAG_START);
</code><code>                    ToNaviCtrl.Param.Byte[9] = (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>) UBat;
</code><code>                    ToNaviCtrl.Param.Byte[10] =(<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>) EE_Parameter.UnterspannungsWarnung;
</code><code>                    ToNaviCtrl.Param.Byte[11] =(<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>) eeprom_read_byte(&amp;EEPromArray[EEPROM_ADR_ACTIVE_SET]);
</code><code>        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>         <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">SPI_CMD_PARAMETER1</FONT></B>:
</code><code>                                ToNaviCtrl.Param.Byte[0] = EE_Parameter.NaviGpsModeControl;     <I><FONT COLOR="#B22222">// Parameters for the Naviboard
</code><code></FONT></I>                                ToNaviCtrl.Param.Byte[1] = EE_Parameter.NaviGpsGain;
</code><code>                                ToNaviCtrl.Param.Byte[2] = EE_Parameter.NaviGpsP;
</code><code>                                ToNaviCtrl.Param.Byte[3] = EE_Parameter.NaviGpsI;
</code><code>                                ToNaviCtrl.Param.Byte[4] = EE_Parameter.NaviGpsD;
</code><code>                                ToNaviCtrl.Param.Byte[5] = EE_Parameter.NaviGpsACC;
</code><code>                                ToNaviCtrl.Param.Byte[6] = EE_Parameter.NaviGpsMinSat;
</code><code>                ToNaviCtrl.Param.Byte[7] = EE_Parameter.NaviStickThreshold;
</code><code>                ToNaviCtrl.Param.Byte[8] = EE_Parameter.NaviOperatingRadius;
</code><code>                ToNaviCtrl.Param.Byte[9] = EE_Parameter.NaviWindCorrection;
</code><code>                ToNaviCtrl.Param.Byte[10] = EE_Parameter.NaviSpeedCompensation;
</code><code>                                ToNaviCtrl.Param.Byte[11] = EE_Parameter.NaviAngleLimitation;
</code><code>            <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>         <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">SPI_CMD_STICK</FONT></B>:
</code><code>                tmp = PPM_in[EE_Parameter.Kanalbelegung[K_GAS]];  <B><FONT COLOR="#A020F0">if</FONT></B>(tmp &gt; 127) tmp = 127; <B><FONT COLOR="#A020F0">else</FONT></B> <B><FONT COLOR="#A020F0">if</FONT></B>(tmp &lt; -127) tmp = -127;
</code><code>                                ToNaviCtrl.Param.Byte[0] = (<B><FONT COLOR="#228B22">char</FONT></B>) tmp;
</code><code>                tmp = PPM_in[EE_Parameter.Kanalbelegung[K_GIER]]; <B><FONT COLOR="#A020F0">if</FONT></B>(tmp &gt; 127) tmp = 127; <B><FONT COLOR="#A020F0">else</FONT></B> <B><FONT COLOR="#A020F0">if</FONT></B>(tmp &lt; -127) tmp = -127;
</code><code>                                ToNaviCtrl.Param.Byte[1] = (<B><FONT COLOR="#228B22">char</FONT></B>) tmp;
</code><code>                tmp = PPM_in[EE_Parameter.Kanalbelegung[K_ROLL]]; <B><FONT COLOR="#A020F0">if</FONT></B>(tmp &gt; 127) tmp = 127; <B><FONT COLOR="#A020F0">else</FONT></B> <B><FONT COLOR="#A020F0">if</FONT></B>(tmp &lt; -127) tmp = -127;
</code><code>                                ToNaviCtrl.Param.Byte[2] = (<B><FONT COLOR="#228B22">char</FONT></B>) tmp;
</code><code>                tmp = PPM_in[EE_Parameter.Kanalbelegung[K_NICK]]; <B><FONT COLOR="#A020F0">if</FONT></B>(tmp &gt; 127) tmp = 127; <B><FONT COLOR="#A020F0">else</FONT></B> <B><FONT COLOR="#A020F0">if</FONT></B>(tmp &lt; -127) tmp = -127;
</code><code>                                ToNaviCtrl.Param.Byte[3] = (<B><FONT COLOR="#228B22">char</FONT></B>) tmp;
</code><code>                                ToNaviCtrl.Param.Byte[4] = (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>) Poti1;
</code><code>                                ToNaviCtrl.Param.Byte[5] = (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>) Poti2;
</code><code>                                ToNaviCtrl.Param.Byte[6] = (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>) Poti3;
</code><code>                    ToNaviCtrl.Param.Byte[7] = (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>) Poti4;
</code><code>                    ToNaviCtrl.Param.Byte[8] = (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>) SenderOkay;
</code><code>            <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>         <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">SPI_CMD_MISC</FONT></B>:
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B>(WinkelOut.CalcState &gt; 5)
</code><code>                  {
</code><code>                    WinkelOut.CalcState = 0;
</code><code>                    ToNaviCtrl.Param.Byte[0] = 5;
</code><code>                  }
</code><code>                                <B><FONT COLOR="#A020F0">else</FONT></B> ToNaviCtrl.Param.Byte[0] = WinkelOut.CalcState;
</code><code>                                ToNaviCtrl.Param.Int[1] = HoehenWert;
</code><code>                                ToNaviCtrl.Param.Byte[1] = EE_Parameter.NaviPH_LoginTime;
</code><code>                                ToNaviCtrl.Param.Byte[4] = EE_Parameter.NaviGpsPLimit;
</code><code>                                ToNaviCtrl.Param.Byte[5] = EE_Parameter.NaviGpsILimit;
</code><code>                                ToNaviCtrl.Param.Byte[6] = EE_Parameter.NaviGpsDLimit;
</code><code>            <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>         <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">SPI_CMD_VERSION</FONT></B>:
</code><code>                                ToNaviCtrl.Param.Byte[0] = SPI_VersionInfo.Major;
</code><code>                                ToNaviCtrl.Param.Byte[1] = SPI_VersionInfo.Minor;
</code><code>                                ToNaviCtrl.Param.Byte[2] = SPI_VersionInfo.Patch;
</code><code>                                ToNaviCtrl.Param.Byte[3] = SPI_VersionInfo.Compatible;
</code><code>                                ToNaviCtrl.Param.Byte[4] = PlatinenVersion;
</code><code>            <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>   }
</code><code>
</code><code>  sei();
</code><code>
</code><code>  <B><FONT COLOR="#A020F0">if</FONT></B>(SPI_RxDataValid)
</code><code>  {
</code><code>   <B><FONT COLOR="#A020F0">if</FONT></B>(abs(FromNaviCtrl.GPS_Nick) &lt; 512 &amp;&amp; abs(FromNaviCtrl.GPS_Roll) &lt; 512 &amp;&amp; (EE_Parameter.GlobalConfig &amp; CFG_GPS_AKTIV))
</code><code>   {
</code><code>    GPS_Nick = FromNaviCtrl.GPS_Nick;
</code><code>    GPS_Roll = FromNaviCtrl.GPS_Roll;
</code><code>        NaviDataOkay = 250;
</code><code>   }
</code><code>    <B><FONT COLOR="#A020F0">if</FONT></B>(FromNaviCtrl.CompassValue &lt;= 360)   KompassValue = FromNaviCtrl.CompassValue;
</code><code>    KompassRichtung = ((540 + KompassValue - KompassStartwert) % 360) - 180;
</code><code>
</code><code>    <B><FONT COLOR="#A020F0">if</FONT></B>(FromNaviCtrl.BeepTime &gt; beeptime &amp;&amp; !WinkelOut.CalcState) beeptime = FromNaviCtrl.BeepTime;
</code><code>
</code><code>          <B><FONT COLOR="#A020F0">switch</FONT></B> (FromNaviCtrl.Command)
</code><code>          {
</code><code>            <B><FONT COLOR="#A020F0">case</FONT></B>  <B><FONT COLOR="#5F9EA0">SPI_KALMAN</FONT></B>:
</code><code>               FromNaviCtrl_Value.Kalman_K = FromNaviCtrl.Param.Byte[0];
</code><code>               FromNaviCtrl_Value.Kalman_MaxFusion = FromNaviCtrl.Param.Byte[1];
</code><code>               FromNaviCtrl_Value.Kalman_MaxDrift = FromNaviCtrl.Param.Byte[2];
</code><code>               FromNaviCtrl_Value.SerialDataOkay = FromNaviCtrl.Param.Byte[3];
</code><code>               <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>                <B><FONT COLOR="#5F9EA0">default</FONT></B>:
</code><code>                  <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>          }
</code><code>  }
</code><code>  <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>  {
</code><code><I><FONT COLOR="#B22222">//    KompassValue = 0;
</code><code></FONT></I><I><FONT COLOR="#B22222">//    KompassRichtung = 0;
</code><code></FONT></I>        GPS_Nick = 0;
</code><code>    GPS_Roll = 0;
</code><code>  }
</code><code>}
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>
</code><code>
</code><code></PRE>
</code><code></code>    </div>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fspi.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fspi.c&amp;rev=0&amp;sc=0">Blame</a></span>
</p>
  </div>
  <div id="footer">
    <p style="padding:0; margin:0"><small>powered by: <a href="http://websvn.tigris.org">WebSVN 2.0</a></small></p>
  </div>
</body>
</html>
