<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="content-type" content="text/html;charset=UTF-8" />
    <meta http-equiv="generator" content="WebSVN 2.0" /> <!-- leave this for stats -->
    <link rel="shortcut icon" type="image/x-icon" href="./templates/calm/images/favicon.ico" />
    <link type="text/css" href="./templates/calm/styles.css" rel="stylesheet" media="screen" />
    <link type="text/css" href="./templates/calm/star-light/star-light.css" rel="stylesheet" media="screen" />
    <!--[if gte IE 5.5000]>
    <script type="text/javascript" src="./templates/calm/png.js"></script>
    <style type="text/css" media="screen">
    tbody tr td { padding:1px 0 }
    #wrap h2 { padding:10px 5px 0 5px; margin-bottom:-8px }
    </style>
    <![endif]-->
    <title>
         MikroKopter - WebSVN
            - FlightCtrl
               - Rev 1226
            - /tags/V0.74d/timer0.c
    </title>
    <script type="text/javascript">
    //<![CDATA[
         function getPath()
         {
         	return '.';
         }
         
         function checkCB(chBox)
         {
            count = 0
            first = null
            f = chBox.form
            for (i = 0 ; i < f.elements.length ; i++)
            if (f.elements[i].type == 'checkbox' && f.elements[i].checked)
            {
               if (first == null && f.elements[i] != chBox)
                  first = f.elements[i]
               count += 1
            }
            
            if (count > 2) 
            {
               first.checked = false
               count -= 1
            }
         }
    //]]>
    </script>
    <script type="text/javascript" src="./templates/calm/collapse.js"></script>
    </head>
    <body>
    <div id="container">
    <H3>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://www.mikrokopter.de" target="_blank">MikroKopter.de</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://forum.mikrokopter.de" target="_blank">Forum</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
  </H3>
<div id="select"><form action="form.php?path=&amp;" method="post" id="projectform"><div><input type="hidden" name="selectproj" value="1" /><input type="hidden" name="op" value="form" /><input type="hidden" name="sc" value="0" /><select name="repname" onchange="javascript:this.form.submit();"><option value="BL-Ctrl">BL-Ctrl</option><option value="FlightCtrl" selected="selected">FlightCtrl</option><option value="MK3Mag">MK3Mag</option><option value="NaviCtrl">NaviCtrl</option><option value="Projects">Projects</option></select><span class="submit"><input type="submit" value="Go" /></span></div></form></div>
<h1><a href=".?sc=0" title="Project home">Subversion&nbsp;Repositories</a> <span>FlightCtrl</span></h1>
<h2 class="path" style="margin:0 2% 15px 2%;">[<a href="listing.php?repname=FlightCtrl&amp;path=%2F&amp;rev=0&amp;sc=0">/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2F&amp;rev=0&amp;sc=0">tags/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2F&amp;rev=0&amp;sc=0">V0.74d/</a>] [<b>timer0.c</b>] - Rev 1226</h2>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftimer0.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftimer0.c&amp;rev=0&amp;sc=0">Blame</a></span> &#124;
<span class="diff"><a href="log.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftimer0.c&amp;rev=0&amp;sc=0&amp;isdir=0">View&nbsp;Log</a></span>
</p>
    <div class="listing">
<code><PRE>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;main.h&quot;</FONT></B>
</code><code>
</code><code><B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> CountMilliseconds = 0;
</code><code><B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">static</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> tim_main;
</code><code><B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> UpdateMotor = 0;
</code><code><B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> cntKompass = 0;
</code><code><B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> beeptime = 0;
</code><code><B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> SendSPI = 0, ServoActive = 0;
</code><code>
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> BeepMuster = 0xffff;
</code><code><B><FONT COLOR="#228B22">int</FONT></B> ServoValue = 0;
</code><code>
</code><code><B><FONT COLOR="#228B22">volatile</FONT></B> int16_t        ServoNickValue = 0;
</code><code><B><FONT COLOR="#228B22">volatile</FONT></B> int16_t        ServoRollValue = 0;
</code><code>
</code><code>
</code><code><B><FONT COLOR="#228B22">enum</FONT></B> {
</code><code>  STOP             = 0,
</code><code>  CK               = 1,
</code><code>  CK8              = 2,
</code><code>  CK64             = 3,
</code><code>  CK256            = 4,
</code><code>  CK1024           = 5,
</code><code>  T0_FALLING_EDGE  = 6,
</code><code>  T0_RISING_EDGE   = 7
</code><code>};
</code><code>
</code><code>
</code><code><B><FONT COLOR="#0000FF">SIGNAL</FONT></B> (SIG_OVERFLOW0)    <I><FONT COLOR="#B22222">// 8kHz
</code><code></FONT></I>{
</code><code>    <B><FONT COLOR="#228B22">static</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> cnt_1ms = 1,cnt = 0;
</code><code>    <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> pieper_ein = 0;
</code><code><I><FONT COLOR="#B22222">//    TCNT0 -= 250;//TIMER_RELOAD_VALUE;
</code><code></FONT></I>   <B><FONT COLOR="#A020F0">if</FONT></B>(SendSPI) SendSPI--;
</code><code>   <B><FONT COLOR="#A020F0">if</FONT></B>(!cnt--)
</code><code>    {
</code><code>     cnt = 9;
</code><code>     cnt_1ms++;
</code><code>     cnt_1ms %= 2;
</code><code>     <B><FONT COLOR="#A020F0">if</FONT></B>(!cnt_1ms) UpdateMotor = 1;
</code><code>     CountMilliseconds++;
</code><code>    }
</code><code>
</code><code>     <B><FONT COLOR="#A020F0">if</FONT></B>(beeptime &gt; 1)
</code><code>        {
</code><code>        beeptime--;
</code><code>        <B><FONT COLOR="#A020F0">if</FONT></B>(beeptime &amp; BeepMuster)
</code><code>         {
</code><code>          pieper_ein = 1;
</code><code>         }
</code><code>         <B><FONT COLOR="#A020F0">else</FONT></B> pieper_ein = 0;
</code><code>        }
</code><code>     <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>      {
</code><code>       pieper_ein = 0;
</code><code>       BeepMuster = 0xffff;
</code><code>      }
</code><code>
</code><code>
</code><code>     <B><FONT COLOR="#A020F0">if</FONT></B>(pieper_ein)
</code><code>        {
</code><code>          <B><FONT COLOR="#A020F0">if</FONT></B>(PlatinenVersion == 10) PORTD |= (1&lt;&lt;2); <I><FONT COLOR="#B22222">// Speaker an PORTD.2
</code><code></FONT></I>          <B><FONT COLOR="#A020F0">else</FONT></B>                      PORTC |= (1&lt;&lt;7); <I><FONT COLOR="#B22222">// Speaker an PORTC.7
</code><code></FONT></I>        }
</code><code>     <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>        {
</code><code>         <B><FONT COLOR="#A020F0">if</FONT></B>(PlatinenVersion == 10) PORTD &amp;= ~(1&lt;&lt;2);
</code><code>         <B><FONT COLOR="#A020F0">else</FONT></B>                      PORTC &amp;= ~(1&lt;&lt;7);
</code><code>        }
</code><code>
</code><code> <B><FONT COLOR="#A020F0">if</FONT></B>(EE_Parameter.GlobalConfig &amp; CFG_KOMPASS_AKTIV)
</code><code> {
</code><code>  <B><FONT COLOR="#A020F0">if</FONT></B>(PINC &amp; 0x10)
</code><code>   {
</code><code>    cntKompass++;
</code><code>   }
</code><code>  <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>   {
</code><code>    <B><FONT COLOR="#A020F0">if</FONT></B>((cntKompass) &amp;&amp; (cntKompass &lt; 362))
</code><code>    {
</code><code>     cntKompass += cntKompass / 41;
</code><code>     <B><FONT COLOR="#A020F0">if</FONT></B>(cntKompass &gt; 10) KompassValue = cntKompass - 10; <B><FONT COLOR="#A020F0">else</FONT></B> KompassValue = 0;
</code><code>    }
</code><code><I><FONT COLOR="#B22222">//     if(cntKompass &lt; 10) cntKompass = 10;
</code><code></FONT></I><I><FONT COLOR="#B22222">//     KompassValue = (unsigned long)((unsigned long)(cntKompass-10)*720L + 1L) / 703L;
</code><code></FONT></I>     KompassRichtung = ((540 + KompassValue - KompassStartwert) % 360) - 180;
</code><code>    cntKompass = 0;
</code><code>   }
</code><code> }
</code><code>}
</code><code>
</code><code>
</code><code><I><FONT COLOR="#B22222">// -----------------------------------------------------------------------
</code><code></FONT></I>
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> <B><FONT COLOR="#0000FF">SetDelay</FONT></B> (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> t)
</code><code>{
</code><code><I><FONT COLOR="#B22222">//  TIMSK0 &amp;= ~_BV(TOIE0);
</code><code></FONT></I>  <B><FONT COLOR="#A020F0">return</FONT></B>(CountMilliseconds + t + 1);
</code><code><I><FONT COLOR="#B22222">//  TIMSK0 |= _BV(TOIE0);
</code><code></FONT></I>}
</code><code>
</code><code><I><FONT COLOR="#B22222">// -----------------------------------------------------------------------
</code><code></FONT></I><B><FONT COLOR="#228B22">char</FONT></B> <B><FONT COLOR="#0000FF">CheckDelay</FONT></B>(<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> t)
</code><code>{
</code><code><I><FONT COLOR="#B22222">//  TIMSK0 &amp;= ~_BV(TOIE0);
</code><code></FONT></I>  <B><FONT COLOR="#A020F0">return</FONT></B>(((t - CountMilliseconds) &amp; 0x8000) &gt;&gt; 9);
</code><code><I><FONT COLOR="#B22222">//  TIMSK0 |= _BV(TOIE0);
</code><code></FONT></I>}
</code><code>
</code><code><I><FONT COLOR="#B22222">// -----------------------------------------------------------------------
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">Delay_ms</FONT></B>(<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> w)
</code><code>{
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> akt;
</code><code> akt = SetDelay(w);
</code><code> <B><FONT COLOR="#A020F0">while</FONT></B> (!CheckDelay(akt));
</code><code>}
</code><code>
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">Delay_ms_Mess</FONT></B>(<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> w)
</code><code>{
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> akt;
</code><code> akt = SetDelay(w);
</code><code> <B><FONT COLOR="#A020F0">while</FONT></B> (!CheckDelay(akt)) <B><FONT COLOR="#A020F0">if</FONT></B>(AdReady) {AdReady = 0; ANALOG_ON;}
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">/*****************************************************/</FONT></I>
</code><code><I><FONT COLOR="#B22222">/*              Initialize Timer 2                   */</FONT></I>
</code><code><I><FONT COLOR="#B22222">/*****************************************************/</FONT></I>
</code><code><I><FONT COLOR="#B22222">// The timer 2 is used to generate the PWM at PD7 (J7)
</code><code></FONT></I><I><FONT COLOR="#B22222">// to control a camera servo for nick compensation.
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">TIMER2_Init</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code>        uint8_t sreg = SREG;
</code><code>
</code><code>        <I><FONT COLOR="#B22222">// disable all interrupts before reconfiguration
</code><code></FONT></I>        cli();
</code><code>
</code><code>        <I><FONT COLOR="#B22222">// set PD7 as output of the PWM for nick servo
</code><code></FONT></I>        DDRD  |= (1&lt;&lt;DDD7);
</code><code>        PORTD &amp;= ~(1&lt;&lt;PORTD7);  <I><FONT COLOR="#B22222">// set PD7 to low
</code><code></FONT></I>
</code><code>        DDRC  |= (1&lt;&lt;DDC6);     <I><FONT COLOR="#B22222">// set PC6 as output (Reset for HEF4017)
</code><code></FONT></I>    HEF4017R_ON;
</code><code>        <I><FONT COLOR="#B22222">// Timer/Counter 2 Control Register A
</code><code></FONT></I>
</code><code>        <I><FONT COLOR="#B22222">// Timer Mode is FastPWM with timer reload at OCR2A (Bits: WGM22 = 1, WGM21 = 1, WGM20 = 1)
</code><code></FONT></I>    <I><FONT COLOR="#B22222">// PD7: Normal port operation, OC2A disconnected, (Bits: COM2A1 = 0, COM2A0 = 0)
</code><code></FONT></I>    <I><FONT COLOR="#B22222">// PD6: Normal port operation, OC2B disconnected, (Bits: COM2B1 = 0, COM2B0 = 0)
</code><code></FONT></I>        TCCR2A &amp;= ~((1&lt;&lt;COM2A1)|(1&lt;&lt;COM2A0)|(1&lt;&lt;COM2B1)|(1&lt;&lt;COM2B0));
</code><code>    TCCR2A |= (1&lt;&lt;WGM21)|(1&lt;&lt;WGM20);
</code><code>
</code><code>    <I><FONT COLOR="#B22222">// Timer/Counter 2 Control Register B
</code><code></FONT></I>
</code><code>        <I><FONT COLOR="#B22222">// Set clock divider for timer 2 to SYSKLOCK/32 = 20MHz / 32 = 625 kHz
</code><code></FONT></I>        <I><FONT COLOR="#B22222">// The timer increments from 0x00 to 0xFF with an update rate of 625 kHz or 1.6 us
</code><code></FONT></I>        <I><FONT COLOR="#B22222">// hence the timer overflow interrupt frequency is 625 kHz / 256 = 2.44 kHz or 0.4096 ms
</code><code></FONT></I>
</code><code>    <I><FONT COLOR="#B22222">// divider 32 (Bits: CS022 = 0, CS21 = 1, CS20 = 1)
</code><code></FONT></I>        TCCR2B &amp;= ~((1&lt;&lt;FOC2A)|(1&lt;&lt;FOC2B)|(1&lt;&lt;CS22));
</code><code>    TCCR2B |= (1&lt;&lt;CS21)|(1&lt;&lt;CS20)|(1&lt;&lt;WGM22);
</code><code>
</code><code>        <I><FONT COLOR="#B22222">// Initialize the Timer/Counter 2 Register
</code><code></FONT></I>    TCNT2 = 0;
</code><code>
</code><code>        <I><FONT COLOR="#B22222">// Initialize the Output Compare Register A used for PWM generation on port PD7.
</code><code></FONT></I>        OCR2A = 255;
</code><code>        TCCR2A |= (1&lt;&lt;COM2A1); <I><FONT COLOR="#B22222">// set or clear at compare match depends on value of COM2A0
</code><code></FONT></I>
</code><code>        <I><FONT COLOR="#B22222">// Timer/Counter 2 Interrupt Mask Register
</code><code></FONT></I>        <I><FONT COLOR="#B22222">// Enable timer output compare match A Interrupt only
</code><code></FONT></I>        TIMSK2 &amp;= ~((1&lt;&lt;OCIE2B)|(1&lt;&lt;TOIE2));
</code><code>        TIMSK2 |= (1&lt;&lt;OCIE2A);
</code><code>
</code><code>    SREG = sreg;
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">//----------------------------
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">Timer_Init</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code>    tim_main = SetDelay(10);
</code><code>    TCCR0B = CK8;
</code><code>    TCCR0A = (1&lt;&lt;COM0A1)|(1&lt;&lt;COM0B1)|3;<I><FONT COLOR="#B22222">//fast PWM
</code><code></FONT></I>    OCR0A =  0;
</code><code>    OCR0B = 120;
</code><code>    TCNT0 = (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>)-TIMER_RELOAD_VALUE;  <I><FONT COLOR="#B22222">// reload
</code><code></FONT></I>    <I><FONT COLOR="#B22222">//OCR1  = 0x00;
</code><code></FONT></I>
</code><code>    TIMSK0 |= _BV(TOIE0);
</code><code>}
</code><code>
</code><code>
</code><code><I><FONT COLOR="#B22222">/*****************************************************/</FONT></I>
</code><code><I><FONT COLOR="#B22222">/*              Control Servo Position               */</FONT></I>
</code><code><I><FONT COLOR="#B22222">/*****************************************************/</FONT></I>
</code><code>
</code><code><B><FONT COLOR="#0000FF">ISR</FONT></B>(TIMER2_COMPA_vect)
</code><code>{
</code><code>
</code><code>        <I><FONT COLOR="#B22222">// frame len 22.5 ms = 14063 * 1.6 us
</code><code></FONT></I>        <I><FONT COLOR="#B22222">// stop pulse: 0.3 ms = 188 * 1.6 us
</code><code></FONT></I>        <I><FONT COLOR="#B22222">// min servo pulse: 0.6 ms =  375 * 1.6 us
</code><code></FONT></I>        <I><FONT COLOR="#B22222">// max servo pulse: 2.4 ms = 1500 * 1.6 us
</code><code></FONT></I>        <I><FONT COLOR="#B22222">// resolution: 1500 - 375 = 1125 steps
</code><code></FONT></I>
</code><code>        #define IRS_RUNTIME 127
</code><code>        #define PPM_STOPPULSE 188
</code><code><I><FONT COLOR="#B22222">//      #define PPM_FRAMELEN (14063
</code><code></FONT></I>    #define PPM_FRAMELEN (1757 * EE_Parameter.ServoNickRefresh)
</code><code>        #define MINSERVOPULSE 375
</code><code>        #define MAXSERVOPULSE 1500
</code><code>        #define SERVORANGE (MAXSERVOPULSE - MINSERVOPULSE)
</code><code>
</code><code>        <B><FONT COLOR="#228B22">static</FONT></B> uint8_t  PulseOutput = 0;
</code><code>        <B><FONT COLOR="#228B22">static</FONT></B> uint16_t RemainingPulse = 0;
</code><code>        <B><FONT COLOR="#228B22">static</FONT></B> uint16_t ServoFrameTime = 0;
</code><code>        <B><FONT COLOR="#228B22">static</FONT></B> uint8_t  ServoIndex = 0;
</code><code>
</code><code>        #define MULTIPLYER 4
</code><code>        <B><FONT COLOR="#228B22">static</FONT></B> int16_t ServoNickOffset = (255 / 2) * MULTIPLYER; <I><FONT COLOR="#B22222">// initial value near center positon
</code><code></FONT></I>        <B><FONT COLOR="#228B22">static</FONT></B> int16_t ServoRollOffset = (255 / 2) * MULTIPLYER; <I><FONT COLOR="#B22222">// initial value near center positon
</code><code></FONT></I>
</code><code>        <B><FONT COLOR="#A020F0">if</FONT></B>(PlatinenVersion &lt; 20)
</code><code>        {
</code><code>                <I><FONT COLOR="#B22222">//---------------------------
</code><code></FONT></I>                <I><FONT COLOR="#B22222">// Nick servo state machine
</code><code></FONT></I>                <I><FONT COLOR="#B22222">//---------------------------
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">if</FONT></B>(!PulseOutput) <I><FONT COLOR="#B22222">// pulse output complete
</code><code></FONT></I>                {
</code><code>                        <B><FONT COLOR="#A020F0">if</FONT></B>(TCCR2A &amp; (1&lt;&lt;COM2A0)) <I><FONT COLOR="#B22222">// we had a low pulse
</code><code></FONT></I>                        {
</code><code>                                TCCR2A &amp;= ~(1&lt;&lt;COM2A0);<I><FONT COLOR="#B22222">// make a high pulse
</code><code></FONT></I>                                RemainingPulse  = MINSERVOPULSE + SERVORANGE/2; <I><FONT COLOR="#B22222">// center position ~ 1.5ms
</code><code></FONT></I>
</code><code>                                ServoNickOffset = (ServoNickOffset * 3 + (int16_t)Parameter_ServoNickControl * MULTIPLYER) / 4; <I><FONT COLOR="#B22222">// lowpass offset
</code><code></FONT></I>                                ServoNickValue = ServoNickOffset; <I><FONT COLOR="#B22222">// offset (Range from 0 to 255 * 3 = 765)
</code><code></FONT></I>                                <B><FONT COLOR="#A020F0">if</FONT></B>(EE_Parameter.ServoNickCompInvert &amp; 0x01)
</code><code>                                {       <I><FONT COLOR="#B22222">// inverting movement of servo
</code><code></FONT></I>                                        ServoNickValue += (int16_t)( ( (int32_t)EE_Parameter.ServoNickComp * MULTIPLYER * (IntegralNick / 128L ) ) / (256L) );
</code><code>                                }
</code><code>                                <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>                                {       <I><FONT COLOR="#B22222">// non inverting movement of servo
</code><code></FONT></I>                                        ServoNickValue -= (int16_t)( ( (int32_t)EE_Parameter.ServoNickComp * MULTIPLYER * (IntegralNick / 128L ) ) / (256L) );
</code><code>                                }
</code><code>                                <I><FONT COLOR="#B22222">// limit servo value to its parameter range definition
</code><code></FONT></I>                                <B><FONT COLOR="#A020F0">if</FONT></B>(ServoNickValue &lt; ((int16_t)EE_Parameter.ServoNickMin * MULTIPLYER) )
</code><code>                                {
</code><code>                                        ServoNickValue = (int16_t)EE_Parameter.ServoNickMin * MULTIPLYER;
</code><code>                                }
</code><code>                                <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>                                <B><FONT COLOR="#A020F0">if</FONT></B>(ServoNickValue &gt; ((int16_t)EE_Parameter.ServoNickMax * MULTIPLYER) )
</code><code>                                {
</code><code>                                        ServoNickValue = (int16_t)EE_Parameter.ServoNickMax * MULTIPLYER;
</code><code>                                }
</code><code>
</code><code>                                RemainingPulse += ServoNickValue - (256 / 2) * MULTIPLYER; <I><FONT COLOR="#B22222">// shift ServoNickValue to center position
</code><code></FONT></I>
</code><code>                                ServoNickValue /= MULTIPLYER;
</code><code>                                DebugOut.Analog[20] = ServoNickValue;
</code><code>
</code><code>                                <I><FONT COLOR="#B22222">// range servo pulse width
</code><code></FONT></I>                                <B><FONT COLOR="#A020F0">if</FONT></B>(RemainingPulse &gt; MAXSERVOPULSE )                     RemainingPulse = MAXSERVOPULSE; <I><FONT COLOR="#B22222">// upper servo pulse limit
</code><code></FONT></I>                                <B><FONT COLOR="#A020F0">else</FONT></B> <B><FONT COLOR="#A020F0">if</FONT></B>(RemainingPulse &lt; MINSERVOPULSE )        RemainingPulse = MINSERVOPULSE; <I><FONT COLOR="#B22222">// lower servo pulse limit
</code><code></FONT></I>                                <I><FONT COLOR="#B22222">// accumulate time for correct update rate
</code><code></FONT></I>                                ServoFrameTime = RemainingPulse;
</code><code>                        }
</code><code>                        <B><FONT COLOR="#A020F0">else</FONT></B> <I><FONT COLOR="#B22222">// we had a high pulse
</code><code></FONT></I>                        {
</code><code>                                TCCR2A |= (1&lt;&lt;COM2A0); <I><FONT COLOR="#B22222">// make a low pulse
</code><code></FONT></I>                                RemainingPulse = PPM_FRAMELEN - ServoFrameTime;
</code><code>                        }
</code><code>                        <I><FONT COLOR="#B22222">// set pulse output active
</code><code></FONT></I>                        PulseOutput = 1;
</code><code>                }
</code><code>        } <I><FONT COLOR="#B22222">// EOF Nick servo state machine
</code><code></FONT></I>        <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>        {
</code><code>                <I><FONT COLOR="#B22222">//-----------------------------------------------------
</code><code></FONT></I>                <I><FONT COLOR="#B22222">// PPM state machine, onboard demultiplexed by HEF4017
</code><code></FONT></I>                <I><FONT COLOR="#B22222">//-----------------------------------------------------
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">if</FONT></B>(!PulseOutput) <I><FONT COLOR="#B22222">// pulse output complete
</code><code></FONT></I>                {
</code><code>                        <B><FONT COLOR="#A020F0">if</FONT></B>(TCCR2A &amp; (1&lt;&lt;COM2A0)) <I><FONT COLOR="#B22222">// we had a low pulse
</code><code></FONT></I>                        {
</code><code>                                TCCR2A &amp;= ~(1&lt;&lt;COM2A0);<I><FONT COLOR="#B22222">// make a high pulse
</code><code></FONT></I>
</code><code>                                <B><FONT COLOR="#A020F0">if</FONT></B>(ServoIndex == 0) <I><FONT COLOR="#B22222">// if we are at the sync gap
</code><code></FONT></I>                                {
</code><code>                                        RemainingPulse = PPM_FRAMELEN - ServoFrameTime; <I><FONT COLOR="#B22222">// generate sync gap by filling time to full frame time
</code><code></FONT></I>                                        ServoFrameTime = 0; <I><FONT COLOR="#B22222">// reset servo frame time
</code><code></FONT></I>                                        HEF4017R_ON; <I><FONT COLOR="#B22222">// enable HEF4017 reset
</code><code></FONT></I>                                }
</code><code>                                <B><FONT COLOR="#A020F0">else</FONT></B> <I><FONT COLOR="#B22222">// servo channels
</code><code></FONT></I>                                {
</code><code>                                        RemainingPulse  = MINSERVOPULSE + SERVORANGE/2; <I><FONT COLOR="#B22222">// center position ~ 1.5ms
</code><code></FONT></I>                                        <B><FONT COLOR="#A020F0">switch</FONT></B>(ServoIndex) <I><FONT COLOR="#B22222">// map servo channels
</code><code></FONT></I>                                        {
</code><code>                                                <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">1</FONT></B>: <I><FONT COLOR="#B22222">// Nick Compensation Servo
</code><code></FONT></I>                                                        ServoNickOffset = (ServoNickOffset * 3 + (int16_t)Parameter_ServoNickControl * MULTIPLYER) / 4; <I><FONT COLOR="#B22222">// lowpass offset
</code><code></FONT></I>                                                        ServoNickValue = ServoNickOffset; <I><FONT COLOR="#B22222">// offset (Range from 0 to 255 * 3 = 765)
</code><code></FONT></I>                                                        <B><FONT COLOR="#A020F0">if</FONT></B>(EE_Parameter.ServoNickCompInvert &amp; 0x01)
</code><code>                                                        {       <I><FONT COLOR="#B22222">// inverting movement of servo
</code><code></FONT></I>                                                                ServoNickValue += (int16_t)( ( (int32_t)EE_Parameter.ServoNickComp * MULTIPLYER * (IntegralNick / 128L ) ) / (256L) );
</code><code>                                                        }
</code><code>                                                        <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>                                                        {       <I><FONT COLOR="#B22222">// non inverting movement of servo
</code><code></FONT></I>                                                                ServoNickValue -= (int16_t)( ( (int32_t)EE_Parameter.ServoNickComp * MULTIPLYER * (IntegralNick / 128L ) ) / (256L) );
</code><code>                                                        }
</code><code>                                                        <I><FONT COLOR="#B22222">// limit servo value to its parameter range definition
</code><code></FONT></I>                                                        <B><FONT COLOR="#A020F0">if</FONT></B>(ServoNickValue &lt; ((int16_t)EE_Parameter.ServoNickMin * MULTIPLYER) )
</code><code>                                                        {
</code><code>                                                                ServoNickValue = (int16_t)EE_Parameter.ServoNickMin * MULTIPLYER;
</code><code>                                                        }
</code><code>                                                        <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>                                                        <B><FONT COLOR="#A020F0">if</FONT></B>(ServoNickValue &gt; ((int16_t)EE_Parameter.ServoNickMax * MULTIPLYER) )
</code><code>                                                        {
</code><code>                                                                ServoNickValue = (int16_t)EE_Parameter.ServoNickMax * MULTIPLYER;
</code><code>                                                        }
</code><code>                                                        RemainingPulse += ServoNickValue - (256 / 2) * MULTIPLYER; <I><FONT COLOR="#B22222">// shift ServoNickValue to center position
</code><code></FONT></I>                                                        ServoNickValue /= MULTIPLYER;
</code><code>                                                        DebugOut.Analog[20] = ServoNickValue;
</code><code>                                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>                                         <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">2</FONT></B>: <I><FONT COLOR="#B22222">// Roll Compensation Servo
</code><code></FONT></I>                                                        ServoRollOffset = (ServoRollOffset * 3 + (int16_t) 80 * MULTIPLYER) / 4; <I><FONT COLOR="#B22222">// lowpass offset
</code><code></FONT></I>                                                        ServoRollValue = ServoRollOffset; <I><FONT COLOR="#B22222">// offset (Range from 0 to 255 * 3 = 765)
</code><code></FONT></I>                                                        <I><FONT COLOR="#B22222">//if(EE_Parameter.ServoRollCompInvert &amp; 0x01)
</code><code></FONT></I>                                                        {       <I><FONT COLOR="#B22222">// inverting movement of servo
</code><code></FONT></I>                                                                ServoRollValue += (int16_t)( ( (int32_t) 50 * MULTIPLYER * (IntegralRoll / 128L ) ) / (256L) );
</code><code>                                                        }
</code><code><I><FONT COLOR="#B22222">/*                                                      else
</code><code>                                                        {       // non inverting movement of servo
</code><code>                                                                ServoRollValue -= (int16_t)( ( (int32_t) 40 * MULTIPLYER * (IntegralRoll / 128L ) ) / (256L) );
</code><code>                                                        }
</code><code>*/</FONT></I>                                                      <I><FONT COLOR="#B22222">// limit servo value to its parameter range definition
</code><code></FONT></I>                                                        <B><FONT COLOR="#A020F0">if</FONT></B>(ServoRollValue &lt; ((int16_t)EE_Parameter.ServoNickMin * MULTIPLYER) )
</code><code>                                                        {
</code><code>                                                                ServoRollValue = (int16_t)EE_Parameter.ServoNickMin * MULTIPLYER;
</code><code>                                                        }
</code><code>                                                        <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>                                                        <B><FONT COLOR="#A020F0">if</FONT></B>(ServoRollValue &gt; ((int16_t)EE_Parameter.ServoNickMax * MULTIPLYER) )
</code><code>                                                        {
</code><code>                                                                ServoRollValue = (int16_t)EE_Parameter.ServoNickMax * MULTIPLYER;
</code><code>                                                        }
</code><code>                                                        RemainingPulse += ServoRollValue - (256 / 2) * MULTIPLYER; <I><FONT COLOR="#B22222">// shift ServoNickValue to center position
</code><code></FONT></I>                                                        ServoRollValue /= MULTIPLYER;
</code><code>                                                        <I><FONT COLOR="#B22222">//DebugOut.Analog[20] = ServoRollValue;
</code><code></FONT></I>
</code><code><I><FONT COLOR="#B22222">/*                                                      ServoRollOffset = (ServoRollOffset * 3 + (int16_t)Parameter_ServoRollControl * MULTIPLYER) / 4; // lowpass offset
</code><code>                                                        ServoRollValue = ServoRollOffset; // offset (Range from 0 to 255 * 3 = 765)
</code><code>                                                        if(EE_Parameter.ServoRollCompInvert &amp; 0x01)
</code><code>                                                        {       // inverting movement of servo
</code><code>                                                                ServoRollValue += (int16_t)( ( (int32_t)EE_Parameter.ServoNickComp * MULTIPLYER * (IntegralNick / 128L ) ) / (256L) );
</code><code>                                                        }
</code><code>                                                        else
</code><code>                                                        {       // non inverting movement of servo
</code><code>                                                                ServoRollValue -= (int16_t)( ( (int32_t)EE_Parameter.ServoNickComp * MULTIPLYER * (IntegralNick / 128L ) ) / (256L) );
</code><code>                                                        }
</code><code>                                                        // limit servo value to its parameter range definition
</code><code>                                                        if(ServoRollValue &lt; ((int16_t)EE_Parameter.ServoRollMin * MULTIPLYER) )
</code><code>                                                        {
</code><code>                                                                ServoRollValue = (int16_t)EE_Parameter.ServoRollMin * MULTIPLYER;
</code><code>                                                        }
</code><code>                                                        else
</code><code>                                                        if(ServoRollValue &gt; ((int16_t)EE_Parameter.ServoRollMax * MULTIPLYER) )
</code><code>                                                        {
</code><code>                                                                ServoRollValue = (int16_t)EE_Parameter.ServoRollMax * MULTIPLYER;
</code><code>                                                        }
</code><code>                                                        RemainingPulse += ServoRollValue - (256 / 2) * MULTIPLYER; // shift ServoNickValue to center position
</code><code>                                                        ServoRollValue /= MULTIPLYER;
</code><code>                                                        //DebugOut.Analog[20] = ServoRollValue;
</code><code>*/</FONT></I>                                                      <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>                                                <B><FONT COLOR="#5F9EA0">default</FONT></B>: <I><FONT COLOR="#B22222">// other servo channels
</code><code></FONT></I>                                                        RemainingPulse += 2 * PPM_in[ServoIndex]; <I><FONT COLOR="#B22222">// add channel value, factor of 2 because timer 1 increments 3.2s
</code><code></FONT></I>                                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>                                        }
</code><code>                                        <I><FONT COLOR="#B22222">// range servo pulse width
</code><code></FONT></I>                                        <B><FONT COLOR="#A020F0">if</FONT></B>(RemainingPulse &gt; MAXSERVOPULSE )                     RemainingPulse = MAXSERVOPULSE; <I><FONT COLOR="#B22222">// upper servo pulse limit
</code><code></FONT></I>                                        <B><FONT COLOR="#A020F0">else</FONT></B> <B><FONT COLOR="#A020F0">if</FONT></B>(RemainingPulse &lt; MINSERVOPULSE )        RemainingPulse = MINSERVOPULSE; <I><FONT COLOR="#B22222">// lower servo pulse limit
</code><code></FONT></I>                                        <I><FONT COLOR="#B22222">// substract stop pulse width
</code><code></FONT></I>                                        RemainingPulse -= PPM_STOPPULSE;
</code><code>                                        <I><FONT COLOR="#B22222">// accumulate time for correct sync gap
</code><code></FONT></I>                                        ServoFrameTime += RemainingPulse;
</code><code>                                }
</code><code>                        }
</code><code>                        <B><FONT COLOR="#A020F0">else</FONT></B> <I><FONT COLOR="#B22222">// we had a high pulse
</code><code></FONT></I>                        {
</code><code>                                TCCR2A |= (1&lt;&lt;COM2A0); <I><FONT COLOR="#B22222">// make a low pulse
</code><code></FONT></I>                                <I><FONT COLOR="#B22222">// set pulsewidth to stop pulse width
</code><code></FONT></I>                                RemainingPulse = PPM_STOPPULSE;
</code><code>                                <I><FONT COLOR="#B22222">// accumulate time for correct sync gap
</code><code></FONT></I>                                ServoFrameTime += RemainingPulse;
</code><code>                                <B><FONT COLOR="#A020F0">if</FONT></B>(ServoActive &amp;&amp; SenderOkay &gt; 180) HEF4017R_OFF; <I><FONT COLOR="#B22222">// disable HEF4017 reset
</code><code></FONT></I>                                ServoIndex++; <I><FONT COLOR="#B22222">// change to next servo channel
</code><code></FONT></I>                                <B><FONT COLOR="#A020F0">if</FONT></B>(ServoIndex &gt; EE_Parameter.ServoNickRefresh) ServoIndex = 0; <I><FONT COLOR="#B22222">// reset to the sync gap
</code><code></FONT></I>                        }
</code><code>                        <I><FONT COLOR="#B22222">// set pulse output active
</code><code></FONT></I>                        PulseOutput = 1;
</code><code>                }
</code><code>        } <I><FONT COLOR="#B22222">// EOF PPM state machine
</code><code></FONT></I>
</code><code>        <I><FONT COLOR="#B22222">// General pulse output generator
</code><code></FONT></I>        <B><FONT COLOR="#A020F0">if</FONT></B>(RemainingPulse &gt; (255 + IRS_RUNTIME))
</code><code>        {
</code><code>                OCR2A = 255;
</code><code>                RemainingPulse -= 255;
</code><code>        }
</code><code>        <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>        {
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B>(RemainingPulse &gt; 255) <I><FONT COLOR="#B22222">// this is the 2nd last part
</code><code></FONT></I>                {
</code><code>                        <B><FONT COLOR="#A020F0">if</FONT></B>((RemainingPulse - 255) &lt; IRS_RUNTIME)
</code><code>                        {
</code><code>                                OCR2A = 255 - IRS_RUNTIME;
</code><code>                                RemainingPulse -= 255 - IRS_RUNTIME;
</code><code>
</code><code>                        }
</code><code>                        <B><FONT COLOR="#A020F0">else</FONT></B> <I><FONT COLOR="#B22222">// last part &gt; ISR_RUNTIME
</code><code></FONT></I>                        {
</code><code>                                OCR2A = 255;
</code><code>                                RemainingPulse -= 255;
</code><code>                        }
</code><code>                }
</code><code>                <B><FONT COLOR="#A020F0">else</FONT></B> <I><FONT COLOR="#B22222">// this is the last part
</code><code></FONT></I>                {
</code><code>                        OCR2A = RemainingPulse;
</code><code>                        RemainingPulse = 0;
</code><code>                        PulseOutput = 0; <I><FONT COLOR="#B22222">// trigger to stop pulse
</code><code></FONT></I>                }
</code><code>        } <I><FONT COLOR="#B22222">// EOF general pulse output generator
</code><code></FONT></I>}
</code><code></PRE>
</code><code></code>    </div>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftimer0.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftimer0.c&amp;rev=0&amp;sc=0">Blame</a></span>
</p>
  </div>
  <div id="footer">
    <p style="padding:0; margin:0"><small>powered by: <a href="http://websvn.tigris.org">WebSVN 2.0</a></small></p>
  </div>
</body>
</html>
