<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="content-type" content="text/html;charset=UTF-8" />
    <meta http-equiv="generator" content="WebSVN 2.0" /> <!-- leave this for stats -->
    <link rel="shortcut icon" type="image/x-icon" href="./templates/calm/images/favicon.ico" />
    <link type="text/css" href="./templates/calm/styles.css" rel="stylesheet" media="screen" />
    <link type="text/css" href="./templates/calm/star-light/star-light.css" rel="stylesheet" media="screen" />
    <!--[if gte IE 5.5000]>
    <script type="text/javascript" src="./templates/calm/png.js"></script>
    <style type="text/css" media="screen">
    tbody tr td { padding:1px 0 }
    #wrap h2 { padding:10px 5px 0 5px; margin-bottom:-8px }
    </style>
    <![endif]-->
    <title>
         MikroKopter - WebSVN
            - FlightCtrl
               - Rev 1226
            - /tags/V0.74d/twimaster.c
    </title>
    <script type="text/javascript">
    //<![CDATA[
         function getPath()
         {
         	return '.';
         }
         
         function checkCB(chBox)
         {
            count = 0
            first = null
            f = chBox.form
            for (i = 0 ; i < f.elements.length ; i++)
            if (f.elements[i].type == 'checkbox' && f.elements[i].checked)
            {
               if (first == null && f.elements[i] != chBox)
                  first = f.elements[i]
               count += 1
            }
            
            if (count > 2) 
            {
               first.checked = false
               count -= 1
            }
         }
    //]]>
    </script>
    <script type="text/javascript" src="./templates/calm/collapse.js"></script>
    </head>
    <body>
    <div id="container">
    <H3>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://www.mikrokopter.de" target="_blank">MikroKopter.de</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://forum.mikrokopter.de" target="_blank">Forum</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
  </H3>
<div id="select"><form action="form.php?path=&amp;" method="post" id="projectform"><div><input type="hidden" name="selectproj" value="1" /><input type="hidden" name="op" value="form" /><input type="hidden" name="sc" value="0" /><select name="repname" onchange="javascript:this.form.submit();"><option value="BL-Ctrl">BL-Ctrl</option><option value="FlightCtrl" selected="selected">FlightCtrl</option><option value="MK3Mag">MK3Mag</option><option value="NaviCtrl">NaviCtrl</option><option value="Projects">Projects</option></select><span class="submit"><input type="submit" value="Go" /></span></div></form></div>
<h1><a href=".?sc=0" title="Project home">Subversion&nbsp;Repositories</a> <span>FlightCtrl</span></h1>
<h2 class="path" style="margin:0 2% 15px 2%;">[<a href="listing.php?repname=FlightCtrl&amp;path=%2F&amp;rev=0&amp;sc=0">/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2F&amp;rev=0&amp;sc=0">tags/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2F&amp;rev=0&amp;sc=0">V0.74d/</a>] [<b>twimaster.c</b>] - Rev 1226</h2>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftwimaster.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftwimaster.c&amp;rev=0&amp;sc=0">Blame</a></span> &#124;
<span class="diff"><a href="log.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftwimaster.c&amp;rev=0&amp;sc=0&amp;isdir=0">View&nbsp;Log</a></span>
</p>
    <div class="listing">
<code><PRE>
</code><code><I><FONT COLOR="#B22222">/*############################################################################
</code><code>############################################################################*/</FONT></I>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;main.h&quot;</FONT></B>
</code><code>
</code><code><B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> twi_state = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> motor = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> motorread = 0,MissingMotor = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> motor_rx[16],motor_rx2[16];
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> MotorPresent[MAX_MOTORS];
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> MotorError[MAX_MOTORS];
</code><code>
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I><I><FONT COLOR="#B22222">//Initzialisieren der I2C (TWI) Schnittstelle
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">i2c_init</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I>{
</code><code>  TWSR = 0;
</code><code>  TWBR = ((SYSCLK/SCL_CLOCK)-16)/2; 
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I><I><FONT COLOR="#B22222">//Start I2C
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">i2c_start</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>) 
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I>{
</code><code>    TWCR = (1&lt;&lt;TWSTA) | (1&lt;&lt;TWEN) | (1&lt;&lt;TWINT) | (1&lt;&lt;TWIE);
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">i2c_stop</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I>{
</code><code>    TWCR = (1&lt;&lt;TWEN) | (1&lt;&lt;TWSTO) | (1&lt;&lt;TWINT);
</code><code>}
</code><code>
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">i2c_reset</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I>{
</code><code>                 i2c_stop();                
</code><code>                 twi_state = 0;
</code><code>                 motor = TWDR;
</code><code>                 motor = 0;
</code><code>                 TWCR = 0x80;
</code><code>                 TWAMR = 0;
</code><code>                 TWAR = 0;
</code><code>                 TWDR = 0;
</code><code>                 TWSR = 0;
</code><code>                 TWBR = 0;
</code><code>                 i2c_init();
</code><code>                 i2c_start();
</code><code>                 i2c_write_byte(0);
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">i2c_write_byte</FONT></B>(<B><FONT COLOR="#228B22">char</FONT></B> byte)
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I>{ 
</code><code>    TWSR = 0x00;
</code><code>    TWDR = byte;
</code><code>    TWCR = (1&lt;&lt;TWINT) | (1&lt;&lt;TWEN) | (1&lt;&lt;TWIE);
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">/****************************************/</FONT></I>
</code><code><I><FONT COLOR="#B22222">/*    Write to I2C                      */</FONT></I>
</code><code><I><FONT COLOR="#B22222">/****************************************/</FONT></I>
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">I2C_WriteByte</FONT></B>(int8_t byte)
</code><code>{
</code><code>    <I><FONT COLOR="#B22222">// move byte to send into TWI Data Register
</code><code></FONT></I>    TWDR = byte;
</code><code>    <I><FONT COLOR="#B22222">// clear interrupt flag (TWINT = 1)
</code><code></FONT></I>    <I><FONT COLOR="#B22222">// enable i2c bus (TWEN = 1)
</code><code></FONT></I>    <I><FONT COLOR="#B22222">// enable interrupt (TWIE = 1)
</code><code></FONT></I>    TWCR = (1&lt;&lt;TWINT) | (1&lt;&lt;TWEN) | (1&lt;&lt;TWIE);
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">/****************************************/</FONT></I>
</code><code><I><FONT COLOR="#B22222">/*    Receive byte and send ACK         */</FONT></I>
</code><code><I><FONT COLOR="#B22222">/****************************************/</FONT></I>
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">I2C_ReceiveByte</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code>   TWCR = (1&lt;&lt;TWINT) | (1&lt;&lt;TWEN) | (1&lt;&lt;TWIE) | (1&lt;&lt;TWEA);
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">/****************************************/</FONT></I>
</code><code><I><FONT COLOR="#B22222">/* I2C receive last byte and send no ACK*/</FONT></I>
</code><code><I><FONT COLOR="#B22222">/****************************************/</FONT></I>
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">I2C_ReceiveLastByte</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code>   TWCR = (1&lt;&lt;TWINT) | (1&lt;&lt;TWEN) | (1&lt;&lt;TWIE);
</code><code>}
</code><code>
</code><code>
</code><code>
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I><B><FONT COLOR="#0000FF">SIGNAL</FONT></B> (TWI_vect)
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I>{
</code><code> <B><FONT COLOR="#228B22">static</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> missing_motor;
</code><code>     <B><FONT COLOR="#A020F0">switch</FONT></B>(twi_state++)
</code><code>        {
</code><code><I><FONT COLOR="#B22222">//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">// Writing the Data
</code><code></FONT></I><I><FONT COLOR="#B22222">//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">0</FONT></B>:
</code><code>                        <B><FONT COLOR="#A020F0">while</FONT></B>(Mixer.Motor[motor][0] &lt;= 0 &amp;&amp; motor &lt; MAX_MOTORS) motor++;  <I><FONT COLOR="#B22222">// skip if not used
</code><code></FONT></I>                                <B><FONT COLOR="#A020F0">if</FONT></B>(motor == MAX_MOTORS)  <I><FONT COLOR="#B22222">// writing finished -&gt; now read 
</code><code></FONT></I>                                { 
</code><code>                                 motor = 0; 
</code><code>                                 twi_state = 3; 
</code><code>                                 i2c_write_byte(0x53+(motorread*2));
</code><code>                                 } 
</code><code>                                <B><FONT COLOR="#A020F0">else</FONT></B> i2c_write_byte(0x52+(motor*2));
</code><code>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">1</FONT></B>:
</code><code>                i2c_write_byte(Motor[motor++]);
</code><code>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">2</FONT></B>:
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B>(TWSR == 0x30) { <B><FONT COLOR="#A020F0">if</FONT></B>(!missing_motor) missing_motor = motor; <B><FONT COLOR="#A020F0">if</FONT></B>(++MotorError[motor-1] == 0) MotorError[motor-1] = 255;}
</code><code>                i2c_stop();
</code><code>                I2CTimeout = 10;
</code><code>                twi_state = 0;
</code><code>                i2c_start();   
</code><code>                <B><FONT COLOR="#A020F0">break</FONT></B>; 
</code><code><I><FONT COLOR="#B22222">//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">// Reading Data
</code><code></FONT></I><I><FONT COLOR="#B22222">//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">3</FONT></B>:
</code><code>               <I><FONT COLOR="#B22222">//Transmit 1st byte for reading
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">if</FONT></B>(TWSR != 0x40)  <I><FONT COLOR="#B22222">// Error?
</code><code></FONT></I>                 { 
</code><code>                  MotorPresent[motorread] = 0;
</code><code>                  motorread++; 
</code><code>                  <B><FONT COLOR="#A020F0">if</FONT></B>(motorread &gt;= MAX_MOTORS) motorread = 0;
</code><code>                  i2c_stop();
</code><code>                  twi_state = 0;
</code><code>                 }
</code><code>                 <B><FONT COLOR="#A020F0">else</FONT></B> 
</code><code>                 {
</code><code>                  MotorPresent[motorread] = (<B><FONT COLOR="#BC8F8F">'1'</FONT></B> - <B><FONT COLOR="#BC8F8F">'-'</FONT></B>) + motorread;
</code><code>                  I2C_ReceiveByte();
</code><code>                 }
</code><code>                MissingMotor = missing_motor;
</code><code>                missing_motor = 0;
</code><code>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">4</FONT></B>: <I><FONT COLOR="#B22222">//Read 1st byte and transmit 2nd Byte
</code><code></FONT></I>                motor_rx[motorread] = TWDR;
</code><code>                I2C_ReceiveLastByte(); <I><FONT COLOR="#B22222">//nack
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">5</FONT></B>:
</code><code>                <I><FONT COLOR="#B22222">//Read 2nd byte
</code><code></FONT></I>                motor_rx2[motorread++] = TWDR;
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B>(motorread &gt;= MAX_MOTORS) motorread = 0;
</code><code>                i2c_stop();
</code><code>                twi_state = 0;
</code><code>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>                        
</code><code><I><FONT COLOR="#B22222">//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">// writing Gyro-Offset
</code><code></FONT></I><I><FONT COLOR="#B22222">//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">8</FONT></B>: 
</code><code>                i2c_write_byte(0x98); <I><FONT COLOR="#B22222">// Address of the DAC
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">9</FONT></B>: 
</code><code>                i2c_write_byte(0x10); <I><FONT COLOR="#B22222">// Update Channel A
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">10</FONT></B>: 
</code><code>                i2c_write_byte(AnalogOffsetNick); <I><FONT COLOR="#B22222">// Value
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">11</FONT></B>: 
</code><code>                i2c_write_byte(0x80); <I><FONT COLOR="#B22222">// Value
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">12</FONT></B>: 
</code><code>                i2c_stop();               
</code><code>                I2CTimeout = 10;
</code><code>                i2c_start();   
</code><code>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">13</FONT></B>: 
</code><code>                i2c_write_byte(0x98); <I><FONT COLOR="#B22222">// Address of the DAC
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">14</FONT></B>: 
</code><code>                i2c_write_byte(0x12); <I><FONT COLOR="#B22222">// Update Channel B
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">15</FONT></B>: 
</code><code>                i2c_write_byte(AnalogOffsetRoll); <I><FONT COLOR="#B22222">// Value
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">16</FONT></B>: 
</code><code>                i2c_write_byte(0x80); <I><FONT COLOR="#B22222">// Value
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">17</FONT></B>: 
</code><code>                i2c_stop();               
</code><code>                I2CTimeout = 10;
</code><code>                i2c_start();   
</code><code>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">18</FONT></B>: 
</code><code>                i2c_write_byte(0x98); <I><FONT COLOR="#B22222">// Address of the DAC
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">19</FONT></B>: 
</code><code>                i2c_write_byte(0x14); <I><FONT COLOR="#B22222">// Update Channel C
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">20</FONT></B>: 
</code><code>                i2c_write_byte(AnalogOffsetGier); <I><FONT COLOR="#B22222">// Value
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">21</FONT></B>: 
</code><code>                i2c_write_byte(0x80); <I><FONT COLOR="#B22222">// Value
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">22</FONT></B>: 
</code><code>                i2c_stop();               
</code><code>                I2CTimeout = 10;
</code><code>                twi_state = 0;
</code><code>                <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>        <B><FONT COLOR="#5F9EA0">default</FONT></B>: twi_state = 0;
</code><code>                <B><FONT COLOR="#A020F0">break</FONT></B>;        
</code><code>                }
</code><code> TWCR |= 0x80;
</code><code>}
</code><code></PRE>
</code><code></code>    </div>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftwimaster.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftwimaster.c&amp;rev=0&amp;sc=0">Blame</a></span>
</p>
  </div>
  <div id="footer">
    <p style="padding:0; margin:0"><small>powered by: <a href="http://websvn.tigris.org">WebSVN 2.0</a></small></p>
  </div>
</body>
</html>
