<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="content-type" content="text/html;charset=UTF-8" />
    <meta http-equiv="generator" content="WebSVN 2.0" /> <!-- leave this for stats -->
    <link rel="shortcut icon" type="image/x-icon" href="./templates/calm/images/favicon.ico" />
    <link type="text/css" href="./templates/calm/styles.css" rel="stylesheet" media="screen" />
    <link type="text/css" href="./templates/calm/star-light/star-light.css" rel="stylesheet" media="screen" />
    <!--[if gte IE 5.5000]>
    <script type="text/javascript" src="./templates/calm/png.js"></script>
    <style type="text/css" media="screen">
    tbody tr td { padding:1px 0 }
    #wrap h2 { padding:10px 5px 0 5px; margin-bottom:-8px }
    </style>
    <![endif]-->
    <title>
         MikroKopter - WebSVN
            - FlightCtrl
               - Rev 1226
            - /tags/V0.74d/twimaster.h
    </title>
    <script type="text/javascript">
    //<![CDATA[
         function getPath()
         {
         	return '.';
         }
         
         function checkCB(chBox)
         {
            count = 0
            first = null
            f = chBox.form
            for (i = 0 ; i < f.elements.length ; i++)
            if (f.elements[i].type == 'checkbox' && f.elements[i].checked)
            {
               if (first == null && f.elements[i] != chBox)
                  first = f.elements[i]
               count += 1
            }
            
            if (count > 2) 
            {
               first.checked = false
               count -= 1
            }
         }
    //]]>
    </script>
    <script type="text/javascript" src="./templates/calm/collapse.js"></script>
    </head>
    <body>
    <div id="container">
    <H3>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://www.mikrokopter.de" target="_blank">MikroKopter.de</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://forum.mikrokopter.de" target="_blank">Forum</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
  </H3>
<div id="select"><form action="form.php?path=&amp;" method="post" id="projectform"><div><input type="hidden" name="selectproj" value="1" /><input type="hidden" name="op" value="form" /><input type="hidden" name="sc" value="0" /><select name="repname" onchange="javascript:this.form.submit();"><option value="BL-Ctrl">BL-Ctrl</option><option value="FlightCtrl" selected="selected">FlightCtrl</option><option value="MK3Mag">MK3Mag</option><option value="NaviCtrl">NaviCtrl</option><option value="Projects">Projects</option></select><span class="submit"><input type="submit" value="Go" /></span></div></form></div>
<h1><a href=".?sc=0" title="Project home">Subversion&nbsp;Repositories</a> <span>FlightCtrl</span></h1>
<h2 class="path" style="margin:0 2% 15px 2%;">[<a href="listing.php?repname=FlightCtrl&amp;path=%2F&amp;rev=0&amp;sc=0">/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2F&amp;rev=0&amp;sc=0">tags/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2F&amp;rev=0&amp;sc=0">V0.74d/</a>] [<b>twimaster.h</b>] - Rev 1226</h2>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftwimaster.h&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftwimaster.h&amp;rev=0&amp;sc=0">Blame</a></span> &#124;
<span class="diff"><a href="log.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftwimaster.h&amp;rev=0&amp;sc=0&amp;isdir=0">View&nbsp;Log</a></span>
</p>
    <div class="listing">
<code><PRE>
</code><code><I><FONT COLOR="#B22222">/*############################################################################
</code><code>############################################################################*/</FONT></I>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">_I2C_MASTER_H</FONT>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">_I2C_MASTER_H</FONT>
</code><code>
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I>
</code><code><I><FONT COLOR="#B22222">// I2C Konstanten
</code><code></FONT></I>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SCL_CLOCK</FONT>  200000L
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">I2C_TIMEOUT</FONT> 30000
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">I2C_START</FONT>          0x08
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">I2C_REPEATED_START</FONT> 0x10
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">I2C_TX_SLA_ACK</FONT>     0x18
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">I2C_TX_DATA_ACK</FONT>    0x28
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">I2C_RX_SLA_ACK</FONT>     0x40
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">I2C_RX_DATA_ACK</FONT>    0x50
</code><code>
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I>
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> twi_state;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> motor,MissingMotor;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> motorread;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> motor_rx[];
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> MotorPresent[];
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> MotorError[];
</code><code>
</code><code><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">i2c_reset</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">i2c_init</FONT></B> (<B><FONT COLOR="#228B22">void</FONT></B>); <I><FONT COLOR="#B22222">// I2C initialisieren
</code><code></FONT></I><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">i2c_start</FONT></B> (<B><FONT COLOR="#228B22">void</FONT></B>); <I><FONT COLOR="#B22222">// Start I2C
</code><code></FONT></I><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">i2c_stop</FONT></B> (<B><FONT COLOR="#228B22">void</FONT></B>); <I><FONT COLOR="#B22222">// Stop I2C
</code><code></FONT></I><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">i2c_write_byte</FONT></B> (<B><FONT COLOR="#228B22">char</FONT></B> byte); <I><FONT COLOR="#B22222">// 1 Byte schreiben
</code><code></FONT></I><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">i2c_reset</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code></PRE>
</code><code></code>    </div>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftwimaster.h&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Ftwimaster.h&amp;rev=0&amp;sc=0">Blame</a></span>
</p>
  </div>
  <div id="footer">
    <p style="padding:0; margin:0"><small>powered by: <a href="http://websvn.tigris.org">WebSVN 2.0</a></small></p>
  </div>
</body>
</html>
