<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="content-type" content="text/html;charset=UTF-8" />
    <meta http-equiv="generator" content="WebSVN 2.0" /> <!-- leave this for stats -->
    <link rel="shortcut icon" type="image/x-icon" href="./templates/calm/images/favicon.ico" />
    <link type="text/css" href="./templates/calm/styles.css" rel="stylesheet" media="screen" />
    <link type="text/css" href="./templates/calm/star-light/star-light.css" rel="stylesheet" media="screen" />
    <!--[if gte IE 5.5000]>
    <script type="text/javascript" src="./templates/calm/png.js"></script>
    <style type="text/css" media="screen">
    tbody tr td { padding:1px 0 }
    #wrap h2 { padding:10px 5px 0 5px; margin-bottom:-8px }
    </style>
    <![endif]-->
    <title>
         MikroKopter - WebSVN
            - FlightCtrl
               - Rev 1226
            - /tags/V0.74d/Spectrum.c
    </title>
    <script type="text/javascript">
    //<![CDATA[
         function getPath()
         {
         	return '.';
         }
         
         function checkCB(chBox)
         {
            count = 0
            first = null
            f = chBox.form
            for (i = 0 ; i < f.elements.length ; i++)
            if (f.elements[i].type == 'checkbox' && f.elements[i].checked)
            {
               if (first == null && f.elements[i] != chBox)
                  first = f.elements[i]
               count += 1
            }
            
            if (count > 2) 
            {
               first.checked = false
               count -= 1
            }
         }
    //]]>
    </script>
    <script type="text/javascript" src="./templates/calm/collapse.js"></script>
    </head>
    <body>
    <div id="container">
    <H3>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://www.mikrokopter.de" target="_blank">MikroKopter.de</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://forum.mikrokopter.de" target="_blank">Forum</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
  </H3>
<div id="select"><form action="form.php?path=&amp;" method="post" id="projectform"><div><input type="hidden" name="selectproj" value="1" /><input type="hidden" name="op" value="form" /><input type="hidden" name="sc" value="0" /><select name="repname" onchange="javascript:this.form.submit();"><option value="BL-Ctrl">BL-Ctrl</option><option value="FlightCtrl" selected="selected">FlightCtrl</option><option value="MK3Mag">MK3Mag</option><option value="NaviCtrl">NaviCtrl</option><option value="Projects">Projects</option></select><span class="submit"><input type="submit" value="Go" /></span></div></form></div>
<h1><a href=".?sc=0" title="Project home">Subversion&nbsp;Repositories</a> <span>FlightCtrl</span></h1>
<h2 class="path" style="margin:0 2% 15px 2%;">[<a href="listing.php?repname=FlightCtrl&amp;path=%2F&amp;rev=0&amp;sc=0">/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2F&amp;rev=0&amp;sc=0">tags/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2F&amp;rev=0&amp;sc=0">V0.74d/</a>] [<b>Spectrum.c</b>] - Rev 1226</h2>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2FSpectrum.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2FSpectrum.c&amp;rev=0&amp;sc=0">Blame</a></span> &#124;
<span class="diff"><a href="log.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2FSpectrum.c&amp;rev=0&amp;sc=0&amp;isdir=0">View&nbsp;Log</a></span>
</p>
    <div class="listing">
<code><PRE>
</code><code><I><FONT COLOR="#B22222">/*#######################################################################################
</code><code>Decodieren eines RC Summen Signals oder Spektrum Empfnger-Satellit
</code><code>#######################################################################################*/</FONT></I>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;Spectrum.h&quot;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;main.h&quot;</FONT></B>
</code><code>
</code><code><I><FONT COLOR="#B22222">//--------------------------------------------------------------//
</code><code></FONT></I>
</code><code><I><FONT COLOR="#B22222">//--------------------------------------------------------------//
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">SpektrumBinding</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code>  <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> timerTimeout = SetDelay(10000);  <I><FONT COLOR="#B22222">// Timeout 10 sec.
</code><code></FONT></I>  <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> connected = 0;
</code><code>  <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> delaycounter;
</code><code>  
</code><code>  UCSR1B &amp;= ~(1 &lt;&lt; RXCIE1);  <I><FONT COLOR="#B22222">// disable rx-interrupt
</code><code></FONT></I>  UCSR1B &amp;= ~(1&lt;&lt;RXEN1);     <I><FONT COLOR="#B22222">// disable Uart-Rx
</code><code></FONT></I>  PORTD &amp;= ~(1 &lt;&lt; PORTD2);   <I><FONT COLOR="#B22222">// disable pull-up
</code><code></FONT></I>  
</code><code>  printf(<B><FONT COLOR="#BC8F8F">&quot;\n\rPlease connect Spektrum receiver for binding NOW...&quot;</FONT></B>);
</code><code>  
</code><code>  <B><FONT COLOR="#A020F0">while</FONT></B>(!CheckDelay(timerTimeout))
</code><code>  {
</code><code>    <B><FONT COLOR="#A020F0">if</FONT></B> (PIND &amp; (1 &lt;&lt; PORTD2)) { timerTimeout = SetDelay(90); connected = 1; <B><FONT COLOR="#A020F0">break</FONT></B>; }
</code><code>  }
</code><code>  
</code><code>  <B><FONT COLOR="#A020F0">if</FONT></B> (connected) 
</code><code>  { 
</code><code>    
</code><code>    printf(<B><FONT COLOR="#BC8F8F">&quot;ok.\n\r&quot;</FONT></B>); 
</code><code>    DDRD |= (1 &lt;&lt; DDD2);     <I><FONT COLOR="#B22222">// Rx as output
</code><code></FONT></I>
</code><code>        <B><FONT COLOR="#A020F0">while</FONT></B>(!CheckDelay(timerTimeout));  <I><FONT COLOR="#B22222">// delay after startup of RX
</code><code></FONT></I>        <B><FONT COLOR="#A020F0">for</FONT></B> (delaycounter = 0; delaycounter &lt; 100; delaycounter++) PORTD |= (1 &lt;&lt; PORTD2);
</code><code>        <B><FONT COLOR="#A020F0">for</FONT></B> (delaycounter = 0; delaycounter &lt; 400; delaycounter++) PORTD &amp;= ~(1 &lt;&lt; PORTD2);
</code><code>        
</code><code>        <B><FONT COLOR="#A020F0">for</FONT></B> (delaycounter = 0; delaycounter &lt; 10; delaycounter++) PORTD |= (1 &lt;&lt; PORTD2);
</code><code>    <B><FONT COLOR="#A020F0">for</FONT></B> (delaycounter = 0; delaycounter &lt; 10; delaycounter++) PORTD &amp;= ~(1 &lt;&lt; PORTD2);
</code><code>        <B><FONT COLOR="#A020F0">for</FONT></B> (delaycounter = 0; delaycounter &lt; 400; delaycounter++) PORTD |= (1 &lt;&lt; PORTD2);
</code><code>        <B><FONT COLOR="#A020F0">for</FONT></B> (delaycounter = 0; delaycounter &lt; 400; delaycounter++) PORTD &amp;= ~(1 &lt;&lt; PORTD2);
</code><code>     
</code><code>        <B><FONT COLOR="#A020F0">for</FONT></B> (delaycounter = 0; delaycounter &lt; 10; delaycounter++) PORTD |= (1 &lt;&lt; PORTD2);
</code><code>    <B><FONT COLOR="#A020F0">for</FONT></B> (delaycounter = 0; delaycounter &lt; 10; delaycounter++) PORTD &amp;= ~(1 &lt;&lt; PORTD2);
</code><code>        <B><FONT COLOR="#A020F0">for</FONT></B> (delaycounter = 0; delaycounter &lt; 400; delaycounter++) PORTD |= (1 &lt;&lt; PORTD2);
</code><code>        <B><FONT COLOR="#A020F0">for</FONT></B> (delaycounter = 0; delaycounter &lt; 400; delaycounter++) PORTD &amp;= ~(1 &lt;&lt; PORTD2);
</code><code>
</code><code>        <B><FONT COLOR="#A020F0">for</FONT></B> (delaycounter = 0; delaycounter &lt; 10; delaycounter++) PORTD |= (1 &lt;&lt; PORTD2);
</code><code>    <B><FONT COLOR="#A020F0">for</FONT></B> (delaycounter = 0; delaycounter &lt; 10; delaycounter++) PORTD &amp;= ~(1 &lt;&lt; PORTD2);
</code><code>        <B><FONT COLOR="#A020F0">for</FONT></B> (delaycounter = 0; delaycounter &lt; 400; delaycounter++) PORTD |= (1 &lt;&lt; PORTD2);
</code><code>  
</code><code>  }
</code><code>   <B><FONT COLOR="#A020F0">else</FONT></B> 
</code><code>  { printf(<B><FONT COLOR="#BC8F8F">&quot;Timeout.\n\r&quot;</FONT></B>); 
</code><code>  
</code><code>  
</code><code>  }
</code><code>   
</code><code>  DDRD &amp;= ~(1 &lt;&lt; DDD2);      <I><FONT COLOR="#B22222">// RX as input
</code><code></FONT></I>  PORTD &amp;= ~(1 &lt;&lt; PORTD2);   
</code><code>
</code><code>  Uart1Init();    <I><FONT COLOR="#B22222">// init Uart again
</code><code></FONT></I>}
</code><code>
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I><I><FONT COLOR="#B22222">// zum Decodieren des Spektrum Satelliten wird USART1 benutzt.
</code><code></FONT></I><I><FONT COLOR="#B22222">// USART1 initialisation from killagreg
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">Uart1Init</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I>    {
</code><code>        <I><FONT COLOR="#B22222">// -- Start of USART1 initialisation for Spekturm seriell-mode
</code><code></FONT></I>        <I><FONT COLOR="#B22222">// USART1 Control and Status Register A, B, C and baud rate register
</code><code></FONT></I>        uint16_t ubrr = (uint16_t) ((uint32_t) SYSCLK/(8 * 115200) - 1);
</code><code>        <I><FONT COLOR="#B22222">// disable RX-Interrupt
</code><code></FONT></I>        UCSR1B &amp;= ~(1 &lt;&lt; RXCIE1);
</code><code>        <I><FONT COLOR="#B22222">// disable TX-Interrupt
</code><code></FONT></I>        UCSR1B &amp;= ~(1 &lt;&lt; TXCIE1);
</code><code>        <I><FONT COLOR="#B22222">// disable DRE-Interrupt
</code><code></FONT></I>        UCSR1B &amp;= ~(1 &lt;&lt; UDRIE1);
</code><code>        <I><FONT COLOR="#B22222">// set direction of RXD1 and TXD1 pins
</code><code></FONT></I>        <I><FONT COLOR="#B22222">// set RXD1 (PD2) as an input pin
</code><code></FONT></I>        PORTD |= (1 &lt;&lt; PORTD2);
</code><code>        DDRD &amp;= ~(1 &lt;&lt; DDD2);
</code><code>        <I><FONT COLOR="#B22222">// USART0 Baud Rate Register
</code><code></FONT></I>        <I><FONT COLOR="#B22222">// set clock divider
</code><code></FONT></I>        
</code><code>        UBRR1H = (uint8_t)(ubrr&gt;&gt;8);
</code><code>        UBRR1L = (uint8_t)ubrr;
</code><code>        <I><FONT COLOR="#B22222">// enable double speed operation
</code><code></FONT></I>        UCSR1A |= (1 &lt;&lt; U2X1);
</code><code>        <I><FONT COLOR="#B22222">// enable receiver and transmitter
</code><code></FONT></I>        <I><FONT COLOR="#B22222">//UCSR1B = (1&lt;&lt;RXEN1)|(1&lt;&lt;TXEN1);
</code><code></FONT></I>
</code><code>
</code><code>        
</code><code>        
</code><code>        UCSR1B = (1&lt;&lt;RXEN1);
</code><code>        <I><FONT COLOR="#B22222">// set asynchronous mode
</code><code></FONT></I>        UCSR1C &amp;= ~(1 &lt;&lt; UMSEL11);
</code><code>        UCSR1C &amp;= ~(1 &lt;&lt; UMSEL10);
</code><code>        <I><FONT COLOR="#B22222">// no parity
</code><code></FONT></I>        UCSR1C &amp;= ~(1 &lt;&lt; UPM11);
</code><code>        UCSR1C &amp;= ~(1 &lt;&lt; UPM10);
</code><code>        <I><FONT COLOR="#B22222">// 1 stop bit
</code><code></FONT></I>        UCSR1C &amp;= ~(1 &lt;&lt; USBS1);
</code><code>        <I><FONT COLOR="#B22222">// 8-bit
</code><code></FONT></I>        UCSR1B &amp;= ~(1 &lt;&lt; UCSZ12);
</code><code>        UCSR1C |=  (1 &lt;&lt; UCSZ11);
</code><code>        UCSR1C |=  (1 &lt;&lt; UCSZ10);
</code><code>        <I><FONT COLOR="#B22222">// flush receive buffer explicit
</code><code></FONT></I>        <B><FONT COLOR="#A020F0">while</FONT></B>(UCSR1A &amp; (1&lt;&lt;RXC1)) UDR1;
</code><code>        <I><FONT COLOR="#B22222">// enable RX-interrupts at the end
</code><code></FONT></I>        UCSR1B |= (1 &lt;&lt; RXCIE1);
</code><code>        <I><FONT COLOR="#B22222">// -- End of USART1 initialisation
</code><code></FONT></I>  <B><FONT COLOR="#A020F0">return</FONT></B>;
</code><code> }
</code><code>        
</code><code><I><FONT COLOR="#B22222">// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">// + Copyright (c) Rainer Walther
</code><code></FONT></I><I><FONT COLOR="#B22222">// + RC-routines from original MK rc.c (c) H&amp;I
</code><code></FONT></I><I><FONT COLOR="#B22222">// + Useful infos from Walter: http://www.rcgroups.com/forums/showthread.php?t=714299&amp;page=2
</code><code></FONT></I><I><FONT COLOR="#B22222">// + only for non-profit use
</code><code></FONT></I><I><FONT COLOR="#B22222">// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">//
</code><code></FONT></I><I><FONT COLOR="#B22222">// 20080808 rw Modified for Spektrum AR6100 (PPM)
</code><code></FONT></I><I><FONT COLOR="#B22222">// 20080823 rw Add Spektrum satellite receiver on USART1 (644P only)
</code><code></FONT></I><I><FONT COLOR="#B22222">// 20081213 rw Add support for Spektrum DS9 Air-Tx-Module (9 channels)
</code><code></FONT></I><I><FONT COLOR="#B22222">//             Replace AR6100-coding with original composit-signal routines
</code><code></FONT></I><I><FONT COLOR="#B22222">//
</code><code></FONT></I><I><FONT COLOR="#B22222">// ---
</code><code></FONT></I><I><FONT COLOR="#B22222">// Entweder Summensignal ODER Spektrum-Receiver anschlieen. Nicht beides gleichzeitig betreiben!
</code><code></FONT></I><I><FONT COLOR="#B22222">// Binding is not implemented. Bind with external Receiver.
</code><code></FONT></I><I><FONT COLOR="#B22222">// Servo output J3, J4, J5 not serviced
</code><code></FONT></I><I><FONT COLOR="#B22222">//
</code><code></FONT></I><I><FONT COLOR="#B22222">// Anschu Spektrum Receiver
</code><code></FONT></I><I><FONT COLOR="#B22222">//              Orange:         3V von der FC (keinesfalls an 5V anschlieen!)
</code><code></FONT></I><I><FONT COLOR="#B22222">//              Schwarz:        GND
</code><code></FONT></I><I><FONT COLOR="#B22222">//              Grau:           RXD1 (Pin 3) auf 10-Pol FC-Stecker
</code><code></FONT></I><I><FONT COLOR="#B22222">//
</code><code></FONT></I><I><FONT COLOR="#B22222">// ---
</code><code></FONT></I><I><FONT COLOR="#B22222">// Satellite-Reciever connected on USART1:
</code><code></FONT></I><I><FONT COLOR="#B22222">//
</code><code></FONT></I><I><FONT COLOR="#B22222">// DX7/DX6i: One data-frame at 115200 baud every 22ms.
</code><code></FONT></I><I><FONT COLOR="#B22222">// DX7se:    One data-frame at 115200 baud every 11ms.
</code><code></FONT></I><I><FONT COLOR="#B22222">//              byte1:  unknown
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte2:  unknown
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte3:  and byte4:  channel data        (FLT-Mode)
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte5:  and byte6:  channel data        (Roll)
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte7:  and byte8:  channel data        (Nick)
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte9:  and byte10: channel data        (Gier)
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte11: and byte12: channel data        (Gear Switch)
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte13: and byte14: channel data        (Gas)
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte15: and byte16: channel data        (AUX2)
</code><code></FONT></I><I><FONT COLOR="#B22222">//
</code><code></FONT></I><I><FONT COLOR="#B22222">// DS9 (9 Channel): One data-frame at 115200 baud every 11ms, alternating frame 1/2 for CH1-7 / CH8-9
</code><code></FONT></I><I><FONT COLOR="#B22222">//  1st Frame:
</code><code></FONT></I><I><FONT COLOR="#B22222">//              byte1:  unknown
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte2:  unknown
</code><code></FONT></I><I><FONT COLOR="#B22222">//              byte3:  and byte4:  channel data
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte5:  and byte6:  channel data
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte7:  and byte8:  channel data
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte9:  and byte10: channel data
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte11: and byte12: channel data
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte13: and byte14: channel data
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte15: and byte16: channel data 
</code><code></FONT></I><I><FONT COLOR="#B22222">//  2nd Frame:
</code><code></FONT></I><I><FONT COLOR="#B22222">//              byte1:  unknown
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte2:  unknown
</code><code></FONT></I><I><FONT COLOR="#B22222">//              byte3:  and byte4:  channel data
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte5:  and byte6:  channel data
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte7:  and byte8:  0xffff
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte9:  and byte10: 0xffff
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte11: and byte12: 0xffff
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte13: and byte14: 0xffff
</code><code></FONT></I><I><FONT COLOR="#B22222">//      byte15: and byte16: 0xffff
</code><code></FONT></I><I><FONT COLOR="#B22222">//
</code><code></FONT></I><I><FONT COLOR="#B22222">// Each channel data (16 bit= 2byte, first msb, second lsb) is arranged as:
</code><code></FONT></I><I><FONT COLOR="#B22222">//
</code><code></FONT></I><I><FONT COLOR="#B22222">// Bits: F 0 C3 C2 C1 C0 D9 D8 D7 D6 D5 D4 D3 D2 D1 D0
</code><code></FONT></I><I><FONT COLOR="#B22222">//
</code><code></FONT></I><I><FONT COLOR="#B22222">// 0 means a '0' bit
</code><code></FONT></I><I><FONT COLOR="#B22222">// F: 1 = indicates beginning of 2nd frame for CH8-9 (DS9 only)
</code><code></FONT></I><I><FONT COLOR="#B22222">// C3 to C0 is the channel number. 0 to 9 (4 bit, as assigned in the transmitter)
</code><code></FONT></I><I><FONT COLOR="#B22222">// D9 to D0 is the channel data (10 bit) 0xaa..0x200..0x356 for 100% transmitter-travel
</code><code></FONT></I><I><FONT COLOR="#B22222">//
</code><code></FONT></I><I><FONT COLOR="#B22222">// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I>
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I><I><FONT COLOR="#B22222">//Diese Routine startet und inizialisiert den USART1 fr seriellen Spektrum satellite reciever
</code><code></FONT></I><B><FONT COLOR="#0000FF">SIGNAL</FONT></B>(USART1_RX_vect)
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I>{
</code><code><B><FONT COLOR="#228B22">static</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> Sync=0, FrameCnt=0, ByteHigh=0, ReSync=1, Frame2=0, FrameTimer;
</code><code>        <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> Channel, index;
</code><code>        <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> signal, tmp;
</code><code>        <B><FONT COLOR="#228B22">int</FONT></B> bCheckDelay;
</code><code>        uint8_t c;
</code><code>        
</code><code>        c = UDR1; <I><FONT COLOR="#B22222">// get data byte
</code><code></FONT></I>        
</code><code>        <B><FONT COLOR="#A020F0">if</FONT></B> (ReSync == 1)
</code><code>            {
</code><code>                <I><FONT COLOR="#B22222">// wait for beginning of new frame
</code><code></FONT></I>                ReSync = 0;
</code><code>                
</code><code>                FrameTimer = SetDelay(7);  <I><FONT COLOR="#B22222">// minimum 7ms zwischen den frames
</code><code></FONT></I>                FrameCnt = 0;
</code><code>                Sync = 0;
</code><code>                ByteHigh = 0;
</code><code>                }
</code><code>  <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>  {     
</code><code>        bCheckDelay = CheckDelay(FrameTimer);
</code><code>        <B><FONT COLOR="#A020F0">if</FONT></B> ( Sync == 0 )
</code><code>            {
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B>(bCheckDelay)
</code><code>                    {
</code><code>                        <I><FONT COLOR="#B22222">// nach einer Pause von mind. 7ms erstes Sync-Character gefunden
</code><code></FONT></I>                        <I><FONT COLOR="#B22222">// Zeichen ignorieren, da Bedeutung unbekannt
</code><code></FONT></I>                        Sync = 1;
</code><code>                        FrameCnt ++;
</code><code>                        }
</code><code>                <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>                        {
</code><code>                        <I><FONT COLOR="#B22222">// Zeichen kam vor Ablauf der 7ms Sync-Pause
</code><code></FONT></I>                        <I><FONT COLOR="#B22222">// warten auf erstes Sync-Zeichen
</code><code></FONT></I>                        }
</code><code>                }
</code><code>        <B><FONT COLOR="#A020F0">else</FONT></B> <B><FONT COLOR="#A020F0">if</FONT></B>((Sync == 1) &amp;&amp; !bCheckDelay)
</code><code>            {
</code><code>                <I><FONT COLOR="#B22222">// zweites Sync-Character ignorieren, Bedeutung unbekannt
</code><code></FONT></I>                Sync = 2;
</code><code>                FrameCnt ++;
</code><code>                }
</code><code>        <B><FONT COLOR="#A020F0">else</FONT></B> <B><FONT COLOR="#A020F0">if</FONT></B>((Sync == 2) &amp;&amp; !bCheckDelay)
</code><code>            {
</code><code>                <I><FONT COLOR="#B22222">// Datenbyte high
</code><code></FONT></I>                ByteHigh = c;
</code><code>                
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B> (FrameCnt == 2)
</code><code>                    {
</code><code>                    <I><FONT COLOR="#B22222">// is 1st Byte of Channel-data
</code><code></FONT></I>                        <I><FONT COLOR="#B22222">// Frame 1 with Channel 1-7 comming next
</code><code></FONT></I>                        Frame2 = 0;
</code><code>                        <B><FONT COLOR="#A020F0">if</FONT></B>(ByteHigh &amp; 0x80)
</code><code>                            {
</code><code>                                <I><FONT COLOR="#B22222">// DS9: Frame 2 with Channel 8-9 comming next
</code><code></FONT></I>                                Frame2 = 1;
</code><code>                                }
</code><code>                        }       
</code><code>                Sync = 3;
</code><code>                FrameCnt ++;
</code><code>                }
</code><code>        <B><FONT COLOR="#A020F0">else</FONT></B> <B><FONT COLOR="#A020F0">if</FONT></B>((Sync == 3) &amp;&amp; !bCheckDelay)
</code><code>            {
</code><code>                <I><FONT COLOR="#B22222">// Datenbyte low
</code><code></FONT></I>                
</code><code>                <I><FONT COLOR="#B22222">// High-Byte for next channel comes next
</code><code></FONT></I>                Sync = 2;
</code><code>                FrameCnt ++;
</code><code>                
</code><code>                index = (ByteHigh &gt;&gt; 2) &amp; 0x0f;
</code><code>                index ++;
</code><code>                Channel = (ByteHigh &lt;&lt; 8) | c;
</code><code>                signal = Channel &amp; 0x3ff;
</code><code>                signal -= 0x200;                <I><FONT COLOR="#B22222">// Offset, range 0x000..0x3ff?
</code><code></FONT></I>                signal = signal/3;              <I><FONT COLOR="#B22222">// scaling to fit PPM resolution
</code><code></FONT></I>                
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B>(index &gt;= 0  &amp;&amp;  index &lt;= 10)
</code><code>                    {
</code><code>                <I><FONT COLOR="#B22222">// Stabiles Signal
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">if</FONT></B>(abs(signal - PPM_in[index]) &lt; 6) { <B><FONT COLOR="#A020F0">if</FONT></B>(SenderOkay &lt; 200) SenderOkay += 10; <B><FONT COLOR="#A020F0">else</FONT></B> SenderOkay = 200;}
</code><code>                tmp = (3 * (PPM_in[index]) + signal) / 4;   
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B>(tmp &gt; signal+1) tmp--; <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B>(tmp &lt; signal-1) tmp++; 
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B>(SenderOkay &gt;= 180)  PPM_diff[index] = ((tmp - PPM_in[index]) / 3) * 3; 
</code><code>                <B><FONT COLOR="#A020F0">else</FONT></B> PPM_diff[index] = 0;
</code><code>                PPM_in[index] = tmp;
</code><code>                        }
</code><code>                }
</code><code>        <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>                {
</code><code>                <I><FONT COLOR="#B22222">// hier stimmt was nicht: neu synchronisieren
</code><code></FONT></I>                ReSync = 1;
</code><code>                FrameCnt = 0;
</code><code>                Frame2 = 0;
</code><code>                }
</code><code>                
</code><code>        <I><FONT COLOR="#B22222">// 16 Bytes per frame
</code><code></FONT></I>        <B><FONT COLOR="#A020F0">if</FONT></B>(FrameCnt &gt;= 16)
</code><code>            {
</code><code>                <I><FONT COLOR="#B22222">// Frame complete
</code><code></FONT></I>                <B><FONT COLOR="#A020F0">if</FONT></B>(Frame2 == 0)
</code><code>                        {
</code><code>                        <I><FONT COLOR="#B22222">// Null bedeutet: Neue Daten
</code><code></FONT></I>                        <I><FONT COLOR="#B22222">// nur beim ersten Frame (CH 0-7) setzen
</code><code></FONT></I>                        NewPpmData = 0;  
</code><code>                        }
</code><code>                
</code><code>                <I><FONT COLOR="#B22222">// new frame next, nach fruehestens 7ms erwartet
</code><code></FONT></I>                FrameCnt = 0;
</code><code>                Frame2 = 0;
</code><code>                Sync = 0;
</code><code>                }
</code><code>        <I><FONT COLOR="#B22222">// Zeit bis zum nchsten Zeichen messen
</code><code></FONT></I>        FrameTimer = SetDelay(7);
</code><code>   }
</code><code>}   
</code><code>
</code><code>
</code><code></PRE>
</code><code></code>    </div>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2FSpectrum.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2FSpectrum.c&amp;rev=0&amp;sc=0">Blame</a></span>
</p>
  </div>
  <div id="footer">
    <p style="padding:0; margin:0"><small>powered by: <a href="http://websvn.tigris.org">WebSVN 2.0</a></small></p>
  </div>
</body>
</html>
