<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="content-type" content="text/html;charset=UTF-8" />
    <meta http-equiv="generator" content="WebSVN 2.0" /> <!-- leave this for stats -->
    <link rel="shortcut icon" type="image/x-icon" href="./templates/calm/images/favicon.ico" />
    <link type="text/css" href="./templates/calm/styles.css" rel="stylesheet" media="screen" />
    <link type="text/css" href="./templates/calm/star-light/star-light.css" rel="stylesheet" media="screen" />
    <!--[if gte IE 5.5000]>
    <script type="text/javascript" src="./templates/calm/png.js"></script>
    <style type="text/css" media="screen">
    tbody tr td { padding:1px 0 }
    #wrap h2 { padding:10px 5px 0 5px; margin-bottom:-8px }
    </style>
    <![endif]-->
    <title>
         MikroKopter - WebSVN
            - FlightCtrl
               - Rev 1226
            - /tags/V0.74d/spi.h
    </title>
    <script type="text/javascript">
    //<![CDATA[
         function getPath()
         {
         	return '.';
         }
         
         function checkCB(chBox)
         {
            count = 0
            first = null
            f = chBox.form
            for (i = 0 ; i < f.elements.length ; i++)
            if (f.elements[i].type == 'checkbox' && f.elements[i].checked)
            {
               if (first == null && f.elements[i] != chBox)
                  first = f.elements[i]
               count += 1
            }
            
            if (count > 2) 
            {
               first.checked = false
               count -= 1
            }
         }
    //]]>
    </script>
    <script type="text/javascript" src="./templates/calm/collapse.js"></script>
    </head>
    <body>
    <div id="container">
    <H3>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://www.mikrokopter.de" target="_blank">MikroKopter.de</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://forum.mikrokopter.de" target="_blank">Forum</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
  </H3>
<div id="select"><form action="form.php?path=&amp;" method="post" id="projectform"><div><input type="hidden" name="selectproj" value="1" /><input type="hidden" name="op" value="form" /><input type="hidden" name="sc" value="0" /><select name="repname" onchange="javascript:this.form.submit();"><option value="BL-Ctrl">BL-Ctrl</option><option value="FlightCtrl" selected="selected">FlightCtrl</option><option value="MK3Mag">MK3Mag</option><option value="NaviCtrl">NaviCtrl</option><option value="Projects">Projects</option></select><span class="submit"><input type="submit" value="Go" /></span></div></form></div>
<h1><a href=".?sc=0" title="Project home">Subversion&nbsp;Repositories</a> <span>FlightCtrl</span></h1>
<h2 class="path" style="margin:0 2% 15px 2%;">[<a href="listing.php?repname=FlightCtrl&amp;path=%2F&amp;rev=0&amp;sc=0">/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2F&amp;rev=0&amp;sc=0">tags/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2F&amp;rev=0&amp;sc=0">V0.74d/</a>] [<b>spi.h</b>] - Rev 1226</h2>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fspi.h&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fspi.h&amp;rev=0&amp;sc=0">Blame</a></span> &#124;
<span class="diff"><a href="log.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fspi.h&amp;rev=0&amp;sc=0&amp;isdir=0">View&nbsp;Log</a></span>
</p>
    <div class="listing">
<code><PRE>
</code><code><I><FONT COLOR="#B22222">// ######################## SPI - FlightCtrl ###################
</code><code></FONT></I>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">_SPI_H</FONT>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">_SPI_H</FONT>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&lt;util/delay.h&gt;</FONT></B>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">USE_SPI_COMMUNICATION</FONT>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPI_PROTOCOL_COMP</FONT>   1
</code><code>
</code><code><I><FONT COLOR="#B22222">//-----------------------------------------
</code><code></FONT></I>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">DDR_SPI</FONT> DDRB
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">DD_SS</FONT>   PB4
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">DD_SCK</FONT>  PB7
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">DD_MOSI</FONT> PB5
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">DD_MISO</FONT> PB6
</code><code>
</code><code><I><FONT COLOR="#B22222">// for compatibility reasons gcc3.x &lt;-&gt; gcc4.x
</code><code></FONT></I>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">SPCR</FONT>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPCR</FONT>   SPCR0
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">SPE</FONT>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPE</FONT>   SPE0
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">MSTR</FONT>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">MSTR</FONT>   MSTR0
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">SPR1</FONT>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPR1</FONT>   SPR01
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">SPR0</FONT>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPR0</FONT>   SPR00
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">SPIE</FONT>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPIE</FONT>   SPIE0
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">SPDR</FONT>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPDR</FONT>   SPDR0
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">SPIF</FONT>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPIF</FONT>   SPIF0
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">ifndef</FONT></B> <FONT COLOR="#B8860B">SPSR</FONT>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPSR</FONT>   SPSR0
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code><I><FONT COLOR="#B22222">// -------------------------
</code><code></FONT></I>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SLAVE_SELECT_DDR_PORT</FONT>   DDRC
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SLAVE_SELECT_PORT</FONT>       PORTC
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPI_SLAVE_SELECT</FONT>        PC5
</code><code>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPI_CMD_USER</FONT>        10
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPI_CMD_STICK</FONT>       11
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPI_CMD_MISC</FONT>        12
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPI_CMD_PARAMETER1</FONT>  13
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPI_CMD_VERSION</FONT>     14
</code><code>
</code><code><B><FONT COLOR="#228B22">struct</FONT></B> str_ToNaviCtrl
</code><code>{
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Sync1, Sync2;
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Command;
</code><code> <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  IntegralNick;
</code><code> <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  IntegralRoll;
</code><code> <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  AccNick;
</code><code> <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  AccRoll;
</code><code> <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  GyroCompass;
</code><code> <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  GyroNick;
</code><code> <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  GyroRoll;
</code><code> <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  GyroGier;
</code><code> <B><FONT COLOR="#228B22">union</FONT></B>
</code><code> { <B><FONT COLOR="#228B22">char</FONT></B> Byte[12];
</code><code>   <B><FONT COLOR="#228B22">int</FONT></B>  Int[6];
</code><code>   <B><FONT COLOR="#228B22">long</FONT></B> Long[3];
</code><code>   <B><FONT COLOR="#228B22">float</FONT></B> Float[3];
</code><code> } Param;
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Chksum;
</code><code>};
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">SPI_KALMAN</FONT>           103
</code><code>
</code><code><B><FONT COLOR="#228B22">struct</FONT></B> str_FromNaviCtrl
</code><code>{
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Command;
</code><code>  <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  GPS_Nick;
</code><code>  <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  GPS_Roll;
</code><code>  <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  GPS_Gier;
</code><code>  <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  CompassValue;
</code><code>  <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B>  Status;
</code><code>  <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> BeepTime;
</code><code>  <B><FONT COLOR="#228B22">union</FONT></B>
</code><code>  { <B><FONT COLOR="#228B22">char</FONT></B> Byte[12];
</code><code>    <B><FONT COLOR="#228B22">int</FONT></B>  Int[6];
</code><code>    <B><FONT COLOR="#228B22">long</FONT></B> Long[3];
</code><code>    <B><FONT COLOR="#228B22">float</FONT></B> Float[3];
</code><code>  } Param;
</code><code>  <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Chksum;
</code><code>};
</code><code>
</code><code><B><FONT COLOR="#228B22">struct</FONT></B> str_FromNaviCtrl_Value
</code><code>{
</code><code> <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Kalman_K;
</code><code> <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Kalman_MaxDrift;
</code><code> <B><FONT COLOR="#228B22">signed</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Kalman_MaxFusion;
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> SerialDataOkay;
</code><code>};
</code><code>
</code><code><B><FONT COLOR="#228B22">struct</FONT></B> str_SPI_VersionInfo
</code><code>{
</code><code>  <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Major;
</code><code>  <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Minor;
</code><code>  <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Patch;
</code><code>  <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> Compatible;
</code><code>};
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">ifdef</FONT></B> <FONT COLOR="#B8860B">USE_SPI_COMMUNICATION</FONT>
</code><code>
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">struct</FONT></B> str_FromNaviCtrl_Value FromNaviCtrl_Value;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">struct</FONT></B> str_ToNaviCtrl   ToNaviCtrl;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">struct</FONT></B> str_FromNaviCtrl FromNaviCtrl;
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> SPI_CommandCounter,NaviDataOkay;
</code><code>
</code><code><I><FONT COLOR="#B22222">//#define SPI_CMD_VALUE   0x03
</code><code></FONT></I>
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">SPI_MasterInit</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">SPI_StartTransmitPacket</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">UpdateSPI_Buffer</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code><B><FONT COLOR="#228B22">extern</FONT></B> <B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">SPI_TransmitByte</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>);
</code><code>#<B><FONT COLOR="#5F9EA0">else
</FONT></B>
</code><code>
</code><code>
</code><code><I><FONT COLOR="#B22222">// -------------------------------- Dummy -----------------------------------------
</code><code></FONT></I>#<B><FONT COLOR="#5F9EA0">define</FONT></B>  <B><FONT COLOR="#0000FF">SPI_MasterInit</FONT></B>() ;
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B>  <B><FONT COLOR="#0000FF">SPI_StartTransmitPacket</FONT></B>() ;
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B>  <B><FONT COLOR="#0000FF">UpdateSPI_Buffer</FONT></B>() ;
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B>  <B><FONT COLOR="#0000FF">SPI_TransmitByte</FONT></B>() ;
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">endif
</FONT></B>
</code><code></PRE>
</code><code></code>    </div>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fspi.h&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fspi.h&amp;rev=0&amp;sc=0">Blame</a></span>
</p>
  </div>
  <div id="footer">
    <p style="padding:0; margin:0"><small>powered by: <a href="http://websvn.tigris.org">WebSVN 2.0</a></small></p>
  </div>
</body>
</html>
