<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="content-type" content="text/html;charset=UTF-8" />
    <meta http-equiv="generator" content="WebSVN 2.0" /> <!-- leave this for stats -->
    <link rel="shortcut icon" type="image/x-icon" href="./templates/calm/images/favicon.ico" />
    <link type="text/css" href="./templates/calm/styles.css" rel="stylesheet" media="screen" />
    <link type="text/css" href="./templates/calm/star-light/star-light.css" rel="stylesheet" media="screen" />
    <!--[if gte IE 5.5000]>
    <script type="text/javascript" src="./templates/calm/png.js"></script>
    <style type="text/css" media="screen">
    tbody tr td { padding:1px 0 }
    #wrap h2 { padding:10px 5px 0 5px; margin-bottom:-8px }
    </style>
    <![endif]-->
    <title>
         MikroKopter - WebSVN
            - FlightCtrl
               - Rev 1226
            - /tags/V0.74d/uart.c
    </title>
    <script type="text/javascript">
    //<![CDATA[
         function getPath()
         {
         	return '.';
         }
         
         function checkCB(chBox)
         {
            count = 0
            first = null
            f = chBox.form
            for (i = 0 ; i < f.elements.length ; i++)
            if (f.elements[i].type == 'checkbox' && f.elements[i].checked)
            {
               if (first == null && f.elements[i] != chBox)
                  first = f.elements[i]
               count += 1
            }
            
            if (count > 2) 
            {
               first.checked = false
               count -= 1
            }
         }
    //]]>
    </script>
    <script type="text/javascript" src="./templates/calm/collapse.js"></script>
    </head>
    <body>
    <div id="container">
    <H3>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://www.mikrokopter.de" target="_blank">MikroKopter.de</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
    <a href="http://forum.mikrokopter.de" target="_blank">Forum</a>
    &nbsp;&nbsp;&#8226;&nbsp;&nbsp;
  </H3>
<div id="select"><form action="form.php?path=&amp;" method="post" id="projectform"><div><input type="hidden" name="selectproj" value="1" /><input type="hidden" name="op" value="form" /><input type="hidden" name="sc" value="0" /><select name="repname" onchange="javascript:this.form.submit();"><option value="BL-Ctrl">BL-Ctrl</option><option value="FlightCtrl" selected="selected">FlightCtrl</option><option value="MK3Mag">MK3Mag</option><option value="NaviCtrl">NaviCtrl</option><option value="Projects">Projects</option></select><span class="submit"><input type="submit" value="Go" /></span></div></form></div>
<h1><a href=".?sc=0" title="Project home">Subversion&nbsp;Repositories</a> <span>FlightCtrl</span></h1>
<h2 class="path" style="margin:0 2% 15px 2%;">[<a href="listing.php?repname=FlightCtrl&amp;path=%2F&amp;rev=0&amp;sc=0">/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2F&amp;rev=0&amp;sc=0">tags/</a>] [<a href="listing.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2F&amp;rev=0&amp;sc=0">V0.74d/</a>] [<b>uart.c</b>] - Rev 1226</h2>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fuart.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fuart.c&amp;rev=0&amp;sc=0">Blame</a></span> &#124;
<span class="diff"><a href="log.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fuart.c&amp;rev=0&amp;sc=0&amp;isdir=0">View&nbsp;Log</a></span>
</p>
    <div class="listing">
<code><PRE>
</code><code><I><FONT COLOR="#B22222">// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">// + Copyright (c) 04.2007 Holger Buss
</code><code></FONT></I><I><FONT COLOR="#B22222">// + only for non-profit use
</code><code></FONT></I><I><FONT COLOR="#B22222">// + www.MikroKopter.com
</code><code></FONT></I><I><FONT COLOR="#B22222">// + see the File &quot;License.txt&quot; for further Informations
</code><code></FONT></I><I><FONT COLOR="#B22222">// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&lt;stdarg.h&gt;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&lt;string.h&gt;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;main.h&quot;</FONT></B>
</code><code>#<B><FONT COLOR="#5F9EA0">include</FONT></B> <B><FONT COLOR="#BC8F8F">&quot;uart.h&quot;</FONT></B>
</code><code>
</code><code>
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">FC_ADDRESS</FONT> 1
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">NC_ADDRESS</FONT> 2
</code><code>#<B><FONT COLOR="#5F9EA0">define</FONT></B> <FONT COLOR="#B8860B">MK3MAG_ADDRESS</FONT> 3
</code><code>
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> GetExternalControl = 0,DebugDisplayAnforderung1 = 0, DebugDisplayAnforderung = 0,DebugDataAnforderung = 0,GetVersionAnforderung = 0, GetPPMChannelAnforderung = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> DisplayLine = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> SioTmp = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> SendeBuffer[MAX_SENDE_BUFF];
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> RxdBuffer[MAX_EMPFANGS_BUFF];
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NMEABuffer[MAX_EMPFANGS_BUFF];
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NeuerDatensatzEmpfangen = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> NeueKoordinateEmpfangen = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> UebertragungAbgeschlossen = 1;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> CntCrcError = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> AnzahlEmpfangsBytes = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *pRxData = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> RxDataLen = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> PC_DebugTimeout = 0;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">volatile</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> PC_MotortestActive = 0;
</code><code>
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> DebugTextAnforderung = 255;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> PcZugriff = 100;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> MotorTest[16];
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> MeineSlaveAdresse = 1; <I><FONT COLOR="#B22222">// Flight-Ctrl
</code><code></FONT></I><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> ConfirmFrame;
</code><code><B><FONT COLOR="#228B22">struct</FONT></B> str_DebugOut    DebugOut;
</code><code><B><FONT COLOR="#228B22">struct</FONT></B> str_ExternControl  ExternControl;
</code><code><B><FONT COLOR="#228B22">struct</FONT></B> str_VersionInfo VersionInfo;
</code><code><B><FONT COLOR="#228B22">struct</FONT></B> str_WinkelOut WinkelOut;
</code><code><B><FONT COLOR="#228B22">struct</FONT></B> str_Data3D Data3D;
</code><code>
</code><code><B><FONT COLOR="#228B22">int</FONT></B> Debug_Timer,Kompass_Timer,Timer3D;
</code><code><B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> DebugDataIntervall = 200, Intervall3D = 0;
</code><code>
</code><code><B><FONT COLOR="#228B22">const</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> ANALOG_TEXT[32][16] =
</code><code>{
</code><code>   <I><FONT COLOR="#B22222">//1234567890123456
</code><code></FONT></I>    <B><FONT COLOR="#BC8F8F">&quot;AngleNick       &quot;</FONT></B>, <I><FONT COLOR="#B22222">//0
</code><code></FONT></I>    <B><FONT COLOR="#BC8F8F">&quot;AngleRoll       &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;AccNick         &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;AccRoll         &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;GyroGier        &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;Hight Value     &quot;</FONT></B>, <I><FONT COLOR="#B22222">//5
</code><code></FONT></I>    <B><FONT COLOR="#BC8F8F">&quot;AccZ            &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;Gas             &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;Compass Value   &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;Voltage         &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;Empfang         &quot;</FONT></B>, <I><FONT COLOR="#B22222">//10
</code><code></FONT></I>    <B><FONT COLOR="#BC8F8F">&quot;Gyro Kompass    &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;Motor Front     &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;Motor Rear      &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;Motor Left      &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;Motor Right     &quot;</FONT></B>, <I><FONT COLOR="#B22222">//15
</code><code></FONT></I>    <B><FONT COLOR="#BC8F8F">&quot;                &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;                &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;                &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;MK3Mag CalState &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;Servo           &quot;</FONT></B>, <I><FONT COLOR="#B22222">//20
</code><code></FONT></I>    <B><FONT COLOR="#BC8F8F">&quot;                &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;                &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;                &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;                &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;                &quot;</FONT></B>, <I><FONT COLOR="#B22222">//25
</code><code></FONT></I>    <B><FONT COLOR="#BC8F8F">&quot;                &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;Kalman_MaxDrift &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;                &quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;Navi Serial Data&quot;</FONT></B>,
</code><code>    <B><FONT COLOR="#BC8F8F">&quot;GPS_Nick        &quot;</FONT></B>, <I><FONT COLOR="#B22222">//30
</code><code></FONT></I>    <B><FONT COLOR="#BC8F8F">&quot;GPS_Roll        &quot;</FONT></B>
</code><code>};
</code><code>
</code><code>
</code><code>
</code><code><I><FONT COLOR="#B22222">//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">//++ Sende-Part der Datenbertragung
</code><code></FONT></I><I><FONT COLOR="#B22222">//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I><B><FONT COLOR="#0000FF">SIGNAL</FONT></B>(INT_VEC_TX)
</code><code>{
</code><code> <B><FONT COLOR="#228B22">static</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> ptr = 0;
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> tmp_tx;
</code><code> <B><FONT COLOR="#A020F0">if</FONT></B>(!UebertragungAbgeschlossen)
</code><code>  {
</code><code>   ptr++;                    <I><FONT COLOR="#B22222">// die [0] wurde schon gesendet
</code><code></FONT></I>   tmp_tx = SendeBuffer[ptr];
</code><code>   <B><FONT COLOR="#A020F0">if</FONT></B>((tmp_tx == <B><FONT COLOR="#BC8F8F">'\r'</FONT></B>) || (ptr == MAX_SENDE_BUFF))
</code><code>    {
</code><code>     ptr = 0;
</code><code>     UebertragungAbgeschlossen = 1;
</code><code>    }
</code><code>   UDR = tmp_tx;
</code><code>  }
</code><code>  <B><FONT COLOR="#A020F0">else</FONT></B> ptr = 0;
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I><I><FONT COLOR="#B22222">//++ Empfangs-Part der Datenbertragung, incl. CRC-Auswertung
</code><code></FONT></I><I><FONT COLOR="#B22222">//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
</code><code></FONT></I><B><FONT COLOR="#0000FF">SIGNAL</FONT></B>(INT_VEC_RX)
</code><code>{
</code><code> <B><FONT COLOR="#228B22">static</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> crc;
</code><code> <B><FONT COLOR="#228B22">static</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> crc1,crc2,buf_ptr;
</code><code> <B><FONT COLOR="#228B22">static</FONT></B> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> UartState = 0;
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> CrcOkay = 0;
</code><code>
</code><code> SioTmp = UDR;
</code><code> <B><FONT COLOR="#A020F0">if</FONT></B>(buf_ptr &gt;= MAX_EMPFANGS_BUFF)    UartState = 0;
</code><code> <B><FONT COLOR="#A020F0">if</FONT></B>(SioTmp == <B><FONT COLOR="#BC8F8F">'\r'</FONT></B> &amp;&amp; UartState == 2)
</code><code>  {
</code><code>   UartState = 0;
</code><code>   crc -= RxdBuffer[buf_ptr-2];
</code><code>   crc -= RxdBuffer[buf_ptr-1];
</code><code>   crc %= 4096;
</code><code>   crc1 = <B><FONT COLOR="#BC8F8F">'='</FONT></B> + crc / 64;
</code><code>   crc2 = <B><FONT COLOR="#BC8F8F">'='</FONT></B> + crc % 64;
</code><code>   CrcOkay = 0;
</code><code>   <B><FONT COLOR="#A020F0">if</FONT></B>((crc1 == RxdBuffer[buf_ptr-2]) &amp;&amp; (crc2 == RxdBuffer[buf_ptr-1])) CrcOkay = 1; <B><FONT COLOR="#A020F0">else</FONT></B> { CrcOkay = 0; CntCrcError++;};
</code><code>   <B><FONT COLOR="#A020F0">if</FONT></B>(!NeuerDatensatzEmpfangen &amp;&amp; CrcOkay) <I><FONT COLOR="#B22222">// Datensatz schon verarbeitet
</code><code></FONT></I>    {
</code><code>     NeuerDatensatzEmpfangen = 1;
</code><code>         AnzahlEmpfangsBytes = buf_ptr + 1;
</code><code>     RxdBuffer[buf_ptr] = <B><FONT COLOR="#BC8F8F">'\r'</FONT></B>;
</code><code>         <B><FONT COLOR="#A020F0">if</FONT></B>(RxdBuffer[2] == <B><FONT COLOR="#BC8F8F">'R'</FONT></B>) wdt_enable(WDTO_250MS); <I><FONT COLOR="#B22222">// Reset-Commando
</code><code></FONT></I>        }
</code><code>  }
</code><code>  <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>  <B><FONT COLOR="#A020F0">switch</FONT></B>(UartState)
</code><code>  {
</code><code>   <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">0</FONT></B>:
</code><code>          <B><FONT COLOR="#A020F0">if</FONT></B>(SioTmp == <B><FONT COLOR="#BC8F8F">'#'</FONT></B> &amp;&amp; !NeuerDatensatzEmpfangen) UartState = 1;  <I><FONT COLOR="#B22222">// Startzeichen und Daten schon verarbeitet
</code><code></FONT></I>                  buf_ptr = 0;
</code><code>                  RxdBuffer[buf_ptr++] = SioTmp;
</code><code>                  crc = SioTmp;
</code><code>          <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>   <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">1</FONT></B>: <I><FONT COLOR="#B22222">// Adresse auswerten
</code><code></FONT></I>                  UartState++;
</code><code>                  RxdBuffer[buf_ptr++] = SioTmp;
</code><code>                  crc += SioTmp;
</code><code>                  <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>   <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">2</FONT></B>: <I><FONT COLOR="#B22222">//  Eingangsdaten sammeln
</code><code></FONT></I>                  RxdBuffer[buf_ptr] = SioTmp;
</code><code>                  <B><FONT COLOR="#A020F0">if</FONT></B>(buf_ptr &lt; MAX_EMPFANGS_BUFF) buf_ptr++;
</code><code>                  <B><FONT COLOR="#A020F0">else</FONT></B> UartState = 0;
</code><code>                  crc += SioTmp;
</code><code>                  <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>   <B><FONT COLOR="#5F9EA0">default</FONT></B>:
</code><code>          UartState = 0;
</code><code>          <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>  }
</code><code>}
</code><code>
</code><code>
</code><code><I><FONT COLOR="#B22222">// --------------------------------------------------------------------------
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">AddCRC</FONT></B>(<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> wieviele)
</code><code>{
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> tmpCRC = 0,i;
</code><code> <B><FONT COLOR="#A020F0">for</FONT></B>(i = 0; i &lt; wieviele;i++)
</code><code>  {
</code><code>   tmpCRC += SendeBuffer[i];
</code><code>  }
</code><code>   tmpCRC %= 4096;
</code><code>   SendeBuffer[i++] = <B><FONT COLOR="#BC8F8F">'='</FONT></B> + tmpCRC / 64;
</code><code>   SendeBuffer[i++] = <B><FONT COLOR="#BC8F8F">'='</FONT></B> + tmpCRC % 64;
</code><code>   SendeBuffer[i++] = <B><FONT COLOR="#BC8F8F">'\r'</FONT></B>;
</code><code>  UebertragungAbgeschlossen = 0;
</code><code>  UDR = SendeBuffer[0];
</code><code>}
</code><code>
</code><code>
</code><code>
</code><code><I><FONT COLOR="#B22222">// --------------------------------------------------------------------------
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">SendOutData</FONT></B>(<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> cmd,<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> address, <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> BufferAnzahl, ...) <I><FONT COLOR="#B22222">//unsigned char *snd, unsigned char len)
</code><code></FONT></I>{
</code><code> va_list ap;
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> pt = 0;
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> a,b,c;
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> ptr = 0;
</code><code>
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *snd = 0;
</code><code> <B><FONT COLOR="#228B22">int</FONT></B> len = 0;
</code><code>
</code><code> SendeBuffer[pt++] = <B><FONT COLOR="#BC8F8F">'#'</FONT></B>;                               <I><FONT COLOR="#B22222">// Startzeichen
</code><code></FONT></I> SendeBuffer[pt++] = <B><FONT COLOR="#BC8F8F">'a'</FONT></B> + address;             <I><FONT COLOR="#B22222">// Adresse (a=0; b=1,...)
</code><code></FONT></I> SendeBuffer[pt++] = cmd;                               <I><FONT COLOR="#B22222">// Commando
</code><code></FONT></I>
</code><code> va_start(ap, BufferAnzahl);
</code><code> <B><FONT COLOR="#A020F0">if</FONT></B>(BufferAnzahl)
</code><code> {
</code><code>                snd = va_arg(ap, <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>*);
</code><code>                len = va_arg(ap, <B><FONT COLOR="#228B22">int</FONT></B>);
</code><code>                ptr = 0;
</code><code>                BufferAnzahl--;
</code><code> }
</code><code> <B><FONT COLOR="#A020F0">while</FONT></B>(len)
</code><code>  {
</code><code>        <B><FONT COLOR="#A020F0">if</FONT></B>(len)
</code><code>        {
</code><code>           a = snd[ptr++];
</code><code>           len--;
</code><code>           <B><FONT COLOR="#A020F0">if</FONT></B>((!len) &amp;&amp; BufferAnzahl)
</code><code>                {
</code><code>                        snd = va_arg(ap, <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>*);
</code><code>                        len = va_arg(ap, <B><FONT COLOR="#228B22">int</FONT></B>);
</code><code>                        ptr = 0;
</code><code>                        BufferAnzahl--;
</code><code>                }
</code><code>        }
</code><code>        <B><FONT COLOR="#A020F0">else</FONT></B> a = 0;
</code><code>        <B><FONT COLOR="#A020F0">if</FONT></B>(len)
</code><code>        {
</code><code>                b = snd[ptr++];
</code><code>                len--;
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B>((!len) &amp;&amp; BufferAnzahl)
</code><code>                {
</code><code>                        snd = va_arg(ap, <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>*);
</code><code>                        len = va_arg(ap, <B><FONT COLOR="#228B22">int</FONT></B>);
</code><code>                        ptr = 0;
</code><code>                        BufferAnzahl--;
</code><code>                }
</code><code>        }
</code><code>        <B><FONT COLOR="#A020F0">else</FONT></B> b = 0;
</code><code>        <B><FONT COLOR="#A020F0">if</FONT></B>(len)
</code><code>        {
</code><code>                c = snd[ptr++];
</code><code>                len--;
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B>((!len) &amp;&amp; BufferAnzahl)
</code><code>                {
</code><code>                        snd = va_arg(ap, <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>*);
</code><code>                        len = va_arg(ap, <B><FONT COLOR="#228B22">int</FONT></B>);
</code><code>                        ptr = 0;
</code><code>                        BufferAnzahl--;
</code><code>                }
</code><code>        }
</code><code>        <B><FONT COLOR="#A020F0">else</FONT></B> c = 0;
</code><code>   SendeBuffer[pt++] = <B><FONT COLOR="#BC8F8F">'='</FONT></B> + (a &gt;&gt; 2);
</code><code>   SendeBuffer[pt++] = <B><FONT COLOR="#BC8F8F">'='</FONT></B> + (((a &amp; 0x03) &lt;&lt; 4) | ((b &amp; 0xf0) &gt;&gt; 4));
</code><code>   SendeBuffer[pt++] = <B><FONT COLOR="#BC8F8F">'='</FONT></B> + (((b &amp; 0x0f) &lt;&lt; 2) | ((c &amp; 0xc0) &gt;&gt; 6));
</code><code>   SendeBuffer[pt++] = <B><FONT COLOR="#BC8F8F">'='</FONT></B> + ( c &amp; 0x3f);
</code><code>  }
</code><code> va_end(ap);
</code><code> AddCRC(pt);
</code><code>}
</code><code>
</code><code>
</code><code><I><FONT COLOR="#B22222">// --------------------------------------------------------------------------
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">Decode64</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)  <I><FONT COLOR="#B22222">// die daten werden im rx buffer dekodiert, das geht nur, weil aus 4 byte immer 3 gemacht werden.
</code><code></FONT></I>{
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> a,b,c,d;
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> x,y,z;
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> ptrIn = 3; <I><FONT COLOR="#B22222">// start at begin of data block
</code><code></FONT></I> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> ptrOut = 3;
</code><code> <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> len = AnzahlEmpfangsBytes - 6; <I><FONT COLOR="#B22222">// von der Gesamtbytezahl eines Frames gehen 3 Bytes des Headers  ('#',Addr, Cmd) und 3 Bytes des Footers (CRC1, CRC2, '\r') ab.
</code><code></FONT></I>
</code><code> <B><FONT COLOR="#A020F0">while</FONT></B>(len)
</code><code>  {
</code><code>   a = RxdBuffer[ptrIn++] - <B><FONT COLOR="#BC8F8F">'='</FONT></B>;
</code><code>   b = RxdBuffer[ptrIn++] - <B><FONT COLOR="#BC8F8F">'='</FONT></B>;
</code><code>   c = RxdBuffer[ptrIn++] - <B><FONT COLOR="#BC8F8F">'='</FONT></B>;
</code><code>   d = RxdBuffer[ptrIn++] - <B><FONT COLOR="#BC8F8F">'='</FONT></B>;
</code><code>
</code><code>   x = (a &lt;&lt; 2) | (b &gt;&gt; 4);
</code><code>   y = ((b &amp; 0x0f) &lt;&lt; 4) | (c &gt;&gt; 2);
</code><code>   z = ((c &amp; 0x03) &lt;&lt; 6) | d;
</code><code>
</code><code>   <B><FONT COLOR="#A020F0">if</FONT></B>(len--) RxdBuffer[ptrOut++] = x; <B><FONT COLOR="#A020F0">else</FONT></B> <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>   <B><FONT COLOR="#A020F0">if</FONT></B>(len--) RxdBuffer[ptrOut++] = y; <B><FONT COLOR="#A020F0">else</FONT></B> <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>   <B><FONT COLOR="#A020F0">if</FONT></B>(len--) RxdBuffer[ptrOut++] = z;   <B><FONT COLOR="#A020F0">else</FONT></B> <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>  }
</code><code>        pRxData = (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B>*)&amp;RxdBuffer[3]; <I><FONT COLOR="#B22222">// decodierte Daten beginnen beim 4. Byte
</code><code></FONT></I>        RxDataLen = ptrOut - 3;  <I><FONT COLOR="#B22222">// wie viele Bytes wurden dekodiert?
</code><code></FONT></I>
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">// --------------------------------------------------------------------------
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">BearbeiteRxDaten</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code> <B><FONT COLOR="#A020F0">if</FONT></B>(!NeuerDatensatzEmpfangen) <B><FONT COLOR="#A020F0">return</FONT></B>;
</code><code>
</code><code>        <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> tempchar1, tempchar2;
</code><code>        Decode64(); <I><FONT COLOR="#B22222">// dekodiere datenblock im Empfangsbuffer
</code><code></FONT></I>        <B><FONT COLOR="#A020F0">switch</FONT></B>(RxdBuffer[1]-<B><FONT COLOR="#BC8F8F">'a'</FONT></B>) <I><FONT COLOR="#B22222">// check for Slave Address
</code><code></FONT></I>        {
</code><code>                <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#5F9EA0">FC_ADDRESS</FONT></B>: <I><FONT COLOR="#B22222">// FC special commands
</code><code></FONT></I>
</code><code>                <B><FONT COLOR="#A020F0">switch</FONT></B>(RxdBuffer[2])
</code><code>                {
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'K'</FONT></B>:<I><FONT COLOR="#B22222">// Kompasswert
</code><code></FONT></I>                                        memcpy((<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)&amp;KompassValue , (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)pRxData, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(KompassValue));
</code><code>                                        KompassRichtung = ((540 + KompassValue - KompassStartwert) % 360) - 180;
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'t'</FONT></B>:<I><FONT COLOR="#B22222">// Motortest
</code><code></FONT></I>                                <B><FONT COLOR="#A020F0">if</FONT></B>(AnzahlEmpfangsBytes &gt; 20) memcpy(&amp;MotorTest[0], (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)pRxData, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(MotorTest));
</code><code>                                <B><FONT COLOR="#A020F0">else</FONT></B> memcpy(&amp;MotorTest[0], (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)pRxData, 4);
</code><code>                                        PC_MotortestActive = 240;
</code><code>                                        <I><FONT COLOR="#B22222">//while(!UebertragungAbgeschlossen);
</code><code></FONT></I>                                        <I><FONT COLOR="#B22222">//SendOutData('T', MeineSlaveAdresse, 0);
</code><code></FONT></I>                                        PcZugriff = 255;
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'n'</FONT></B>:<I><FONT COLOR="#B22222">// &quot;Get Mixer
</code><code></FONT></I>                                        <B><FONT COLOR="#A020F0">while</FONT></B>(!UebertragungAbgeschlossen);
</code><code>                    SendOutData(<B><FONT COLOR="#BC8F8F">'N'</FONT></B>, FC_ADDRESS, 1, (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) &amp;Mixer,<B><FONT COLOR="#A020F0">sizeof</FONT></B>(Mixer));
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'m'</FONT></B>:<I><FONT COLOR="#B22222">// &quot;Write Mixer
</code><code></FONT></I>                                        <B><FONT COLOR="#A020F0">while</FONT></B>(!UebertragungAbgeschlossen);
</code><code>                    <B><FONT COLOR="#A020F0">if</FONT></B>(pRxData[0] == MIXER_REVISION)
</code><code>                                         {
</code><code>                       memcpy(&amp;Mixer, (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)pRxData, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(Mixer));
</code><code>                       eeprom_write_block(&amp;Mixer, &amp;EEPromArray[EEPROM_ADR_MIXER_TABLE], <B><FONT COLOR="#A020F0">sizeof</FONT></B>(Mixer));
</code><code>                                           tempchar1 = 1;
</code><code>                                         }
</code><code>                     <B><FONT COLOR="#A020F0">else</FONT></B>  tempchar1 = 0;
</code><code>                                        SendOutData(<B><FONT COLOR="#BC8F8F">'M'</FONT></B>, FC_ADDRESS, 1, &amp;tempchar1, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(tempchar1));
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'p'</FONT></B>: <I><FONT COLOR="#B22222">// get PPM Channels
</code><code></FONT></I>                                        GetPPMChannelAnforderung = 1;
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'q'</FONT></B>:<I><FONT COLOR="#B22222">// &quot;Get&quot;-Anforderung fr Settings
</code><code></FONT></I>                                        <I><FONT COLOR="#B22222">// Bei Get werden die vom PC einstellbaren Werte vom PC zurckgelesen
</code><code></FONT></I>                                        <B><FONT COLOR="#A020F0">if</FONT></B>(pRxData[0] == 0xFF)
</code><code>                                        {
</code><code>                                                pRxData[0] = GetActiveParamSetNumber();
</code><code>                                        }
</code><code>                                        <I><FONT COLOR="#B22222">// limit settings range
</code><code></FONT></I>                                        <B><FONT COLOR="#A020F0">if</FONT></B>(pRxData[0] &lt; 1) pRxData[0] = 1; <I><FONT COLOR="#B22222">// limit to 5
</code><code></FONT></I>                                        <B><FONT COLOR="#A020F0">else</FONT></B> <B><FONT COLOR="#A020F0">if</FONT></B>(pRxData[0] &gt; 5) pRxData[0] = 5; <I><FONT COLOR="#B22222">// limit to 5
</code><code></FONT></I>                                        <I><FONT COLOR="#B22222">// load requested parameter set
</code><code></FONT></I>                                        ReadParameterSet(pRxData[0], (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) &amp;EE_Parameter.Kanalbelegung[0], STRUCT_PARAM_LAENGE);
</code><code>
</code><code>                                        <B><FONT COLOR="#A020F0">while</FONT></B>(!UebertragungAbgeschlossen);
</code><code>                                        tempchar1 = pRxData[0];
</code><code>                                        tempchar2 = EE_DATENREVISION;
</code><code>                                        SendOutData(<B><FONT COLOR="#BC8F8F">'Q'</FONT></B>, FC_ADDRESS, 3, &amp;tempchar1, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(tempchar1), &amp;tempchar2, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(tempchar2), (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) &amp;EE_Parameter.Kanalbelegung[0], STRUCT_PARAM_LAENGE);
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'s'</FONT></B>: <I><FONT COLOR="#B22222">// Parametersatz speichern
</code><code></FONT></I>                                        <B><FONT COLOR="#A020F0">if</FONT></B>((1 &lt;= pRxData[0]) &amp;&amp; (pRxData[0] &lt;= 5) &amp;&amp; (pRxData[1] == EE_DATENREVISION)) <I><FONT COLOR="#B22222">// check for setting to be in range
</code><code></FONT></I>                                        {
</code><code>                                                memcpy((<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) &amp;EE_Parameter.Kanalbelegung[0], (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)&amp;pRxData[2], STRUCT_PARAM_LAENGE);
</code><code>                                                WriteParameterSet(pRxData[0], (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) &amp;EE_Parameter.Kanalbelegung[0], STRUCT_PARAM_LAENGE);
</code><code>                                                Umschlag180Nick = (<B><FONT COLOR="#228B22">long</FONT></B>) EE_Parameter.WinkelUmschlagNick * 2500L;
</code><code>                                                Umschlag180Roll = (<B><FONT COLOR="#228B22">long</FONT></B>) EE_Parameter.WinkelUmschlagRoll * 2500L;
</code><code>                                                SetActiveParamSetNumber(pRxData[0]);
</code><code>                                                tempchar1 = GetActiveParamSetNumber();
</code><code>                                                Piep(tempchar1);
</code><code>                                        }
</code><code>                                        <B><FONT COLOR="#A020F0">else</FONT></B>
</code><code>                                        {
</code><code>                                                tempchar1 = 0; <I><FONT COLOR="#B22222">// mark in response an invlid setting
</code><code></FONT></I>                                        }
</code><code>                                        <B><FONT COLOR="#A020F0">while</FONT></B>(!UebertragungAbgeschlossen);
</code><code>                                        SendOutData(<B><FONT COLOR="#BC8F8F">'S'</FONT></B>, FC_ADDRESS, 1, &amp;tempchar1, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(tempchar1));
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>                } <I><FONT COLOR="#B22222">// case FC_ADDRESS:
</code><code></FONT></I>
</code><code>                <B><FONT COLOR="#5F9EA0">default</FONT></B>: <I><FONT COLOR="#B22222">// any Slave Address
</code><code></FONT></I>
</code><code>                <B><FONT COLOR="#A020F0">switch</FONT></B>(RxdBuffer[2])
</code><code>                {
</code><code>                        <I><FONT COLOR="#B22222">// 't' comand placed here only for compatibility to BL
</code><code></FONT></I>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'t'</FONT></B>:<I><FONT COLOR="#B22222">// Motortest
</code><code></FONT></I>                                <B><FONT COLOR="#A020F0">if</FONT></B>(AnzahlEmpfangsBytes &gt; 20) memcpy(&amp;MotorTest[0], (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)pRxData, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(MotorTest));
</code><code>                                <B><FONT COLOR="#A020F0">else</FONT></B> memcpy(&amp;MotorTest[0], (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)pRxData, 4);
</code><code>                                        <B><FONT COLOR="#A020F0">while</FONT></B>(!UebertragungAbgeschlossen);
</code><code>                                        SendOutData(<B><FONT COLOR="#BC8F8F">'T'</FONT></B>, MeineSlaveAdresse, 0);
</code><code>                                        PC_MotortestActive = 250;
</code><code>                                        PcZugriff = 255;
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>                        <I><FONT COLOR="#B22222">// 'K' comand placed here only for compatibility to old MK3MAG software, that does not send the right Slave Address
</code><code></FONT></I>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'K'</FONT></B>:<I><FONT COLOR="#B22222">// Kompasswert
</code><code></FONT></I>                                        memcpy((<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)&amp;KompassValue , (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)pRxData, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(KompassValue));
</code><code>                                        KompassRichtung = ((540 + KompassValue - KompassStartwert) % 360) - 180;
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'a'</FONT></B>:<I><FONT COLOR="#B22222">// Texte der Analogwerte
</code><code></FONT></I>                                        DebugTextAnforderung = pRxData[0];
</code><code>                                        <B><FONT COLOR="#A020F0">if</FONT></B> (DebugTextAnforderung &gt; 31) DebugTextAnforderung = 31;
</code><code>                                        PcZugriff = 255;
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'b'</FONT></B>:
</code><code>                                        memcpy((<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)&amp;ExternControl, (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)pRxData, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(ExternControl));
</code><code>                                        ConfirmFrame = ExternControl.Frame;
</code><code>                                        PcZugriff = 255;
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'c'</FONT></B>: <I><FONT COLOR="#B22222">// Poll the 3D-Data
</code><code></FONT></I>                    <B><FONT COLOR="#A020F0">if</FONT></B>(!Intervall3D) { <B><FONT COLOR="#A020F0">if</FONT></B>(pRxData[0]) Timer3D = SetDelay(pRxData[0] * 10);}
</code><code>                                        Intervall3D = pRxData[0] * 10;
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'d'</FONT></B>: <I><FONT COLOR="#B22222">// Poll the debug data
</code><code></FONT></I>                                        DebugDataIntervall = pRxData[0] * 10;
</code><code>                                        <B><FONT COLOR="#A020F0">if</FONT></B>(DebugDataIntervall &gt; 0) DebugDataAnforderung = 1;
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'h'</FONT></B>:<I><FONT COLOR="#B22222">// x-1 Displayzeilen
</code><code></FONT></I>                                PcZugriff = 255;
</code><code>                                        RemoteKeys |= pRxData[0];
</code><code>                                        <B><FONT COLOR="#A020F0">if</FONT></B>(RemoteKeys) DisplayLine = 0;
</code><code>                                        DebugDisplayAnforderung = 1;
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'l'</FONT></B>:<I><FONT COLOR="#B22222">// x-1 Displayzeilen
</code><code></FONT></I>                                PcZugriff = 255;
</code><code>                                        MenuePunkt = pRxData[0];
</code><code>                                        DebugDisplayAnforderung1 = 1;
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'v'</FONT></B>: <I><FONT COLOR="#B22222">// Version-Anforderung und Ausbaustufe
</code><code></FONT></I>                                        GetVersionAnforderung = 1;
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>
</code><code>                        <B><FONT COLOR="#A020F0">case</FONT></B> <B><FONT COLOR="#BC8F8F">'g'</FONT></B>:<I><FONT COLOR="#B22222">//
</code><code></FONT></I>                                        GetExternalControl = 1;
</code><code>                                        <B><FONT COLOR="#A020F0">break</FONT></B>;
</code><code>                }
</code><code>                <B><FONT COLOR="#A020F0">break</FONT></B>; <I><FONT COLOR="#B22222">// default:
</code><code></FONT></I>        }
</code><code>        NeuerDatensatzEmpfangen = 0;
</code><code>        pRxData = 0;
</code><code>        RxDataLen = 0;
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I><I><FONT COLOR="#B22222">//Routine fr die Serielle Ausgabe
</code><code></FONT></I><B><FONT COLOR="#228B22">int</FONT></B> <B><FONT COLOR="#0000FF">uart_putchar</FONT></B> (<B><FONT COLOR="#228B22">char</FONT></B> c)
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I>{
</code><code>        <B><FONT COLOR="#A020F0">if</FONT></B> (c == <B><FONT COLOR="#BC8F8F">'\n'</FONT></B>)
</code><code>                uart_putchar(<B><FONT COLOR="#BC8F8F">'\r'</FONT></B>);
</code><code>        <I><FONT COLOR="#B22222">//Warten solange bis Zeichen gesendet wurde
</code><code></FONT></I>        loop_until_bit_is_set(USR, UDRE);
</code><code>        <I><FONT COLOR="#B22222">//Ausgabe des Zeichens
</code><code></FONT></I>        UDR = c;
</code><code>
</code><code>        <B><FONT COLOR="#A020F0">return</FONT></B> (0);
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">// --------------------------------------------------------------------------
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">WriteProgramData</FONT></B>(<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">int</FONT></B> pos, <B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> wert)
</code><code>{
</code><code>  <I><FONT COLOR="#B22222">//if (ProgramLocation == IN_RAM) Buffer[pos] = wert;
</code><code></FONT></I>  <I><FONT COLOR="#B22222">// else eeprom_write_byte(&amp;EE_Buffer[pos], wert);
</code><code></FONT></I>  <I><FONT COLOR="#B22222">// Buffer[pos] = wert;
</code><code></FONT></I>}
</code><code>
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I><I><FONT COLOR="#B22222">//INstallation der Seriellen Schnittstelle
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">UART_Init</FONT></B> (<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code><I><FONT COLOR="#B22222">//############################################################################
</code><code></FONT></I>{
</code><code>        <I><FONT COLOR="#B22222">//Enable TXEN im Register UCR TX-Data Enable &amp; RX Enable
</code><code></FONT></I>
</code><code>        UCR=(1 &lt;&lt; TXEN) | (1 &lt;&lt; RXEN);
</code><code>    <I><FONT COLOR="#B22222">// UART Double Speed (U2X)
</code><code></FONT></I>        USR   |= (1&lt;&lt;U2X);
</code><code>        <I><FONT COLOR="#B22222">// RX-Interrupt Freigabe
</code><code></FONT></I>        UCSRB |= (1&lt;&lt;RXCIE);
</code><code>        <I><FONT COLOR="#B22222">// TX-Interrupt Freigabe
</code><code></FONT></I>        UCSRB |= (1&lt;&lt;TXCIE);
</code><code>
</code><code>        <I><FONT COLOR="#B22222">//Teiler wird gesetzt
</code><code></FONT></I>        UBRR=(SYSCLK / (BAUD_RATE * 8L) - 1);
</code><code>        <I><FONT COLOR="#B22222">//UBRR = 33;
</code><code></FONT></I>        <I><FONT COLOR="#B22222">//ffnet einen Kanal fr printf (STDOUT)
</code><code></FONT></I>        <I><FONT COLOR="#B22222">//fdevopen (uart_putchar, 0);
</code><code></FONT></I>        <I><FONT COLOR="#B22222">//sbi(PORTD,4);
</code><code></FONT></I>        Debug_Timer = SetDelay(DebugDataIntervall);
</code><code>        Kompass_Timer = SetDelay(220);
</code><code>
</code><code>        VersionInfo.SWMajor = VERSION_MAJOR;
</code><code>        VersionInfo.SWMinor = VERSION_MINOR;
</code><code>        VersionInfo.SWPatch = VERSION_PATCH;
</code><code>        VersionInfo.ProtoMajor  = VERSION_SERIAL_MAJOR;
</code><code>        VersionInfo.ProtoMinor  = VERSION_SERIAL_MINOR;
</code><code>
</code><code>        pRxData = 0;
</code><code>        RxDataLen = 0;
</code><code>}
</code><code>
</code><code><I><FONT COLOR="#B22222">//---------------------------------------------------------------------------------------------
</code><code></FONT></I><B><FONT COLOR="#228B22">void</FONT></B> <B><FONT COLOR="#0000FF">DatenUebertragung</FONT></B>(<B><FONT COLOR="#228B22">void</FONT></B>)
</code><code>{
</code><code> <B><FONT COLOR="#A020F0">if</FONT></B>(!UebertragungAbgeschlossen) <B><FONT COLOR="#A020F0">return</FONT></B>;
</code><code>
</code><code>        <B><FONT COLOR="#A020F0">if</FONT></B>(DebugDisplayAnforderung &amp;&amp; UebertragungAbgeschlossen)
</code><code>        {
</code><code>                Menu();
</code><code>                SendOutData(<B><FONT COLOR="#BC8F8F">'H'</FONT></B>, FC_ADDRESS, 2, &amp;DisplayLine, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(DisplayLine), &amp;DisplayBuff[DisplayLine * 20], 20);
</code><code>                DisplayLine++;
</code><code>                <B><FONT COLOR="#A020F0">if</FONT></B>(DisplayLine &gt;= 4) DisplayLine = 0;
</code><code>                DebugDisplayAnforderung = 0;
</code><code>        }
</code><code>        <B><FONT COLOR="#A020F0">if</FONT></B>(DebugDisplayAnforderung1 &amp;&amp; UebertragungAbgeschlossen)
</code><code>        {
</code><code>                Menu();
</code><code>                SendOutData(<B><FONT COLOR="#BC8F8F">'L'</FONT></B>, FC_ADDRESS, 3, &amp;MenuePunkt, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(MenuePunkt), &amp;MaxMenue, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(MaxMenue), DisplayBuff, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(DisplayBuff));
</code><code>                DebugDisplayAnforderung1 = 0;
</code><code>        }
</code><code>        <B><FONT COLOR="#A020F0">if</FONT></B>(GetVersionAnforderung &amp;&amp; UebertragungAbgeschlossen)
</code><code>        {
</code><code>                SendOutData(<B><FONT COLOR="#BC8F8F">'V'</FONT></B>, FC_ADDRESS, 1, (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) &amp;VersionInfo, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(VersionInfo));
</code><code>                GetVersionAnforderung = 0;
</code><code>        }
</code><code>
</code><code>        <B><FONT COLOR="#A020F0">if</FONT></B>(GetExternalControl &amp;&amp; UebertragungAbgeschlossen)           <I><FONT COLOR="#B22222">// Bei Get werden die vom PC einstellbaren Werte vom PC zurckgelesen
</code><code></FONT></I>        {
</code><code>                SendOutData(<B><FONT COLOR="#BC8F8F">'G'</FONT></B>,MeineSlaveAdresse, 1, (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) &amp;ExternControl, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(ExternControl));
</code><code>                GetExternalControl = 0;
</code><code>        }
</code><code>    <B><FONT COLOR="#A020F0">if</FONT></B>((CheckDelay(Kompass_Timer)) &amp;&amp; UebertragungAbgeschlossen)
</code><code>         {
</code><code>                  WinkelOut.Winkel[0] = (<B><FONT COLOR="#228B22">int</FONT></B>) (IntegralNick / (EE_Parameter.GyroAccFaktor * 4));  <I><FONT COLOR="#B22222">// etwa in 0.1 Grad
</code><code></FONT></I>                  WinkelOut.Winkel[1] = (<B><FONT COLOR="#228B22">int</FONT></B>) (IntegralRoll / (EE_Parameter.GyroAccFaktor * 4));  <I><FONT COLOR="#B22222">// etwa in 0.1 Grad
</code><code></FONT></I>                  WinkelOut.UserParameter[0] = Parameter_UserParam1;
</code><code>                  WinkelOut.UserParameter[1] = Parameter_UserParam2;
</code><code>          SendOutData(<B><FONT COLOR="#BC8F8F">'w'</FONT></B>, MK3MAG_ADDRESS, 1, (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) &amp;WinkelOut,<B><FONT COLOR="#A020F0">sizeof</FONT></B>(WinkelOut));
</code><code>          <B><FONT COLOR="#A020F0">if</FONT></B>(WinkelOut.CalcState &gt; 4)  WinkelOut.CalcState = 6; <I><FONT COLOR="#B22222">// wird dann in SPI auf Null gesetzt
</code><code></FONT></I>          Kompass_Timer = SetDelay(99);
</code><code>         }
</code><code>    <B><FONT COLOR="#A020F0">if</FONT></B>(((DebugDataIntervall&gt;0 &amp;&amp; CheckDelay(Debug_Timer)) || DebugDataAnforderung) &amp;&amp; UebertragungAbgeschlossen)
</code><code>         {
</code><code>          SendOutData(<B><FONT COLOR="#BC8F8F">'D'</FONT></B>, FC_ADDRESS, 1, (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) &amp;DebugOut,<B><FONT COLOR="#A020F0">sizeof</FONT></B>(DebugOut));
</code><code>          DebugDataAnforderung = 0;
</code><code>          <B><FONT COLOR="#A020F0">if</FONT></B>(DebugDataIntervall&gt;0) Debug_Timer = SetDelay(DebugDataIntervall);
</code><code>         }
</code><code>    <B><FONT COLOR="#A020F0">if</FONT></B>(Intervall3D &gt; 0 &amp;&amp; CheckDelay(Timer3D) &amp;&amp; UebertragungAbgeschlossen)
</code><code>         {
</code><code>                  Data3D.Winkel[0] = (<B><FONT COLOR="#228B22">int</FONT></B>) (IntegralNick / (EE_Parameter.GyroAccFaktor * 4));  <I><FONT COLOR="#B22222">// etwa in 0.1 Grad
</code><code></FONT></I>                  Data3D.Winkel[1] = (<B><FONT COLOR="#228B22">int</FONT></B>) (IntegralRoll / (EE_Parameter.GyroAccFaktor * 4));  <I><FONT COLOR="#B22222">// etwa in 0.1 Grad
</code><code></FONT></I>          Data3D.Winkel[2] = (<B><FONT COLOR="#228B22">int</FONT></B>) ((10 * ErsatzKompass) / GIER_GRAD_FAKTOR);
</code><code>          SendOutData(<B><FONT COLOR="#BC8F8F">'C'</FONT></B>, FC_ADDRESS, 1, (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) &amp;Data3D,<B><FONT COLOR="#A020F0">sizeof</FONT></B>(Data3D));
</code><code>          Timer3D = SetDelay(Intervall3D);
</code><code>         }
</code><code>    <B><FONT COLOR="#A020F0">if</FONT></B>(DebugTextAnforderung != 255) <I><FONT COLOR="#B22222">// Texte fr die Analogdaten
</code><code></FONT></I>     {
</code><code>      SendOutData(<B><FONT COLOR="#BC8F8F">'A'</FONT></B>, FC_ADDRESS, 2, (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *)&amp;DebugTextAnforderung, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(DebugTextAnforderung),(<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) ANALOG_TEXT[DebugTextAnforderung], 16);
</code><code>      DebugTextAnforderung = 255;
</code><code>         }
</code><code>     <B><FONT COLOR="#A020F0">if</FONT></B>(ConfirmFrame &amp;&amp; UebertragungAbgeschlossen)   <I><FONT COLOR="#B22222">// Datensatz besttigen
</code><code></FONT></I>         {
</code><code>                SendOutData(<B><FONT COLOR="#BC8F8F">'B'</FONT></B>, FC_ADDRESS, 1, (uint8_t*)&amp;ConfirmFrame, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(ConfirmFrame));
</code><code>        ConfirmFrame = 0;
</code><code>     }
</code><code>
</code><code>     <B><FONT COLOR="#A020F0">if</FONT></B>(GetPPMChannelAnforderung &amp;&amp; UebertragungAbgeschlossen)
</code><code>     {
</code><code>                 SendOutData(<B><FONT COLOR="#BC8F8F">'P'</FONT></B>, FC_ADDRESS, 1, (<B><FONT COLOR="#228B22">unsigned</FONT></B> <B><FONT COLOR="#228B22">char</FONT></B> *) &amp;PPM_in, <B><FONT COLOR="#A020F0">sizeof</FONT></B>(PPM_in));
</code><code>                 GetPPMChannelAnforderung = 0;
</code><code>         }
</code><code>
</code><code>}
</code><code>
</code><code></PRE>
</code><code></code>    </div>
<p>
<span class="diff"><a href="diff.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fuart.c&amp;rev=0&amp;sc=0">Compare with Previous</a></span> &#124;
<span class="diff"><a href="blame.php?repname=FlightCtrl&amp;path=%2Ftags%2FV0.74d%2Fuart.c&amp;rev=0&amp;sc=0">Blame</a></span>
</p>
  </div>
  <div id="footer">
    <p style="padding:0; margin:0"><small>powered by: <a href="http://websvn.tigris.org">WebSVN 2.0</a></small></p>
  </div>
</body>
</html>
